/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

var _typeof = require('./dep-a483aecf.js');
var eq = require('./dep-bf3c4644.js');
var isArrayLike = require('./dep-d5965f49.js');
var _isIndex = require('./dep-39cfa1e8.js');
var isObject = require('./dep-9aa61227.js');

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject.isObject(object)) {
    return false;
  }
  var type = _typeof._typeof(index);
  if (type == 'number' ? isArrayLike.isArrayLike(object) && _isIndex.isIndex(index, object.length) : type == 'string' && index in object) {
    return eq.eq(object[index], value);
  }
  return false;
}

exports.isIterateeCall = isIterateeCall;
//# sourceMappingURL=dep-831ea6d9.js.map
