/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var objectWithoutProperties = require('../_chunks/dep-d4a1910a.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var anchor_AnchorContext = require('./AnchorContext.js');
var anchor_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-a483aecf.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_util/noop.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["href", "title", "target", "children", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var AnchorItem = function AnchorItem(props) {
  var _useContext = React.useContext(anchor_AnchorContext.AnchorContext),
    onClick = _useContext.onClick,
    activeItem = _useContext.activeItem,
    registerItem = _useContext.registerItem,
    unregisterItem = _useContext.unregisterItem;
  var _useDefaultProps = hooks_useDefaultProps["default"](props, anchor_defaultProps.anchorItemDefaultProps),
    href = _useDefaultProps.href,
    title = _useDefaultProps.title,
    target = _useDefaultProps.target,
    children = _useDefaultProps.children,
    className = _useDefaultProps.className,
    rest = objectWithoutProperties._objectWithoutProperties(_useDefaultProps, _excluded);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var titleAttr = typeof title === "string" ? title : null;
  var handleClick = function handleClick(e) {
    onClick({
      title: titleAttr,
      href: href
    }, e);
  };
  React.useEffect(function () {
    registerItem(href);
    return function () {
      return unregisterItem(href);
    };
  }, [href, registerItem, unregisterItem]);
  return /* @__PURE__ */React__default["default"].createElement("div", _objectSpread(_objectSpread({}, rest), {}, {
    className: classNames__default["default"]("".concat(classPrefix, "-anchor__item"), defineProperty._defineProperty({}, "".concat(classPrefix, "-is-active"), activeItem === href), className)
  }), /* @__PURE__ */React__default["default"].createElement("a", {
    href: href,
    className: classNames__default["default"]("".concat(classPrefix, "-anchor__item-link")),
    title: titleAttr,
    target: target,
    onClick: function onClick(e) {
      return handleClick(e);
    }
  }, title), children);
};
AnchorItem.displayName = "AnchorItem";

exports["default"] = AnchorItem;
//# sourceMappingURL=AnchorItem.js.map
