/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var slicedToArray = require('../_chunks/dep-1135362e.js');
var objectWithoutProperties = require('../_chunks/dep-d4a1910a.js');
var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var breadcrumb_BreadcrumbContext = require('./BreadcrumbContext.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var breadcrumb_defaultProps = require('./defaultProps.js');
var tooltip_index = require('../tooltip/index.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var _util_scroll = require('../_util/scroll.js');
var isFunction = require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-2ebc1a75.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_chunks/dep-e13830e4.js');
require('../tooltip/Tooltip.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-7603c5b0.js');
require('../_chunks/dep-8ad5b41f.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-825271ec.js');
require('../hooks/useAnimation.js');
require('../common/Portal.js');
require('react-dom');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../hooks/useLayoutEffect.js');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c6c72aff.js');
require('../_chunks/dep-05e58abe.js');
require('../_chunks/dep-4a4a845f.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-888c17ef.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-4d46699b.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-e15a33e9.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../tooltip/defaultProps.js');
require('../tooltip/TooltipLite.js');
require('../hooks/useSwitch.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-b24245bf.js');
require('raf');
require('../_util/easing.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["children", "separator", "disabled", "maxItemWidth", "maxWidth", "icon", "href", "to", "target", "router", "replace", "className", "content", "onClick", "tooltipProps", "readOnly"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var BreadcrumbItem = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var commonClassNames = hooks_useCommonClassName["default"]();
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      ChevronRightIcon: tdesignIconsReact.ChevronRightIcon
    }),
    ChevronRightIcon = _useGlobalIcon.ChevronRightIcon;
  var _useDefaultProps = hooks_useDefaultProps["default"](props, breadcrumb_defaultProps.breadcrumbItemDefaultProps),
    children = _useDefaultProps.children,
    separator = _useDefaultProps.separator,
    disabled = _useDefaultProps.disabled,
    maxItemWidth = _useDefaultProps.maxItemWidth,
    maxWidth = _useDefaultProps.maxWidth,
    icon = _useDefaultProps.icon,
    href = _useDefaultProps.href,
    to = _useDefaultProps.to,
    target = _useDefaultProps.target,
    router = _useDefaultProps.router,
    replace = _useDefaultProps.replace,
    className = _useDefaultProps.className,
    content = _useDefaultProps.content,
    onClick = _useDefaultProps.onClick,
    tooltipProps = _useDefaultProps.tooltipProps,
    readonly = _useDefaultProps.readOnly,
    restProps = objectWithoutProperties._objectWithoutProperties(_useDefaultProps, _excluded);
  var _useContext = React.useContext(breadcrumb_BreadcrumbContext.BreadcrumbContext),
    maxItemWidthInContext = _useContext.maxItemWidthInContext,
    separatorInContext = _useContext.separator;
  var breadcrumbText = React.useRef(null);
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    isCutOff = _useState2[0],
    setIsCutOff = _useState2[1];
  var breadcrumbItemClassNames = classNames__default["default"]("".concat(classPrefix, "-breadcrumb__item"));
  var textWrapperClassName = "".concat(classPrefix, "-breadcrumb__inner");
  var textClassName = "".concat(classPrefix, "-breadcrumb__inner-text");
  var textClassNames = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-breadcrumb--text-overflow"), !readonly), commonClassNames.STATUS.disabled, disabled));
  var separatorClassName = "".concat(classPrefix, "-breadcrumb__separator");
  var linkClassName = "".concat(classPrefix, "-link");
  var maxWidthForItem = React.useMemo(function () {
    return {
      maxWidth: maxWidth || maxItemWidth || maxItemWidthInContext || "120px"
    };
  }, [maxItemWidth, maxWidth, maxItemWidthInContext]);
  React.useEffect(function () {
    if (!breadcrumbText.current) return;
    return setIsCutOff(_util_scroll.isNodeOverflow(breadcrumbText.current));
  }, [breadcrumbText]);
  var textContent = /* @__PURE__ */React__default["default"].createElement("span", {
    className: textWrapperClassName,
    style: maxWidthForItem
  }, isFunction.isFunction(icon) ? icon() : icon, /* @__PURE__ */React__default["default"].createElement("span", {
    ref: breadcrumbText,
    className: textClassName
  }, children || content));
  var itemContent = /* @__PURE__ */React__default["default"].createElement("span", {
    className: textClassNames
  }, textContent);
  if ((href || to) && !disabled) {
    var handleRouting = function handleRouting() {
      if (href || !router) return;
      replace ? router.replace(to) : router.push(to);
    };
    itemContent = /* @__PURE__ */React__default["default"].createElement("a", {
      className: classNames__default["default"](textClassNames, linkClassName),
      href: href,
      target: target,
      onClick: handleRouting
    }, textContent);
  }
  var separatorInProps = _util_parseTNode["default"](separator);
  var separatorContent = separatorInProps || separatorInContext || /* @__PURE__ */React__default["default"].createElement(ChevronRightIcon, {
    style: {
      opacity: ".5"
    }
  });
  var handleClick = function handleClick(e) {
    if (disabled) return;
    onClick === null || onClick === void 0 || onClick(e);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", _objectSpread({
    className: classNames__default["default"](breadcrumbItemClassNames, className),
    ref: ref,
    onClick: handleClick
  }, restProps), isCutOff ? /* @__PURE__ */React__default["default"].createElement(tooltip_index.TooltipLite, _objectSpread({
    content: children || content
  }, tooltipProps), itemContent) : itemContent, /* @__PURE__ */React__default["default"].createElement("span", {
    className: separatorClassName
  }, separatorContent));
});
BreadcrumbItem.displayName = "BreadcrumbItem";

exports["default"] = BreadcrumbItem;
//# sourceMappingURL=BreadcrumbItem.js.map
