/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var React = require('react');
var classNames = require('classnames');
var loading_index = require('../loading/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var card_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-a483aecf.js');
require('../loading/Loading.js');
require('../_chunks/dep-1135362e.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-0d2e37a8.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-0030e873.js');
require('../_chunks/dep-5aec375e.js');
require('../_chunks/dep-4d46699b.js');
require('../_chunks/dep-c02b300c.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-e15a33e9.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Card = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useDefaultProps = hooks_useDefaultProps["default"](props, card_defaultProps.cardDefaultProps),
    actions = _useDefaultProps.actions,
    avatar = _useDefaultProps.avatar,
    bordered = _useDefaultProps.bordered,
    children = _useDefaultProps.children,
    className = _useDefaultProps.className,
    cover = _useDefaultProps.cover,
    description = _useDefaultProps.description,
    footer = _useDefaultProps.footer,
    header = _useDefaultProps.header,
    headerBordered = _useDefaultProps.headerBordered,
    hoverShadow = _useDefaultProps.hoverShadow,
    loading = _useDefaultProps.loading,
    shadow = _useDefaultProps.shadow,
    size = _useDefaultProps.size,
    style = _useDefaultProps.style,
    subtitle = _useDefaultProps.subtitle,
    title = _useDefaultProps.title,
    theme = _useDefaultProps.theme,
    status = _useDefaultProps.status,
    loadingProps = _useDefaultProps.loadingProps;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var commonClassNames = hooks_useCommonClassName["default"]();
  var isPoster2 = theme === "poster2";
  var cardClass = classNames__default["default"]("".concat(classPrefix, "-card"), className, defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, commonClassNames.SIZE.small, size === "small"), "".concat(classPrefix, "-card--bordered"), bordered), "".concat(classPrefix, "-card--shadow"), shadow), "".concat(classPrefix, "-card--shadow-hover"), hoverShadow));
  var showHeader = header || title || subtitle || description || avatar || actions && !isPoster2 || status && isPoster2;
  var headerClass = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-card__header"), showHeader), "".concat(classPrefix, "-card__title--bordered"), headerBordered));
  var titleClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__title"), title));
  var subtitleClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__subtitle"), subtitle));
  var actionClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__actions"), actions));
  var footerClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__footer"), footer));
  var coverClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__cover"), cover));
  var avatarClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__avatar"), avatar));
  var bodyClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__body"), children));
  var descriptionClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__description"), description));
  var renderTitle = title ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: titleClass
  }, title) : null;
  var renderSubtitle = subtitle ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: subtitleClass
  }, subtitle) : null;
  var renderDescription = description ? /* @__PURE__ */React__default["default"].createElement("p", {
    className: descriptionClass
  }, description) : null;
  var renderAvatar = avatar && /* @__PURE__ */React__default["default"].createElement("div", {
    className: avatarClass
  }, avatar);
  var renderHeaderActions = actions && !isPoster2 && /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionClass
  }, actions);
  var renderFooterActions = actions && isPoster2 && /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionClass
  }, actions);
  var renderStatus = status && isPoster2 && /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionClass
  }, status);
  var renderHeader = function renderHeader() {
    if (header) {
      return /* @__PURE__ */React__default["default"].createElement("div", {
        className: headerClass
      }, header);
    }
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: headerClass
    }, /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-card__header-wrapper")
    }, renderAvatar, /* @__PURE__ */React__default["default"].createElement("div", null, renderTitle, renderSubtitle, renderDescription)), renderHeaderActions, renderStatus);
  };
  var renderCover = cover ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: coverClass
  }, typeof cover === "string" ? /* @__PURE__ */React__default["default"].createElement("img", {
    src: cover,
    alt: ""
  }) : cover) : null;
  var renderChildren = children && /* @__PURE__ */React__default["default"].createElement("div", {
    className: bodyClass
  }, children);
  var renderFooter = footer && /* @__PURE__ */React__default["default"].createElement("div", {
    className: footerClass
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-card__footer-wrapper")
  }, footer), renderFooterActions);
  var card = /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, showHeader ? renderHeader() : null, renderCover, renderChildren, renderFooter);
  var childrenNode = null;
  if (!Reflect.has(props, "loading")) {
    childrenNode = card;
  } else if (/*#__PURE__*/React__default["default"].isValidElement(loading)) {
    childrenNode = /*#__PURE__*/React__default["default"].cloneElement(loading, null, card);
  } else {
    childrenNode = /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, _objectSpread(_objectSpread({}, loadingProps), {}, {
      loading: !!loading
    }), card);
  }
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: cardClass,
    style: style
  }, childrenNode);
});
Card.displayName = "Card";

exports["default"] = Card;
//# sourceMappingURL=Card.js.map
