/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var toConsumableArray = require('../_chunks/dep-4d46699b.js');
var slicedToArray = require('../_chunks/dep-1135362e.js');
var objectWithoutProperties = require('../_chunks/dep-d4a1910a.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var collapse_CollapsePanel = require('./CollapsePanel.js');
var collapse_CollapseContext = require('./CollapseContext.js');
var collapse_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-2ebc1a75.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('hoist-non-react-statics');
require('../_util/noop.js');
require('../_chunks/dep-7603c5b0.js');
require('../_chunks/dep-8ad5b41f.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-825271ec.js');
require('react-transition-group');
require('../common/FakeArrow.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["defaultExpandAll", "disabled", "expandIconPlacement", "expandOnRowClick", "expandIcon"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Collapse = _util_forwardRefWithStatics["default"](function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, collapse_defaultProps.collapseDefaultProps);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var componentName = "".concat(classPrefix, "-collapse");
  var borderlessClass = "".concat(classPrefix, "--border-less");
  var defaultExpandAll = props.defaultExpandAll,
    disabled = props.disabled,
    expandIconPlacement = props.expandIconPlacement,
    expandOnRowClick = props.expandOnRowClick,
    expandIcon = props.expandIcon,
    rest = objectWithoutProperties._objectWithoutProperties(props, _excluded);
  var children = rest.children,
    className = rest.className,
    style = rest.style,
    expandMutex = rest.expandMutex,
    borderless = rest.borderless,
    onChange = rest.onChange;
  var _useControlled = hooks_useControlled["default"](props, "value", onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    collapseValue = _useControlled2[0],
    setCollapseValue = _useControlled2[1];
  var collapseValues = React.useRef(collapseValue);
  React.useEffect(function () {
    collapseValues.current = collapseValue;
  }, [collapseValue]);
  var updateCollapseValue = function updateCollapseValue(value, context) {
    var newValue = [].concat(collapseValues.current || []);
    var index = newValue.indexOf(value);
    if (index >= 0) {
      newValue.splice(index, 1);
    } else if (expandMutex) {
      newValue = [value];
    } else {
      newValue.push(value);
    }
    collapseValues.current = toConsumableArray._toConsumableArray(newValue);
    setCollapseValue(newValue, context);
  };
  var classes = [componentName, defineProperty._defineProperty({}, borderlessClass, !!borderless), className];
  var childrenList = React__default["default"].Children.toArray(children).filter(function (child) {
    return child.type.displayName === collapse_CollapsePanel["default"].displayName;
  });
  var collapsePanelList = function collapsePanelList() {
    return childrenList.map(function (child, index) {
      var key = child.key || String(index);
      var childProps = _objectSpread({
        key: key,
        index: index + 1
      }, child.props);
      return /*#__PURE__*/React__default["default"].cloneElement(child, childProps);
    });
  };
  return /* @__PURE__ */React__default["default"].createElement(collapse_CollapseContext["default"].Provider, {
    value: {
      defaultExpandAll: defaultExpandAll,
      disabled: disabled,
      expandIconPlacement: expandIconPlacement,
      expandOnRowClick: expandOnRowClick,
      expandIcon: expandIcon,
      updateCollapseValue: updateCollapseValue,
      collapseValue: collapseValue
    }
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"](classes),
    style: style,
    ref: ref
  }, collapsePanelList()));
}, {
  Panel: collapse_CollapsePanel["default"]
});
Collapse.displayName = "Collapse";

exports["default"] = Collapse;
//# sourceMappingURL=Collapse.js.map
