/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../../_chunks/dep-1135362e.js');
var React = require('react');
var constants = require('../../../_chunks/dep-43cd25b9.js');
var radio_index = require('../../../radio/index.js');
var locale_LocalReceiver = require('../../../locale/LocalReceiver.js');
require('../../../_chunks/dep-2ebc1a75.js');
require('../../../_chunks/dep-61237f17.js');
require('../../../_chunks/dep-36f2c0c2.js');
require('../../../_chunks/dep-a483aecf.js');
require('../../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../../common/Check.js');
require('../../../_chunks/dep-d4a1910a.js');
require('classnames');
require('../../../_util/helper.js');
require('../../../_chunks/dep-7e8bb5cc.js');
require('../../../_chunks/dep-f9468320.js');
require('../../../_chunks/dep-4d53c647.js');
require('../../../_chunks/dep-24d4266a.js');
require('../../../_chunks/dep-825271ec.js');
require('../../../_chunks/dep-0d2e37a8.js');
require('../../../_chunks/dep-7603c5b0.js');
require('../../../_chunks/dep-8ad5b41f.js');
require('../../../_chunks/dep-bacf1f7c.js');
require('../../../hooks/useConfig.js');
require('../../../config-provider/ConfigContext.js');
require('../../../_chunks/dep-62452fcb.js');
require('../../../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../../../_chunks/dep-5a0b2388.js');
require('../../../_chunks/dep-c03abb8d.js');
require('../../../_chunks/dep-93691cd7.js');
require('../../../_chunks/dep-4422ab9c.js');
require('../../../_chunks/dep-d5965f49.js');
require('../../../_chunks/dep-cfd04a4b.js');
require('../../../_chunks/dep-9aa61227.js');
require('../../../_chunks/dep-f9fc748e.js');
require('../../../_chunks/dep-39cfa1e8.js');
require('../../../_chunks/dep-5a308fe8.js');
require('../../../_chunks/dep-ab975a03.js');
require('../../../_chunks/dep-bf3c4644.js');
require('../../../_chunks/dep-810d56ec.js');
require('../../../_chunks/dep-2f2e3172.js');
require('../../../_chunks/dep-e121d70e.js');
require('../../../_chunks/dep-bd0ab4be.js');
require('../../../_chunks/dep-0da99b78.js');
require('../../../_chunks/dep-4edddcbd.js');
require('../../../_chunks/dep-831ea6d9.js');
require('../../../hooks/useControlled.js');
require('../../../_util/noop.js');
require('../../../_chunks/dep-c4b07574.js');
require('../../../_chunks/dep-61f98c51.js');
require('../../../hooks/useCommonClassName.js');
require('../../../radio/defaultProps.js');
require('../../../hooks/useDefaultProps.js');
require('../../../radio/useKeyboard.js');
require('../../../_chunks/dep-a844b8f2.js');
require('../../../_util/listener.js');
require('../../../_chunks/dep-2e323406.js');
require('../../../_chunks/dep-c340510d.js');
require('../../../config-provider/ConfigProvider.js');
require('../../../_chunks/dep-bf0e5957.js');
require('../../../_chunks/dep-349377fd.js');
require('../../../_chunks/dep-9ee1931f.js');
require('../../../_chunks/dep-e57f7de9.js');
require('../../../_chunks/dep-d371704c.js');
require('../../../_chunks/dep-aca4abf9.js');
require('../../../_chunks/dep-a422f8bb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var Header = function Header(props) {
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("colorPicker"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var baseClassName = props.baseClassName,
    _props$mode = props.mode,
    mode = _props$mode === void 0 ? "monochrome" : _props$mode,
    colorModes = props.colorModes,
    onModeChange = props.onModeChange;
  var isSingleMode = (colorModes === null || colorModes === void 0 ? void 0 : colorModes.length) === 1;
  if (isSingleMode) {
    return null;
  }
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__head")
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__mode")
  }, /* @__PURE__ */React__default["default"].createElement(radio_index.Radio.Group, {
    variant: "default-filled",
    size: "small",
    value: mode,
    onChange: onModeChange
  }, Object.keys(constants.COLOR_MODES).map(function (key) {
    return /* @__PURE__ */React__default["default"].createElement(radio_index.Radio.Button, {
      key: key,
      value: key
    }, t(local[constants.COLOR_MODES[key]]));
  }))));
};
var PanelHeader = /*#__PURE__*/React__default["default"].memo(Header);

exports["default"] = PanelHeader;
//# sourceMappingURL=header.js.map
