/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var color = require('../../../_chunks/dep-d788e8cd.js');
var hooks_useGlobalIcon = require('../../../hooks/useGlobalIcon.js');
var hooks_useCommonClassName = require('../../../hooks/useCommonClassName.js');
require('../../../_chunks/dep-1135362e.js');
require('../../../_chunks/dep-2ebc1a75.js');
require('../../../_chunks/dep-ce434e16.js');
require('../../../_chunks/dep-36f2c0c2.js');
require('../../../_chunks/dep-a483aecf.js');
require('tinycolor2');
require('../../../_chunks/dep-43cd25b9.js');
require('../../../_chunks/dep-c340510d.js');
require('../../../_chunks/dep-4d53c647.js');
require('../../../_chunks/dep-24d4266a.js');
require('../../../_chunks/dep-0d2e37a8.js');
require('../../../_chunks/dep-1b417134.js');
require('../../../hooks/useConfig.js');
require('../../../config-provider/ConfigContext.js');
require('../../../_chunks/dep-62452fcb.js');
require('../../../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../../../_chunks/dep-5a0b2388.js');
require('../../../_chunks/dep-c03abb8d.js');
require('../../../_chunks/dep-93691cd7.js');
require('../../../_chunks/dep-4422ab9c.js');
require('../../../_chunks/dep-d5965f49.js');
require('../../../_chunks/dep-cfd04a4b.js');
require('../../../_chunks/dep-9aa61227.js');
require('../../../_chunks/dep-f9fc748e.js');
require('../../../_chunks/dep-39cfa1e8.js');
require('../../../_chunks/dep-5a308fe8.js');
require('../../../_chunks/dep-ab975a03.js');
require('../../../_chunks/dep-bf3c4644.js');
require('../../../_chunks/dep-810d56ec.js');
require('../../../_chunks/dep-2f2e3172.js');
require('../../../_chunks/dep-e121d70e.js');
require('../../../_chunks/dep-bd0ab4be.js');
require('../../../_chunks/dep-0da99b78.js');
require('../../../_chunks/dep-4edddcbd.js');
require('../../../_chunks/dep-831ea6d9.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var Swatches = function Swatches(props) {
  var baseClassName = props.baseClassName,
    _props$colors = props.colors,
    colors = _props$colors === void 0 ? [] : _props$colors,
    _props$editable = props.editable,
    editable = _props$editable === void 0 ? false : _props$editable,
    title = props.title,
    onChange = props.onChange,
    disabled = props.disabled,
    onSetColor = props.onSetColor,
    handleAddColor = props.handleAddColor;
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      DeleteIcon: tdesignIconsReact.DeleteIcon,
      AddIcon: tdesignIconsReact.AddIcon
    }),
    DeleteIcon = _useGlobalIcon.DeleteIcon,
    AddIcon = _useGlobalIcon.AddIcon;
  var swatchesClass = "".concat(baseClassName, "__swatches");
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    statusClassNames = _useCommonClassName.STATUS;
  var isEqualCurrentColor = function isEqualCurrentColor(color$1) {
    return color.Color.compare(color$1, props.color.css);
  };
  var selectedColorIndex = function selectedColorIndex() {
    return colors.findIndex(function (color) {
      return isEqualCurrentColor(color);
    });
  };
  var handleRemoveColor = function handleRemoveColor() {
    var selectedIndex = selectedColorIndex();
    if (selectedIndex > -1) {
      var newColors = colors.filter(function (item, index) {
        return index !== selectedIndex;
      });
      onChange(newColors);
    }
  };
  var handleClick = function handleClick(color) {
    return onSetColor(color);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: swatchesClass
  }, title ? /* @__PURE__ */React__default["default"].createElement("h3", {
    className: "".concat(swatchesClass, "--title")
  }, /* @__PURE__ */React__default["default"].createElement("span", null, title), editable && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(swatchesClass, "--actions")
  }, /* @__PURE__ */React__default["default"].createElement("span", {
    role: "button",
    className: "".concat(baseClassName, "__icon"),
    onClick: function onClick() {
      return handleAddColor();
    }
  }, /* @__PURE__ */React__default["default"].createElement(AddIcon, null)), colors.length > 0 ? /* @__PURE__ */React__default["default"].createElement("span", {
    role: "button",
    className: "".concat(baseClassName, "__icon"),
    onClick: function onClick() {
      return handleRemoveColor();
    }
  }, /* @__PURE__ */React__default["default"].createElement(DeleteIcon, null)) : null)) : /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(swatchesClass, "--items"), "narrow-scrollbar")
  }, colors.map(function (color) {
    return /* @__PURE__ */React__default["default"].createElement("li", {
      className: classNames__default["default"]("".concat(swatchesClass, "--item"), isEqualCurrentColor(color) && editable ? statusClassNames.active : ""),
      key: color,
      onClick: function onClick() {
        if (disabled) {
          return;
        }
        handleClick(color);
      }
    }, /* @__PURE__ */React__default["default"].createElement("div", {
      className: classNames__default["default"]("".concat(swatchesClass, "--item__color"), "".concat(baseClassName, "--bg-alpha"))
    }, /* @__PURE__ */React__default["default"].createElement("span", {
      className: "".concat(swatchesClass, "--item__inner"),
      style: {
        background: color
      }
    })));
  })));
};
var SwatchesPanel = /*#__PURE__*/React__default["default"].memo(Swatches);

exports["default"] = SwatchesPanel;
//# sourceMappingURL=swatches.js.map
