/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-1135362e.js');
var React = require('react');
var format = require('../../_chunks/dep-87b282c3.js');
var log = require('../../_chunks/dep-e13830e4.js');
var hooks_useControlled = require('../../hooks/useControlled.js');
require('../../_chunks/dep-2ebc1a75.js');
require('dayjs');
require('../../_chunks/dep-6a2c14e7.js');
require('../../_chunks/dep-c340510d.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_util/noop.js');
require('../../_chunks/dep-7603c5b0.js');
require('../../_chunks/dep-8ad5b41f.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-825271ec.js');

function useSingleValue(props) {
  var _useControlled = hooks_useControlled["default"](props, "value", props.onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    value = _useControlled2[0],
    onChange = _useControlled2[1];
  var _getDefaultFormat = format.getDefaultFormat({
      mode: props.mode,
      format: props.format,
      enableTimePicker: props.multiple ? false : props.enableTimePicker
    }),
    format$1 = _getDefaultFormat.format,
    timeFormat = _getDefaultFormat.timeFormat;
  if (props.enableTimePicker) {
    if (!format.extractTimeFormat(format$1)) log.log.error("DatePicker", "format: ".concat(format$1, " is invalid\uFF0Ctime selection must include time formatting HH:mm:ss"));
  }
  var _useState = React.useState(function () {
      return format.formatTime(props.multiple ? value === null || value === void 0 ? void 0 : value[0] : value, format$1, timeFormat, props.defaultTime);
    }),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    time = _useState2[0],
    setTime = _useState2[1];
  var _useState3 = React.useState(function () {
      return format.parseToDayjs(props.multiple ? value === null || value === void 0 ? void 0 : value[0] : value, format$1).month();
    }),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    month = _useState4[0],
    setMonth = _useState4[1];
  var _useState5 = React.useState(function () {
      return format.parseToDayjs(props.multiple ? value === null || value === void 0 ? void 0 : value[0] : value, format$1).year();
    }),
    _useState6 = slicedToArray._slicedToArray(_useState5, 2),
    year = _useState6[0],
    setYear = _useState6[1];
  var _useState7 = React.useState(function () {
      return format.formatDate(props.multiple ? value === null || value === void 0 ? void 0 : value[0] : value, {
        format: format$1
      });
    }),
    _useState8 = slicedToArray._slicedToArray(_useState7, 2),
    cacheValue = _useState8[0],
    setCacheValue = _useState8[1];
  React.useEffect(function () {
    if (!value) {
      setCacheValue("");
      return;
    }
    if (!format.isValidDate(value, format$1)) return;
    setCacheValue(format.formatDate(value, {
      format: format$1
    }));
    setTime(format.formatTime(value, format$1, timeFormat, props.defaultTime));
  }, [value]);
  return {
    year: year,
    month: month,
    value: value,
    time: time,
    cacheValue: cacheValue,
    onChange: onChange,
    setYear: setYear,
    setMonth: setMonth,
    setTime: setTime,
    setCacheValue: setCacheValue
  };
}

exports["default"] = useSingleValue;
//# sourceMappingURL=useSingleValue.js.map
