/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-36f2c0c2.js');
var React = require('react');
var classNames = require('classnames');
var format = require('../../_chunks/dep-87b282c3.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var datePicker_panel_PanelContent = require('./PanelContent.js');
var datePicker_panel_ExtraContent = require('./ExtraContent.js');
var datePicker_hooks_useTableData = require('../hooks/useTableData.js');
var datePicker_hooks_useDisableDate = require('../hooks/useDisableDate.js');
var hooks_useDefaultProps = require('../../hooks/useDefaultProps.js');
var datePicker_utils = require('../utils.js');
var isFunction = require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-a483aecf.js');
require('dayjs');
require('../../_chunks/dep-6a2c14e7.js');
require('../../_chunks/dep-e13830e4.js');
require('../../_chunks/dep-c340510d.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-62452fcb.js');
require('../../_chunks/dep-5a0b2388.js');
require('../../_chunks/dep-c03abb8d.js');
require('../../_chunks/dep-93691cd7.js');
require('../../_chunks/dep-4422ab9c.js');
require('../../_chunks/dep-d5965f49.js');
require('../../_chunks/dep-f9fc748e.js');
require('../../_chunks/dep-39cfa1e8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-810d56ec.js');
require('../../_chunks/dep-2f2e3172.js');
require('../../_chunks/dep-e121d70e.js');
require('../../_chunks/dep-bd0ab4be.js');
require('../../_chunks/dep-0da99b78.js');
require('../../_chunks/dep-4edddcbd.js');
require('../../_chunks/dep-831ea6d9.js');
require('../base/Header.js');
require('../../_chunks/dep-4d46699b.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-1135362e.js');
require('../../locale/LocalReceiver.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-bf0e5957.js');
require('../../_chunks/dep-349377fd.js');
require('../../_chunks/dep-9ee1931f.js');
require('../../_chunks/dep-e57f7de9.js');
require('../../_chunks/dep-d371704c.js');
require('../../_chunks/dep-aca4abf9.js');
require('../../_chunks/dep-a422f8bb.js');
require('../../select/index.js');
require('../../select/base/Select.js');
require('../../_chunks/dep-d4a1910a.js');
require('../../_util/helper.js');
require('../../_chunks/dep-7e8bb5cc.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-7603c5b0.js');
require('../../_chunks/dep-8ad5b41f.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../select/util/helper.js');
require('../../select/base/OptionGroup.js');
require('../../select/defaultProps.js');
require('../../select/base/Option.js');
require('../../hooks/useDomRefCallback.js');
require('../../hooks/useRipple.js');
require('../../_chunks/dep-0030e873.js');
require('../../hooks/useAnimation.js');
require('../../_chunks/dep-2e323406.js');
require('../../_chunks/dep-c02b300c.js');
require('../../_chunks/dep-f3ba9c81.js');
require('../../_chunks/dep-8bc1cdb3.js');
require('../../common/FakeArrow.js');
require('../../loading/index.js');
require('../../loading/Loading.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-5aec375e.js');
require('../../loading/defaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-e15a33e9.js');
require('../../common/PluginContainer.js');
require('../../select-input/index.js');
require('../../select-input/SelectInput.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('react-transition-group');
require('../../popup/hooks/useTrigger.js');
require('react-is');
require('../../_util/ref.js');
require('../../_util/isFragment.js');
require('../../_util/composeRefs.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../hooks/useMutationObserver.js');
require('../../hooks/useLatest.js');
require('../../_chunks/dep-c6c72aff.js');
require('../../_chunks/dep-05e58abe.js');
require('../../_chunks/dep-4a4a845f.js');
require('../../_chunks/dep-b6a887a7.js');
require('../../_chunks/dep-888c17ef.js');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../hooks/useAttach.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../popup/PopupPlugin.js');
require('../../select-input/useSingle.js');
require('../../input/index.js');
require('../../input/Input.js');
require('tdesign-icons-react');
require('../../hooks/useGlobalIcon.js');
require('../../input/InputGroup.js');
require('../../input/defaultProps.js');
require('../../_util/parseTNode.js');
require('../../input/useLengthLimit.js');
require('../../_chunks/dep-99057d6c.js');
require('../../_chunks/dep-08c2f3c4.js');
require('../../_chunks/dep-199b9155.js');
require('../../_chunks/dep-e3718be1.js');
require('../../_chunks/dep-fc852541.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/TagInput.js');
require('../../hooks/useDragSorter.js');
require('../../hooks/useEventCallback.js');
require('../../tag-input/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag/index.js');
require('../../tag/Tag.js');
require('tinycolor2');
require('../../tag/defaultProps.js');
require('../../tag/CheckTag.js');
require('../../_chunks/dep-a844b8f2.js');
require('../../tag/CheckTagGroup.js');
require('../../tag-input/useHover.js');
require('../../tag-input/defaultProps.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../select-input/defaultProps.js');
require('../../select/base/PopupContent.js');
require('../../select/hooks/usePanelVirtualScroll.js');
require('../../hooks/useVirtualScroll.js');
require('../../hooks/useResizeObserver.js');
require('../../select/hooks/useOptions.js');
require('../../pagination/index.js');
require('../../pagination/Pagination.js');
require('../../input-number/index.js');
require('../../input-number/InputNumber.js');
require('../../button/index.js');
require('../../button/Button.js');
require('../../button/defaultProps.js');
require('../../input-number/useInputNumber.js');
require('../../_chunks/dep-d2f9d8ad.js');
require('../../_chunks/dep-fccfa508.js');
require('../../hooks/useCommonClassName.js');
require('../../input-number/defaultProps.js');
require('../../input-adornment/InputAdornment.js');
require('../../pagination/hooks/useBoundaryJumper.js');
require('../../pagination/hooks/usePrevNextJumper.js');
require('../../pagination/hooks/usePageNumber.js');
require('../../pagination/hooks/useTotal.js');
require('../../pagination/validators.js');
require('../../pagination/defaultProps.js');
require('../../_chunks/dep-24a443af.js');
require('../../_chunks/dep-dd40281a.js');
require('../../pagination/PaginationMini.js');
require('../base/Table.js');
require('../base/Cell.js');
require('../../_chunks/dep-72276c68.js');
require('../../_chunks/dep-3d623476.js');
require('../../time-picker/index.js');
require('../../time-picker/TimePicker.js');
require('../../_chunks/dep-500fdc96.js');
require('../../time-picker/hooks/useTimePickerTextConfig.js');
require('../../hooks/useDebounce.js');
require('../../hooks/usePersistFn.js');
require('../../hooks/usePropsRef.js');
require('../../time-picker/TimeRangePicker.js');
require('../../range-input/index.js');
require('../../range-input/RangeInput.js');
require('../../range-input/defaultProps.js');
require('../../range-input/RangeInputPopup.js');
require('../../time-picker/panel/TimePickerPanel.js');
require('../../time-picker/defaultProps.js');
require('../base/Footer.js');
require('../../_chunks/dep-a3296643.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var SinglePanel = /*#__PURE__*/React.forwardRef(function (originalProps, ref) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix,
    globalDatePickerConfig = _useConfig.datePicker;
  var panelName = "".concat(classPrefix, "-date-picker__panel");
  var props = hooks_useDefaultProps["default"](originalProps, {
    mode: "date",
    enableTimePicker: false,
    presetsPlacement: "bottom"
  });
  var value = props.value,
    mode = props.mode,
    presetsPlacement = props.presetsPlacement,
    _props$firstDayOfWeek = props.firstDayOfWeek,
    firstDayOfWeek = _props$firstDayOfWeek === void 0 ? globalDatePickerConfig.firstDayOfWeek : _props$firstDayOfWeek,
    needConfirm = props.needConfirm,
    style = props.style,
    className = props.className,
    year = props.year,
    month = props.month,
    onPanelClick = props.onPanelClick,
    disableTime = props.disableTime;
  var _getDefaultFormat = format.getDefaultFormat({
      mode: props.mode,
      format: props.format,
      enableTimePicker: props.enableTimePicker
    }),
    format$1 = _getDefaultFormat.format;
  var disableDateOptions = datePicker_hooks_useDisableDate["default"]({
    disableDate: props.disableDate,
    mode: props.mode,
    format: format$1
  });
  var disableTimeOptions = function disableTimeOptions(h, m, s, ms) {
    if (!isFunction.isFunction(disableTime) || !value) {
      return {};
    }
    return disableTime(datePicker_utils.parseToDateTime(value, format$1, [h, m, s, ms]));
  };
  var tableData = datePicker_hooks_useTableData["default"](_objectSpread({
    value: value,
    year: year,
    month: month,
    mode: mode,
    start: value ? format.parseToDayjs(props.multiple ? value[0] : value, format$1).toDate() : void 0,
    firstDayOfWeek: firstDayOfWeek,
    multiple: props.multiple
  }, disableDateOptions));
  var panelContentProps = {
    mode: mode,
    value: value,
    year: year,
    month: month,
    format: format$1,
    firstDayOfWeek: firstDayOfWeek,
    tableData: tableData,
    popupVisible: props.popupVisible,
    multiple: props.multiple,
    time: props.time,
    timePickerProps: _objectSpread({
      disableTime: disableTimeOptions
    }, props.timePickerProps),
    enableTimePicker: props.enableTimePicker,
    onMonthChange: props.onMonthChange,
    onYearChange: props.onYearChange,
    onJumperClick: props.onJumperClick,
    onCellClick: props.onCellClick,
    onCellMouseEnter: props.onCellMouseEnter,
    onCellMouseLeave: props.onCellMouseLeave,
    onTimePickerChange: props.onTimePickerChange
  };
  var extraProps = {
    presets: props.presets,
    enableTimePicker: props.enableTimePicker,
    presetsPlacement: props.presetsPlacement,
    onPresetClick: props.onPresetClick,
    onConfirmClick: props.onConfirmClick,
    selectedValue: props.value,
    needConfirm: needConfirm
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    style: style,
    className: classNames__default["default"](panelName, className, defineProperty._defineProperty({}, "".concat(panelName, "--direction-row"), ["left", "right"].includes(presetsPlacement))),
    onClick: function onClick(e) {
      return onPanelClick === null || onPanelClick === void 0 ? void 0 : onPanelClick({
        e: e
      });
    }
  }, ["top", "left"].includes(presetsPlacement) ? /* @__PURE__ */React__default["default"].createElement(datePicker_panel_ExtraContent["default"], _objectSpread({}, extraProps)) : null, /* @__PURE__ */React__default["default"].createElement(datePicker_panel_PanelContent["default"], _objectSpread({}, panelContentProps)), ["bottom", "right"].includes(presetsPlacement) ? /* @__PURE__ */React__default["default"].createElement(datePicker_panel_ExtraContent["default"], _objectSpread({}, extraProps)) : null);
});
SinglePanel.displayName = "SinglePanel";

exports["default"] = SinglePanel;
//# sourceMappingURL=SinglePanel.js.map
