/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var getScrollbarWidth = require('../../_chunks/dep-dc961b6b.js');
var hooks_useLayoutEffect = require('../../hooks/useLayoutEffect.js');
require('../../_chunks/dep-5aec375e.js');
require('../../_chunks/dep-4d46699b.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-c02b300c.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_chunks/dep-2e323406.js');
require('../../_chunks/dep-c340510d.js');
require('../../_chunks/dep-24d4266a.js');

var key = 1;
function useDialogLockStyle(_ref) {
  var preventScrollThrough = _ref.preventScrollThrough,
    visible = _ref.visible,
    mode = _ref.mode,
    showInAttachedElement = _ref.showInAttachedElement;
  var lockStyleRef = React.useRef(null);
  var timerRef = React.useRef(null);
  var clearStyleFunc = React.useCallback(function () {
    clearTimeout(timerRef.current);
    timerRef.current = setTimeout(function () {
      var _lockStyleRef$current, _lockStyleRef$current2;
      (_lockStyleRef$current = lockStyleRef.current.parentNode) === null || _lockStyleRef$current === void 0 || (_lockStyleRef$current2 = _lockStyleRef$current.removeChild) === null || _lockStyleRef$current2 === void 0 || _lockStyleRef$current2.call(_lockStyleRef$current, lockStyleRef.current);
    }, 150);
  }, []);
  hooks_useLayoutEffect["default"](function () {
    if (typeof document === "undefined") return;
    if (!lockStyleRef.current) {
      lockStyleRef.current = document.createElement("style");
    }
    var hasScrollBar = document.documentElement.scrollHeight > document.documentElement.clientHeight;
    var scrollbarWidth = hasScrollBar ? getScrollbarWidth.getScrollbarWidth() : 0;
    lockStyleRef.current.dataset.id = "td_dialog_".concat(+new Date(), "_").concat(key += 1);
    lockStyleRef.current.innerHTML = "\n      html body {\n        overflow-y: hidden;\n        width: calc(100% - ".concat(scrollbarWidth, "px);\n      }\n    ");
    return clearStyleFunc;
  }, [clearStyleFunc]);
  hooks_useLayoutEffect["default"](function () {
    if (typeof document === "undefined") return;
    if (mode !== "modal" || !preventScrollThrough || showInAttachedElement) return;
    if (visible) {
      document.head.appendChild(lockStyleRef.current);
    } else {
      clearStyleFunc();
    }
  }, [preventScrollThrough, visible, mode, showInAttachedElement, clearStyleFunc]);
}

exports["default"] = useDialogLockStyle;
//# sourceMappingURL=useLockStyle.js.map
