/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var React = require('react');
var log = require('../_chunks/dep-e13830e4.js');
var _util_reactRender = require('../_util/react-render.js');
var drawer_Drawer = require('./Drawer.js');
var _util_style = require('../_chunks/dep-2e323406.js');
var configProvider_ConfigProvider = require('../config-provider/ConfigProvider.js');
require('../config-provider/ConfigContext.js');
var common_PluginContainer = require('../common/PluginContainer.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-e15a33e9.js');
require('react-dom');
require('../_chunks/dep-1135362e.js');
require('../_chunks/dep-2ebc1a75.js');
require('classnames');
require('react-transition-group');
require('tdesign-icons-react');
require('../locale/LocalReceiver.js');
require('../button/index.js');
require('../button/Button.js');
require('../_chunks/dep-d4a1910a.js');
require('../hooks/useConfig.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-0030e873.js');
require('../hooks/useAnimation.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../common/Portal.js');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-5aec375e.js');
require('../_chunks/dep-4d46699b.js');
require('../_chunks/dep-c02b300c.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../loading/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../_chunks/dep-c340510d.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../loading/plugin.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../button/defaultProps.js');
require('../_util/parseTNode.js');
require('../hooks/useGlobalIcon.js');
require('./defaultProps.js');
require('./hooks/useDrag.js');
require('./hooks/useLockStyle.js');
require('../_chunks/dep-dc961b6b.js');
require('../_util/scroll.js');
require('raf');
require('../_util/easing.js');
require('../hooks/useAttach.js');
require('../hooks/useSetState.js');
require('../_chunks/dep-fccfa508.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var createDrawer = function createDrawer(props) {
  var drawerRef = /*#__PURE__*/React__default["default"].createRef();
  var _props$visible = props.visible,
    visible = _props$visible === void 0 ? false : _props$visible;
  var fragment = document.createDocumentFragment();
  var dGlobalConfig = configProvider_ConfigProvider["default"].getGlobalConfig();
  _util_reactRender.render(/* @__PURE__ */React__default["default"].createElement(common_PluginContainer["default"], {
    globalConfig: dGlobalConfig
  }, /* @__PURE__ */React__default["default"].createElement(drawer_Drawer["default"], _objectSpread(_objectSpread({}, props), {}, {
    visible: visible,
    ref: drawerRef,
    isPlugin: true
  }))), fragment);
  var container = _util_style.getAttach(props.attach);
  if (container) {
    requestAnimationFrame(function () {
      var _drawerRef$current;
      (_drawerRef$current = drawerRef.current) === null || _drawerRef$current === void 0 || _drawerRef$current.show();
    });
    container.appendChild(fragment);
  } else {
    log.log.error("Drawer", "attach is not exist");
  }
  var drawerNode = {
    show: function show() {
      requestAnimationFrame(function () {
        var _drawerRef$current2;
        (_drawerRef$current2 = drawerRef.current) === null || _drawerRef$current2 === void 0 || _drawerRef$current2.show();
      });
    },
    hide: function hide() {
      requestAnimationFrame(function () {
        var _drawerRef$current3;
        (_drawerRef$current3 = drawerRef.current) === null || _drawerRef$current3 === void 0 || _drawerRef$current3.destroy();
      });
    },
    update: function update(updateOptions) {
      requestAnimationFrame(function () {
        var _drawerRef$current4;
        (_drawerRef$current4 = drawerRef.current) === null || _drawerRef$current4 === void 0 || _drawerRef$current4.update(updateOptions);
      });
    },
    destroy: function destroy() {
      requestAnimationFrame(function () {
        var _drawerRef$current5;
        (_drawerRef$current5 = drawerRef.current) === null || _drawerRef$current5 === void 0 || _drawerRef$current5.destroy();
      });
    }
  };
  return drawerNode;
};
var DrawerPlugin = createDrawer;

exports.DrawerPlugin = DrawerPlugin;
//# sourceMappingURL=plugin.js.map
