/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var slicedToArray = require('../_chunks/dep-1135362e.js');
var React = require('react');
var classNames = require('classnames');
var popup_index = require('../popup/index.js');
var dropdown_DropdownMenu = require('./DropdownMenu.js');
var dropdown_DropdownItem = require('./DropdownItem.js');
var dropdown_defaultProps = require('./defaultProps.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var dropdown_hooks_useDropdownOptions = require('./hooks/useDropdownOptions.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var omit = require('../_chunks/dep-24a443af.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-2ebc1a75.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-7603c5b0.js');
require('../_chunks/dep-8ad5b41f.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-825271ec.js');
require('../_chunks/dep-0d2e37a8.js');
require('../hooks/useAnimation.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../common/Portal.js');
require('react-dom');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../hooks/useLayoutEffect.js');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c6c72aff.js');
require('../_chunks/dep-05e58abe.js');
require('../_chunks/dep-4a4a845f.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-888c17ef.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-4d46699b.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-e15a33e9.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('tdesign-icons-react');
require('../divider/index.js');
require('../divider/Divider.js');
require('../_chunks/dep-d4a1910a.js');
require('../divider/defaultProps.js');
require('../hooks/useGlobalIcon.js');
require('../_chunks/dep-b24245bf.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-0030e873.js');
require('../_util/helper.js');
require('../_chunks/dep-7e8bb5cc.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../_chunks/dep-dd40281a.js');
require('../_chunks/dep-e3718be1.js');
require('../_chunks/dep-fc852541.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Dropdown = function Dropdown(originalProps) {
  var props = hooks_useDefaultProps["default"](originalProps, dropdown_defaultProps.dropdownDefaultProps);
  var _props$popupProps = props.popupProps,
    popupProps = _props$popupProps === void 0 ? {} : _props$popupProps,
    disabled = props.disabled,
    placement = props.placement,
    trigger = props.trigger,
    className = props.className,
    children = props.children,
    hideAfterItemClick = props.hideAfterItemClick,
    propsOptions = props.options,
    style = props.style;
  var arrayChildren = React__default["default"].Children.toArray(children);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    isPopupVisible = _useState2[0],
    togglePopupVisible = _useState2[1];
  var dropdownClass = "".concat(classPrefix, "-dropdown");
  var options = dropdown_hooks_useDropdownOptions["default"](arrayChildren, propsOptions);
  var handleMenuClick = function handleMenuClick(data, context) {
    var _props$onClick;
    if (hideAfterItemClick) {
      var _popupProps$onVisible;
      togglePopupVisible(false);
      popupProps === null || popupProps === void 0 || (_popupProps$onVisible = popupProps.onVisibleChange) === null || _popupProps$onVisible === void 0 || _popupProps$onVisible.call(popupProps, false, context);
    }
    (_props$onClick = props.onClick) === null || _props$onClick === void 0 || _props$onClick.call(props, data, context);
  };
  var handleVisibleChange = function handleVisibleChange(visible, context) {
    var _popupProps$onVisible2;
    if (disabled || !options.length) return;
    togglePopupVisible(visible);
    popupProps === null || popupProps === void 0 || (_popupProps$onVisible2 = popupProps.onVisibleChange) === null || _popupProps$onVisible2 === void 0 || _popupProps$onVisible2.call(popupProps, visible, context);
  };
  var renderContent = /* @__PURE__ */React__default["default"].createElement(dropdown_DropdownMenu["default"], _objectSpread(_objectSpread({}, props), {}, {
    options: options,
    onClick: handleMenuClick
  }));
  var popupParams = _objectSpread(_objectSpread({
    disabled: disabled,
    placement: placement,
    trigger: trigger,
    showArrow: false,
    content: renderContent
  }, omit.omit(popupProps, "onVisibleChange")), {}, {
    overlayInnerClassName: classNames__default["default"](dropdownClass, className, popupProps === null || popupProps === void 0 ? void 0 : popupProps.overlayInnerClassName),
    overlayInnerStyle: style
  });
  var child = arrayChildren === null || arrayChildren === void 0 ? void 0 : arrayChildren[0];
  var dropDownTrigger = /*#__PURE__*/React.isValidElement(child) ? /*#__PURE__*/React__default["default"].cloneElement(child, {
    disabled: disabled
  }) : child;
  return /* @__PURE__ */React__default["default"].createElement(popup_index.Popup, _objectSpread({
    expandAnimation: true,
    destroyOnClose: true,
    visible: isPopupVisible,
    onVisibleChange: handleVisibleChange
  }, popupParams), dropDownTrigger);
};
Dropdown.DropdownItem = dropdown_DropdownItem["default"];
Dropdown.DropdownMenu = dropdown_DropdownMenu["default"];
Dropdown.displayName = "Dropdown";

exports["default"] = Dropdown;
//# sourceMappingURL=Dropdown.js.map
