/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var tree_Tree = require('../../tree/Tree.js');
var upload_upload = require('../../upload/upload.js');
var tag_CheckTag = require('../../tag/CheckTag.js');
var checkbox_CheckboxGroup = require('../../_chunks/dep-b1179ab2.js');
var tagInput_TagInput = require('../../tag-input/TagInput.js');
var rangeInput_RangeInput = require('../../range-input/RangeInput.js');
var transfer_Transfer = require('../../transfer/Transfer.js');
var datePicker_DateRangePicker = require('../../date-picker/DateRangePicker.js');
var timePicker_TimeRangePicker = require('../../time-picker/TimeRangePicker.js');
var form_FormContext = require('../FormContext.js');
var isEmpty = require('../../_chunks/dep-9c407767.js');
var get = require('../../_chunks/dep-f3ba9c81.js');
var omit = require('../../_chunks/dep-24a443af.js');
require('../../_chunks/dep-4d46699b.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-36f2c0c2.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-1135362e.js');
require('react-transition-group');
require('classnames');
require('../../_chunks/dep-e13830e4.js');
require('../../tree/TreeItem.js');
require('../../_chunks/dep-d4a1910a.js');
require('tdesign-icons-react');
require('../../loading/index.js');
require('../../loading/Loading.js');
require('../../_chunks/dep-2e323406.js');
require('../../_chunks/dep-c340510d.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-62452fcb.js');
require('../../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../../_chunks/dep-5a0b2388.js');
require('../../_chunks/dep-c03abb8d.js');
require('../../_chunks/dep-93691cd7.js');
require('../../_chunks/dep-4422ab9c.js');
require('../../_chunks/dep-d5965f49.js');
require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-f9fc748e.js');
require('../../_chunks/dep-39cfa1e8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-810d56ec.js');
require('../../_chunks/dep-2f2e3172.js');
require('../../_chunks/dep-e121d70e.js');
require('../../_chunks/dep-bd0ab4be.js');
require('../../_chunks/dep-0da99b78.js');
require('../../_chunks/dep-4edddcbd.js');
require('../../_chunks/dep-831ea6d9.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-0030e873.js');
require('../../_chunks/dep-5aec375e.js');
require('../../_chunks/dep-c02b300c.js');
require('../../hooks/useDomRefCallback.js');
require('../../loading/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-e15a33e9.js');
require('../../common/PluginContainer.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-bf0e5957.js');
require('../../_chunks/dep-349377fd.js');
require('../../_chunks/dep-9ee1931f.js');
require('../../_chunks/dep-e57f7de9.js');
require('../../_chunks/dep-d371704c.js');
require('../../_chunks/dep-aca4abf9.js');
require('../../_chunks/dep-a422f8bb.js');
require('../../hooks/useRipple.js');
require('../../hooks/useAnimation.js');
require('../../hooks/useGlobalIcon.js');
require('../../checkbox/index.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../common/Check.js');
require('../../_util/helper.js');
require('../../_chunks/dep-7e8bb5cc.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-7603c5b0.js');
require('../../_chunks/dep-8ad5b41f.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_chunks/dep-c4b07574.js');
require('../../checkbox/defaultProps.js');
require('../../tree/hooks/useTreeConfig.js');
require('../../locale/LocalReceiver.js');
require('../../tree/hooks/useDraggable.js');
require('../../tree/hooks/TreeDraggableContext.js');
require('../../_util/createHookContext.js');
require('../../hooks/usePersistFn.js');
require('../../_chunks/dep-b24245bf.js');
require('../../_chunks/dep-b6a887a7.js');
require('../../_chunks/dep-888c17ef.js');
require('../../_util/composeRefs.js');
require('../../tree/hooks/useControllable.js');
require('../../tree/hooks/useStore.js');
require('../../_chunks/dep-2964015e.js');
require('../../_chunks/dep-ce434e16.js');
require('mitt');
require('../../_chunks/dep-0de56bba.js');
require('../../_chunks/dep-99057d6c.js');
require('../../_chunks/dep-8bc1cdb3.js');
require('../../_chunks/dep-08c2f3c4.js');
require('../../_chunks/dep-199b9155.js');
require('../../_chunks/dep-e3718be1.js');
require('../../_chunks/dep-fc852541.js');
require('../../_chunks/dep-fccfa508.js');
require('../../_chunks/dep-1b417134.js');
require('../../_chunks/dep-a3296643.js');
require('../../_chunks/dep-4a0537fa.js');
require('../../_chunks/dep-d12ca794.js');
require('../../_chunks/dep-05e58abe.js');
require('../../_chunks/dep-98484f3b.js');
require('../../hooks/useUpdateLayoutEffect.js');
require('../../hooks/useIsFirstRender.js');
require('../../hooks/usePrevious.js');
require('../../_chunks/dep-dd40281a.js');
require('../../_util/parseTNode.js');
require('../../tree/hooks/useTreeVirtualScroll.js');
require('../../hooks/useVirtualScroll.js');
require('../../hooks/useResizeObserver.js');
require('../../hooks/useLatest.js');
require('../../hooks/useEventCallback.js');
require('../../upload/themes/NormalFile.js');
require('../../_chunks/dep-75514aca.js');
require('../../link/index.js');
require('../../link/Link.js');
require('../../link/defaultProps.js');
require('../../upload/themes/DraggerFile.js');
require('../../hooks/useCommonClassName.js');
require('../../upload/hooks/useDrag.js');
require('../../image-viewer/index.js');
require('../../image-viewer/ImageViewer.js');
require('../../_chunks/dep-ea4fef74.js');
require('../../_chunks/dep-d2f9d8ad.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../tooltip/index.js');
require('../../tooltip/Tooltip.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('../../popup/hooks/useTrigger.js');
require('react-is');
require('../../_util/ref.js');
require('../../_util/isFragment.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../hooks/useMutationObserver.js');
require('../../_chunks/dep-c6c72aff.js');
require('../../_chunks/dep-4a4a845f.js');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../hooks/useAttach.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../popup/PopupPlugin.js');
require('../../tooltip/defaultProps.js');
require('../../tooltip/TooltipLite.js');
require('../../hooks/useSwitch.js');
require('../../image-viewer/utils.js');
require('../../dialog/index.js');
require('../../dialog/Dialog.js');
require('../../hooks/useSetState.js');
require('../../dialog/defaultProps.js');
require('../../dialog/DialogCard.js');
require('../../button/index.js');
require('../../button/Button.js');
require('../../button/defaultProps.js');
require('../../dialog/hooks/useDialogEsc.js');
require('../../dialog/hooks/useLockStyle.js');
require('../../_chunks/dep-dc961b6b.js');
require('../../dialog/hooks/useDialogPosition.js');
require('../../dialog/hooks/useDialogDrag.js');
require('../../dialog/utils.js');
require('../../dialog/plugin.js');
require('../../image-viewer/hooks/useMirror.js');
require('../../image-viewer/hooks/usePosition.js');
require('../../image-viewer/hooks/useIndex.js');
require('../../image-viewer/hooks/useRotate.js');
require('../../image-viewer/hooks/useScale.js');
require('../../image-viewer/hooks/useIconMap.js');
require('../../image/index.js');
require('../../image/Image.js');
require('../../_chunks/dep-61f98c51.js');
require('../../image/defaultProps.js');
require('../../space/index.js');
require('../../space/Space.js');
require('../../space/defaultProps.js');
require('../../image-viewer/defaultProps.js');
require('../../image-viewer/hooks/useImageScale.js');
require('../../image-viewer/hooks/useList.js');
require('../../image-viewer/hooks/useViewerScale.js');
require('../../upload/themes/ImageCard.js');
require('../../upload/themes/MultipleFlowList.js');
require('../../upload/hooks/useUpload.js');
require('../../_chunks/dep-6790041a.js');
require('../../upload/defaultProps.js');
require('../../upload/themes/CustomFile.js');
require('../../_chunks/dep-a844b8f2.js');
require('../../tag/defaultProps.js');
require('../../tag/Tag.js');
require('tinycolor2');
require('../../hooks/useDragSorter.js');
require('../../input/index.js');
require('../../input/Input.js');
require('../../input/InputGroup.js');
require('../../input/defaultProps.js');
require('../../input/useLengthLimit.js');
require('../../tag-input/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag/index.js');
require('../../tag/CheckTagGroup.js');
require('../../tag-input/useHover.js');
require('../../tag-input/defaultProps.js');
require('../../range-input/defaultProps.js');
require('../../transfer/TransferList.js');
require('../../transfer/utils.js');
require('../../pagination/index.js');
require('../../pagination/Pagination.js');
require('../../select/index.js');
require('../../select/base/Select.js');
require('../../select/util/helper.js');
require('../../select/base/OptionGroup.js');
require('../../select/defaultProps.js');
require('../../select/base/Option.js');
require('../../common/FakeArrow.js');
require('../../select-input/index.js');
require('../../select-input/SelectInput.js');
require('../../select-input/useSingle.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../select-input/defaultProps.js');
require('../../select/base/PopupContent.js');
require('../../select/hooks/usePanelVirtualScroll.js');
require('../../select/hooks/useOptions.js');
require('../../input-number/index.js');
require('../../input-number/InputNumber.js');
require('../../input-number/useInputNumber.js');
require('../../input-number/defaultProps.js');
require('../../input-adornment/InputAdornment.js');
require('../../pagination/hooks/useBoundaryJumper.js');
require('../../pagination/hooks/usePrevNextJumper.js');
require('../../pagination/hooks/usePageNumber.js');
require('../../pagination/hooks/useTotal.js');
require('../../pagination/validators.js');
require('../../pagination/defaultProps.js');
require('../../pagination/PaginationMini.js');
require('../../transfer/defaultProps.js');
require('../../_chunks/dep-87b282c3.js');
require('../../_chunks/dep-72276c68.js');
require('../../_chunks/dep-3d623476.js');
require('../../range-input/index.js');
require('../../range-input/RangeInputPopup.js');
require('../../date-picker/panel/RangePanel.js');
require('../../date-picker/panel/PanelContent.js');
require('../../date-picker/base/Header.js');
require('../../date-picker/base/Table.js');
require('../../date-picker/base/Cell.js');
require('../../time-picker/index.js');
require('../../time-picker/TimePicker.js');
require('../../_chunks/dep-500fdc96.js');
require('../../time-picker/hooks/useTimePickerTextConfig.js');
require('../../hooks/useDebounce.js');
require('../../hooks/usePropsRef.js');
require('../../time-picker/panel/TimePickerPanel.js');
require('../../time-picker/defaultProps.js');
require('../../date-picker/panel/ExtraContent.js');
require('../../date-picker/base/Footer.js');
require('../../date-picker/hooks/useTableData.js');
require('../../date-picker/hooks/useDisableDate.js');
require('../../date-picker/utils.js');
require('../../date-picker/hooks/useRange.js');
require('../../date-picker/hooks/useRangeValue.js');
require('../../date-picker/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/**
 * Removes the property at `path` of `object`.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to unset.
 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 7 } }] };
 * _.unset(object, 'a[0].b.c');
 * // => true
 *
 * console.log(object);
 * // => { 'a': [{ 'b': {} }] };
 *
 * _.unset(object, ['a', '0', 'b', 'c']);
 * // => true
 *
 * console.log(object);
 * // => { 'a': [{ 'b': {} }] };
 */
function unset(object, path) {
  return object == null ? true : omit.baseUnset(object, path);
}

var ctrlKeyMap = /* @__PURE__ */new Map();
ctrlKeyMap.set(checkbox_CheckboxGroup.Checkbox, "checked");
ctrlKeyMap.set(tag_CheckTag["default"], "checked");
ctrlKeyMap.set(upload_upload["default"], "files");
var initialDataMap = /* @__PURE__ */new Map();
[tree_Tree["default"], upload_upload["default"], transfer_Transfer["default"], tagInput_TagInput["default"], rangeInput_RangeInput["default"], checkbox_CheckboxGroup.CheckboxGroup, datePicker_DateRangePicker["default"], timePicker_TimeRangePicker["default"]].forEach(function (component) {
  initialDataMap.set(component, []);
});
[checkbox_CheckboxGroup.Checkbox].forEach(function (component) {
  initialDataMap.set(component, false);
});
function useFormItemInitialData(name) {
  var hadReadFloatingFormData = false;
  var _useFormContext = form_FormContext.useFormContext(),
    floatingFormDataRef = _useFormContext.floatingFormDataRef,
    formContextInitialData = _useFormContext.initialData;
  var _useFormListContext = form_FormContext.useFormListContext(),
    formListName = _useFormListContext.name,
    formListInitialData = _useFormListContext.initialData;
  React.useEffect(function () {
    if (hadReadFloatingFormData) {
      var nameList = formListName ? [formListName, name].flat() : name;
      unset(floatingFormDataRef.current, nameList);
    }
  }, [hadReadFloatingFormData, floatingFormDataRef, formListName, name]);
  function getDefaultInitialData(_ref) {
    var children = _ref.children,
      initialData = _ref.initialData;
    if (name && floatingFormDataRef !== null && floatingFormDataRef !== void 0 && floatingFormDataRef.current && !isEmpty.isEmpty(floatingFormDataRef.current)) {
      var nameList = formListName ? [formListName, name].flat() : name;
      var defaultInitialData = get.get(floatingFormDataRef.current, nameList);
      if (typeof defaultInitialData !== "undefined") {
        hadReadFloatingFormData = true;
        return defaultInitialData;
      }
    }
    if (typeof initialData !== "undefined") {
      return initialData;
    }
    if (name && formListInitialData.length) {
      var _defaultInitialData = get.get(formListInitialData, name);
      if (typeof _defaultInitialData !== "undefined") return _defaultInitialData;
    }
    if (name && formContextInitialData) {
      var _defaultInitialData2 = get.get(formContextInitialData, name);
      if (typeof _defaultInitialData2 !== "undefined") return _defaultInitialData2;
    }
    if (typeof children !== "function") {
      var childList = React__default["default"].Children.toArray(children);
      var lastChild = childList[childList.length - 1];
      if (lastChild && /*#__PURE__*/React__default["default"].isValidElement(lastChild)) {
        var _lastChild$props;
        var isMultiple = lastChild === null || lastChild === void 0 || (_lastChild$props = lastChild.props) === null || _lastChild$props === void 0 ? void 0 : _lastChild$props.multiple;
        return isMultiple ? [] : initialDataMap.get(lastChild.type);
      }
    }
  }
  return {
    getDefaultInitialData: getDefaultInitialData
  };
}

exports.ctrlKeyMap = ctrlKeyMap;
exports["default"] = useFormItemInitialData;
exports.initialDataMap = initialDataMap;
//# sourceMappingURL=useFormItemInitialData.js.map
