/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-1135362e.js');
var React = require('react');
var form_hooks_useForm = require('./useForm.js');
var _util_noop = require('../../_util/noop.js');
var get = require('../../_chunks/dep-f3ba9c81.js');
var isUndefined = require('../../_chunks/dep-fccfa508.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-4d46699b.js');
require('../../_chunks/dep-ce434e16.js');
require('../../_chunks/dep-36f2c0c2.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-e13830e4.js');
require('../../_chunks/dep-8bc1cdb3.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-f9468320.js');

function useWatch(name, form) {
  var _useState = React.useState(),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var valueStr = React.useMemo(function () {
    return JSON.stringify(value);
  }, [value]);
  var valueStrRef = React.useRef(valueStr);
  var isValidForm = form && form._init;
  React.useEffect(function () {
    var _form$getInternalHook3, _form$getFieldsValue2;
    if (!isValidForm) return;
    var _form$getInternalHook = (_form$getInternalHook3 = form.getInternalHooks) === null || _form$getInternalHook3 === void 0 ? void 0 : _form$getInternalHook3.call(form, form_hooks_useForm.HOOK_MARK),
      _form$getInternalHook2 = _form$getInternalHook.registerWatch,
      registerWatch = _form$getInternalHook2 === void 0 ? _util_noop["default"] : _form$getInternalHook2;
    var cancelRegister = registerWatch(function () {
      var _form$getFieldsValue;
      var allFieldsValue2 = (_form$getFieldsValue = form.getFieldsValue) === null || _form$getFieldsValue === void 0 ? void 0 : _form$getFieldsValue.call(form, true);
      var newValue = get.get(allFieldsValue2, name);
      var nextValueStr = JSON.stringify(newValue);
      if (valueStrRef.current !== nextValueStr) {
        valueStrRef.current = nextValueStr;
        setValue(nextValueStr);
      }
    });
    var allFieldsValue = (_form$getFieldsValue2 = form.getFieldsValue) === null || _form$getFieldsValue2 === void 0 ? void 0 : _form$getFieldsValue2.call(form, true);
    var initialValue = get.get(allFieldsValue, name);
    setValue(JSON.stringify(initialValue));
    return cancelRegister;
  }, []);
  return isUndefined.isUndefined(value) ? value : JSON.parse(value);
}

exports["default"] = useWatch;
//# sourceMappingURL=useWatch.js.map
