/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var hooks_useConfig = require('./useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-36f2c0c2.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');

function useClickOutside(refs, handler, includePopup) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var POPUP_SELECTOR = ".".concat(classPrefix, "-popup");
  React.useEffect(function () {
    var listener = function listener(event) {
      if (!Array.isArray(refs)) {
        return;
      }
      var elements = [];
      if (includePopup) {
        document.querySelectorAll(POPUP_SELECTOR).forEach(function (ele) {
          elements.push(ele);
        });
      }
      elements = Array.from(new Set(elements));
      if (refs.find(function (ref) {
        var _ref$current;
        return (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.contains(event.target);
      }) || elements.find(function (el) {
        return el === null || el === void 0 ? void 0 : el.contains(event.target);
      })) {
        return;
      }
      handler(event);
    };
    document.addEventListener("mousedown", listener);
    document.addEventListener("touchstart", listener);
    return function () {
      document.removeEventListener("mousedown", listener);
      document.removeEventListener("touchstart", listener);
    };
  }, [refs, handler, includePopup]);
}

exports["default"] = useClickOutside;
//# sourceMappingURL=useClickOutside.js.map
