/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var hooks_usePersistFn = require('./usePersistFn.js');
var debounce = require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-888c17ef.js');
require('../_chunks/dep-825271ec.js');
require('../_chunks/dep-0d2e37a8.js');

var useDebounce = function useDebounce(func, delay, options) {
  var callback = hooks_usePersistFn.usePersistFn(func);
  var debounced = React.useCallback(debounce.debounce(callback, delay, options), [callback, delay, options]);
  React.useEffect(function () {
    return debounced.cancel;
  }, [debounced]);
  return debounced;
};

exports["default"] = useDebounce;
//# sourceMappingURL=useDebounce.js.map
