/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function useDefaultProps(originalProps, defaultProps) {
  return React.useMemo(function () {
    var props = Object.assign({}, originalProps);
    Object.keys(defaultProps).forEach(function (key) {
      if (props[key] === void 0) {
        props[key] = defaultProps[key];
      }
    });
    return props;
  }, [originalProps, defaultProps]);
}

exports["default"] = useDefaultProps;
//# sourceMappingURL=useDefaultProps.js.map
