/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-1135362e.js');
var React = require('react');
var log = require('../_chunks/dep-e13830e4.js');
var utils = require('../_chunks/dep-75514aca.js');
require('../_chunks/dep-2ebc1a75.js');

function useImagePreviewUrl(imgUrl) {
  var _useState = React.useState(""),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    previewUrl = _useState2[0],
    setPreviewUrl = _useState2[1];
  React.useEffect(function () {
    if (!imgUrl) return;
    if (typeof imgUrl === "string") {
      setPreviewUrl(imgUrl);
      return;
    }
    utils.getFileUrlByFileRaw(imgUrl).then(function (url) {
      setPreviewUrl(url);
    }, function () {
      log.log.error("Image", "Image.src is not a valid file");
    });
  }, [imgUrl]);
  return {
    previewUrl: previewUrl
  };
}

exports["default"] = useImagePreviewUrl;
exports.useImagePreviewUrl = useImagePreviewUrl;
//# sourceMappingURL=useImagePreviewUrl.js.map
