/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-1135362e.js');
var React = require('react');
var _util_style = require('../_chunks/dep-2e323406.js');
var debounce = require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-c340510d.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-888c17ef.js');
require('../_chunks/dep-825271ec.js');

function useWindowSize() {
  var _useState = React.useState(_util_style.getWindowSize),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    size = _useState2[0],
    setSize = _useState2[1];
  React.useEffect(function () {
    function handleResize() {
      setSize(_util_style.getWindowSize());
    }
    var debounceResize = debounce.debounce(handleResize, 400);
    window.addEventListener("resize", debounceResize);
    return function () {
      window.removeEventListener("resize", debounceResize);
      debounceResize.cancel();
    };
  }, []);
  return size;
}

exports["default"] = useWindowSize;
//# sourceMappingURL=useWindowSize.js.map
