import React, { MouseEvent, KeyboardEvent } from 'react';
import { TNode } from '../common';
import { ImageInfo, ImageScale, ImageViewerScale } from './type';
import type { TdImageViewerProps } from './type';
import { ImageViewerProps } from './ImageViewer';
interface ImageModalItemProps {
    rotateZ: number;
    scale: number;
    mirror: number;
    src: string | File;
    preSrc?: string | File;
    errorText: string;
    imageReferrerpolicy?: TdImageViewerProps['imageReferrerpolicy'];
    isSvg: boolean;
}
export declare const ImageModalItem: React.FC<ImageModalItemProps>;
interface ImageViewerUtilsProps {
    scale: number;
    currentImage: ImageInfo;
    onRotate: (ROTATE_COUNT: number) => void;
    onZoom: () => void;
    onZoomOut: () => void;
    onMirror: () => void;
    onReset: () => void;
    tipText: {
        mirror: string;
        rotate: string;
        originsize: string;
    };
    onDownload?: TdImageViewerProps['onDownload'];
}
export declare const ImageViewerUtils: React.FC<ImageViewerUtilsProps>;
export interface ImageModalProps {
    title?: TNode;
    visible: boolean;
    closeOnOverlay: boolean;
    showOverlay: boolean;
    index: number;
    defaultIndex?: number;
    images: ImageInfo[];
    onClose: (context: {
        trigger: 'close-btn' | 'overlay' | 'esc';
        e: MouseEvent<HTMLElement> | KeyboardEvent;
    }) => void;
    onOpen: () => void;
    imageScale: ImageScale;
    viewerScale: ImageViewerScale;
    zIndex: number;
    isMini: boolean;
    draggable: boolean;
    closeBtn: boolean | TNode;
    closeOnEscKeydown?: boolean;
    onDownload?: TdImageViewerProps['onDownload'];
    onIndexChange?: (index: number, context: {
        trigger: 'prev' | 'next';
    }) => void;
    imageReferrerpolicy?: ImageViewerProps['imageReferrerpolicy'];
}
export declare const ImageModal: React.FC<ImageModalProps>;
export {};
