/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tdesignIconsReact = require('tdesign-icons-react');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
require('../../hooks/useConfig.js');
require('react');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-36f2c0c2.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-62452fcb.js');
require('../../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../../_chunks/dep-5a0b2388.js');
require('../../_chunks/dep-c03abb8d.js');
require('../../_chunks/dep-93691cd7.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-4422ab9c.js');
require('../../_chunks/dep-d5965f49.js');
require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-f9fc748e.js');
require('../../_chunks/dep-39cfa1e8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-810d56ec.js');
require('../../_chunks/dep-2f2e3172.js');
require('../../_chunks/dep-e121d70e.js');
require('../../_chunks/dep-bd0ab4be.js');
require('../../_chunks/dep-0da99b78.js');
require('../../_chunks/dep-4edddcbd.js');
require('../../_chunks/dep-831ea6d9.js');

var useIconMap = function useIconMap() {
  var Icons = hooks_useGlobalIcon["default"]({
    ChevronDownIcon: tdesignIconsReact.ChevronDownIcon,
    ChevronLeftIcon: tdesignIconsReact.ChevronLeftIcon,
    ChevronRightIcon: tdesignIconsReact.ChevronRightIcon,
    CloseIcon: tdesignIconsReact.CloseIcon,
    DownloadIcon: tdesignIconsReact.DownloadIcon,
    MirrorIcon: tdesignIconsReact.MirrorIcon,
    RotationIcon: tdesignIconsReact.RotationIcon,
    ZoomInIcon: tdesignIconsReact.ZoomInIcon,
    ZoomOutIcon: tdesignIconsReact.ZoomOutIcon
  });
  return {
    rotation: Icons.RotationIcon,
    "zoom-in": Icons.ZoomInIcon,
    mirror: Icons.MirrorIcon,
    "zoom-out": Icons.ZoomOutIcon,
    download: Icons.DownloadIcon,
    "chevron-left": Icons.ChevronLeftIcon,
    "chevron-right": Icons.ChevronRightIcon,
    "chevron-down": Icons.ChevronDownIcon,
    close: Icons.CloseIcon
  };
};

exports["default"] = useIconMap;
//# sourceMappingURL=useIconMap.js.map
