/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-1135362e.js');
var React = require('react');
var hooks_useControlled = require('../../hooks/useControlled.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_util/noop.js');
require('../../_chunks/dep-7603c5b0.js');
require('../../_chunks/dep-8ad5b41f.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-0d2e37a8.js');

var useIndex = function useIndex(resProps, images) {
  var _useControlled = hooks_useControlled["default"](resProps, "index", resProps.onIndexChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    index = _useControlled2[0],
    setIndex = _useControlled2[1];
  var next = React.useCallback(function () {
    var newIndex = index + 1;
    if (newIndex >= images.length) return index;
    setIndex(newIndex, {
      trigger: "next"
    });
  }, [setIndex, index, images.length]);
  var prev = React.useCallback(function () {
    var newIndex = index - 1 > 0 ? index - 1 : 0;
    setIndex(newIndex, {
      trigger: "prev"
    });
  }, [index, setIndex]);
  return {
    index: index,
    next: next,
    prev: prev,
    setIndex: setIndex
  };
};

exports["default"] = useIndex;
//# sourceMappingURL=useIndex.js.map
