/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-1135362e.js');
var React = require('react');
require('../../_chunks/dep-2ebc1a75.js');

var useScale = function useScale(imageScale) {
  var _useState = React.useState(function () {
      var _imageScale$defaultSc;
      return (_imageScale$defaultSc = imageScale.defaultScale) !== null && _imageScale$defaultSc !== void 0 ? _imageScale$defaultSc : 1;
    }),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    scale = _useState2[0],
    setScale = _useState2[1];
  var onZoom = React.useCallback(function () {
    setScale(function (scale2) {
      var newScale = scale2 + imageScale.step;
      if (newScale < imageScale.min) return imageScale.min;
      if (newScale > imageScale.max) return imageScale.max;
      return newScale;
    });
  }, [imageScale]);
  var onZoomOut = React.useCallback(function () {
    setScale(function (scale2) {
      var newScale = scale2 - imageScale.step;
      if (newScale < imageScale.min) return imageScale.min;
      if (newScale > imageScale.max) return imageScale.max;
      return newScale;
    });
  }, [imageScale]);
  var onResetScale = React.useCallback(function () {
    var _imageScale$defaultSc2;
    return setScale((_imageScale$defaultSc2 = imageScale.defaultScale) !== null && _imageScale$defaultSc2 !== void 0 ? _imageScale$defaultSc2 : 1);
  }, [imageScale]);
  return {
    scale: scale,
    onZoom: onZoom,
    onZoomOut: onZoomOut,
    onResetScale: onResetScale
  };
};

exports["default"] = useScale;
//# sourceMappingURL=useScale.js.map
