/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var objectWithoutProperties = require('../_chunks/dep-d4a1910a.js');
var classNames = require('classnames');
var React = require('react');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var link_defaultProps = require('./defaultProps.js');
require('../_chunks/dep-a483aecf.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_chunks/dep-e13830e4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var _excluded = ["children", "content", "className", "underline", "prefixIcon", "suffixIcon", "theme", "disabled", "hover", "onClick", "href", "size"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Link = /*#__PURE__*/React__default["default"].forwardRef(function (props, ref) {
  var _useDefaultProps = hooks_useDefaultProps["default"](props, link_defaultProps.linkDefaultProps),
    children = _useDefaultProps.children,
    content = _useDefaultProps.content,
    className = _useDefaultProps.className,
    underline = _useDefaultProps.underline,
    prefixIcon = _useDefaultProps.prefixIcon,
    suffixIcon = _useDefaultProps.suffixIcon,
    theme = _useDefaultProps.theme,
    disabled = _useDefaultProps.disabled,
    hover = _useDefaultProps.hover,
    onClick = _useDefaultProps.onClick,
    href = _useDefaultProps.href,
    size = _useDefaultProps.size,
    otherProps = objectWithoutProperties._objectWithoutProperties(_useDefaultProps, _excluded);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var childNode = content || children;
  var handleClick = function handleClick(e) {
    if (disabled) {
      return;
    }
    onClick === null || onClick === void 0 || onClick(e);
  };
  return /* @__PURE__ */React__default["default"].createElement("a", _objectSpread(_objectSpread({}, otherProps), {}, {
    href: disabled || !href ? void 0 : href,
    ref: ref,
    className: classNames__default["default"](className, ["".concat(classPrefix, "-link"), "".concat(classPrefix, "-link--theme-").concat(theme)], defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-size-s"), size === "small"), "".concat(classPrefix, "-size-l"), size === "large"), "".concat(classPrefix, "-is-disabled"), !!disabled), "".concat(classPrefix, "-is-underline"), !!underline), "".concat(classPrefix, "-link--hover-").concat(hover), !disabled)),
    onClick: handleClick
  }), prefixIcon && /* @__PURE__ */React__default["default"].createElement("span", {
    className: classNames__default["default"](["".concat(classPrefix, "-link__prefix-icon")])
  }, _util_parseTNode["default"](prefixIcon)), childNode, suffixIcon && /* @__PURE__ */React__default["default"].createElement("span", {
    className: classNames__default["default"](["".concat(classPrefix, "-link__suffix-icon")])
  }, _util_parseTNode["default"](suffixIcon)));
});
Link.displayName = "Link";

exports["default"] = Link;
//# sourceMappingURL=Link.js.map
