/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var objectWithoutProperties = require('../_chunks/dep-d4a1910a.js');
var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var classNames = require('classnames');
var React = require('react');
var tabs_index = require('../tabs/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var menu_hooks_useMenuContext = require('./hooks/useMenuContext.js');
var menu_MenuContext = require('./MenuContext.js');
var menu__util_checkSubMenuActive = require('./_util/checkSubMenuActive.js');
var isObject = require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-a483aecf.js');
require('../tabs/Tabs.js');
require('../_chunks/dep-1135362e.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../tabs/TabNav.js');
require('tdesign-icons-react');
require('../_util/noop.js');
require('../tabs/useTabClass.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../tabs/TabNavItem.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-0030e873.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useGlobalIcon.js');
require('../tabs/TabBar.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c6c72aff.js');
require('../_chunks/dep-05e58abe.js');
require('../_chunks/dep-4a4a845f.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-888c17ef.js');
require('../_chunks/dep-825271ec.js');
require('../hooks/useResizeObserver.js');
require('../hooks/useLayoutEffect.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-e13830e4.js');
require('../_chunks/dep-24a443af.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../_chunks/dep-dd40281a.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-e3718be1.js');
require('../_chunks/dep-fc852541.js');
require('../tabs/TabPanel.js');
require('../tabs/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../_chunks/dep-4d46699b.js');
require('./_util/checkSubMenuChildExpanded.js');
require('./_util/type.js');
require('../_chunks/dep-db4738a0.js');
require('./_util/checkMenuType.js');
require('./_util/checkSubMenuChildrenActive.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var _excluded = ["children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TabPanel = tabs_index.Tabs.TabPanel;
var HeadMenu = function HeadMenu(props) {
  var children = props.children,
    className = props.className,
    _props$theme = props.theme,
    theme = _props$theme === void 0 ? "light" : _props$theme,
    style = props.style,
    logo = props.logo,
    operations = props.operations;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useMenuContext = menu_hooks_useMenuContext["default"](_objectSpread(_objectSpread({}, props), {}, {
      children: children,
      mode: "title"
    })),
    value = _useMenuContext.value;
  var childList = React.useMemo(function () {
    if (value.expandType === "popup") return null;
    var activeMenu = menu__util_checkSubMenuActive["default"](children, value.active);
    if (!activeMenu) return null;
    var child = activeMenu.props.children;
    if (Array.isArray(child)) return child;
    if (isObject.isObject(child)) return [child];
    return activeMenu.props.children;
  }, [children, value.expandType, value.active]);
  var currentChildListValues = (childList === null || childList === void 0 ? void 0 : childList.length) > 0 ? childList.map(function (item) {
    return item.props.value;
  }) : [];
  return /* @__PURE__ */React__default["default"].createElement(menu_MenuContext.MenuContext.Provider, {
    value: value
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"]("".concat(classPrefix, "-head-menu"), "".concat(classPrefix, "-menu--").concat(theme), className),
    style: _objectSpread({}, style)
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-head-menu__inner")
  }, logo && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__logo")
  }, logo), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: "".concat(classPrefix, "-menu")
  }, children), operations && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__operations")
  }, operations)), (childList === null || childList === void 0 ? void 0 : childList.length) > 0 && /* @__PURE__ */React__default["default"].createElement("ul", {
    className: "".concat(classPrefix, "-head-menu__submenu ").concat(classPrefix, "-submenu")
  }, /* @__PURE__ */React__default["default"].createElement(tabs_index.Tabs, {
    value: currentChildListValues.includes(value.active) ? value.active : currentChildListValues[0],
    onChange: value.onChange
  }, childList.map(function (_ref) {
    var _ref$props = _ref.props,
      children2 = _ref$props.children,
      restProps = objectWithoutProperties._objectWithoutProperties(_ref$props, _excluded);
    return /* @__PURE__ */React__default["default"].createElement(TabPanel, _objectSpread(_objectSpread({
      key: props.value
    }, restProps), {}, {
      label: children2
    }));
  })))));
};

exports["default"] = HeadMenu;
//# sourceMappingURL=HeadMenu.js.map
