/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../../_chunks/dep-4d46699b.js');
var defineProperty = require('../../_chunks/dep-36f2c0c2.js');
var slicedToArray = require('../../_chunks/dep-1135362e.js');
var React = require('react');
var menu__util_checkSubMenuChildExpanded = require('../_util/checkSubMenuChildExpanded.js');
var noop = require('../../_chunks/dep-db4738a0.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-a483aecf.js');
require('../_util/type.js');

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useMenuContext(_ref) {
  var defaultValue = _ref.defaultValue,
    defaultExpanded = _ref.defaultExpanded,
    expandMutex = _ref.expandMutex,
    children = _ref.children,
    _ref$onExpand = _ref.onExpand,
    onExpand = _ref$onExpand === void 0 ? noop.noop : _ref$onExpand,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? noop.noop : _ref$onChange,
    value = _ref.value,
    expanded = _ref.expanded,
    collapsed = _ref.collapsed,
    expandType = _ref.expandType,
    theme = _ref.theme,
    mode = _ref.mode;
  var _useState = React.useState({
      active: defaultValue,
      expanded: defaultExpanded
    }),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    state = _useState2[0],
    setState = _useState2[1];
  var setStateValue = function setStateValue(menuState) {
    return setState(_objectSpread(_objectSpread({}, state), menuState));
  };
  var handleExpandChange = function handleExpandChange(value2, expanded2) {
    var nextExpand = [];
    var index = expanded2.indexOf(value2);
    if (index > -1) {
      if (expandMutex) {
        nextExpand = expanded2.slice(0, index);
      } else {
        nextExpand = expanded2.filter(function (item) {
          return item !== value2;
        });
      }
    } else if (expandMutex) {
      nextExpand = menu__util_checkSubMenuChildExpanded["default"](children, expanded2, value2);
    } else {
      nextExpand = [].concat(toConsumableArray._toConsumableArray(expanded2), [value2]);
    }
    onExpand(nextExpand);
    setState({
      expanded: nextExpand
    });
  };
  return {
    value: {
      onExpand: handleExpandChange,
      onChange: onChange,
      active: value || state.active,
      expanded: expanded || state.expanded,
      collapsed: collapsed || state.collapsed,
      setState: setStateValue,
      expandMutex: expandMutex,
      expandType: collapsed ? "popup" : expandType,
      mode: mode,
      theme: theme
    }
  };
}

exports["default"] = useMenuContext;
//# sourceMappingURL=useMenuContext.js.map
