/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../_chunks/dep-4d46699b.js');
var _typeof = require('../_chunks/dep-a483aecf.js');
var notification_NotificationList = require('../_chunks/dep-867bd13e.js');
var notification_config = require('./config.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-36f2c0c2.js');
require('react');
require('classnames');
require('tdesign-icons-react');
require('../_chunks/dep-1135362e.js');
require('../_util/react-render.js');
require('../_chunks/dep-e15a33e9.js');
require('react-dom');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_util/noop.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-e13830e4.js');
require('../hooks/useGlobalIcon.js');
require('./defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../common/PluginContainer.js');

var renderNotification = function renderNotification(theme, options) {
  if (_typeof._typeof(options) !== "object") return;
  var configs = notification_config.getConfig(options);
  var placement = configs.placement;
  var attach = function () {
    var containerId = "tdesign-notification-".concat(placement);
    var container = document.querySelector("#".concat(containerId));
    if (container && container instanceof HTMLElement) {
      return container;
    }
    var element = document.createElement("div");
    element.setAttribute("id", containerId);
    if (options.attach && typeof options.attach === "string") {
      var container2 = document.querySelector(options.attach);
      if (container2 instanceof HTMLElement) return container2.appendChild(element);
    }
    if (options.attach instanceof HTMLElement) return options.attach.appendChild(element);
    document.body.appendChild(element);
    return element;
  }();
  return notification_NotificationList.fetchListInstance(placement, attach, configs.zIndex).then(function (listInstance) {
    return listInstance.push(theme, configs);
  });
};
var NotificationPlugin = function NotificationPlugin(theme, props) {
  return renderNotification(theme, props);
};
NotificationPlugin.info = function (options) {
  return renderNotification("info", options);
};
NotificationPlugin.success = function (options) {
  return renderNotification("success", options);
};
NotificationPlugin.warning = function (options) {
  return renderNotification("warning", options);
};
NotificationPlugin.error = function (options) {
  return renderNotification("error", options);
};
NotificationPlugin.close = function (promise) {
  return promise.then(function (instance) {
    return instance.close();
  });
};
NotificationPlugin.closeAll = function () {
  return toConsumableArray._toConsumableArray(notification_NotificationList.listMap.values()).forEach(function (list) {
    return list.removeAll();
  });
};
NotificationPlugin.config = function (options) {
  return notification_config.setGlobalConfig(options);
};

exports.NotificationPlugin = NotificationPlugin;
//# sourceMappingURL=NotificationPlugin.js.map
