import React from 'react';
import { TdPopupProps } from './type';
import usePopper from '../hooks/usePopper';
export interface PopupProps extends TdPopupProps {
    expandAnimation?: boolean;
    updateScrollTop?: (content: HTMLDivElement) => void;
}
export interface PopupRef {
    /** 获取 popper 实例 */
    getPopper: () => ReturnType<typeof usePopper>;
    /** 获取 Popup dom 元素 */
    getPopupElement: () => HTMLDivElement;
    /** 获取 portal dom 元素 */
    getPortalElement: () => HTMLDivElement;
    /** 获取内容区域 dom 元素 */
    getPopupContentElement: () => HTMLDivElement;
    /** 设置 popup 显示隐藏 */
    setVisible: (visible: boolean) => void;
}
declare const Popup: React.ForwardRefExoticComponent<PopupProps & React.RefAttributes<PopupRef>>;
export default Popup;
