/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var React = require('react');
var classNames = require('classnames');
var table_utils = require('./utils.js');
var table_hooks_useFixed = require('./hooks/useFixed.js');
var table_hooks_useRowspanAndColspan = require('./hooks/useRowspanAndColspan.js');
var table_hooks_useClassName = require('./hooks/useClassName.js');
var isFunction = require('../_chunks/dep-cfd04a4b.js');
var get = require('../_chunks/dep-f3ba9c81.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-5aec375e.js');
require('../_chunks/dep-4d46699b.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-c02b300c.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-1135362e.js');
require('../_chunks/dep-e13830e4.js');
require('../_chunks/dep-dc961b6b.js');
require('../hooks/useDebounce.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-888c17ef.js');
require('../_chunks/dep-825271ec.js');
require('../hooks/usePrevious.js');
require('../_util/listener.js');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-7897a10b.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-d12ca794.js');
require('../_chunks/dep-05e58abe.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-98484f3b.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-fc852541.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-db4738a0.js');
require('../_chunks/dep-4a4a845f.js');
require('../_chunks/dep-dd40281a.js');
require('../_chunks/dep-99057d6c.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../_chunks/dep-08c2f3c4.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-199b9155.js');
require('../_chunks/dep-e3718be1.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function TFoot(props) {
  var footData = props.footData,
    columns = props.columns,
    rowKey = props.rowKey,
    footerSummary = props.footerSummary,
    virtualScroll = props.virtualScroll;
  var tfooterRef = React.useRef(null);
  var classnames = table_hooks_useClassName["default"]();
  var _useRowspanAndColspan = table_hooks_useRowspanAndColspan["default"](footData, columns, rowKey, props.rowspanAndColspanInFooter),
    skipSpansMap = _useRowspanAndColspan.skipSpansMap;
  var renderTFootCell = function renderTFootCell(p) {
    var col = p.col,
      row = p.row;
    if (isFunction.isFunction(col.foot)) {
      return col.foot(p);
    }
    return col.foot || get.get(row, col.colKey);
  };
  var theadClasses = [classnames.tableFooterClasses.footer, defineProperty._defineProperty({}, classnames.tableFooterClasses.fixed, props.isFixedHeader)];
  if (!columns) return null;
  var footerDomList = footData === null || footData === void 0 ? void 0 : footData.map(function (row, rowIndex) {
    var trAttributes = table_utils.formatRowAttributes(props.rowAttributes, {
      row: row,
      rowIndex: rowIndex,
      type: "foot"
    });
    var customClasses = table_utils.formatRowClassNames(props.rowClassName, {
      row: row,
      rowIndex: rowIndex,
      type: "foot"
    }, props.rowKey || "id");
    return /* @__PURE__ */React__default["default"].createElement("tr", _objectSpread(_objectSpread({
      key: rowIndex
    }, trAttributes), {}, {
      className: classNames__default["default"](customClasses)
    }), columns.map(function (col, colIndex) {
      var _props$thWidthList;
      var cellSpans = {};
      var spanState = null;
      if (skipSpansMap.size) {
        var _spanState, _spanState2;
        var cellKey = table_hooks_useRowspanAndColspan.getCellKey(row, rowKey, col.colKey, colIndex);
        spanState = skipSpansMap.get(cellKey) || {};
        ((_spanState = spanState) === null || _spanState === void 0 ? void 0 : _spanState.rowspan) > 1 && (cellSpans.rowspan = spanState.rowspan);
        ((_spanState2 = spanState) === null || _spanState2 === void 0 ? void 0 : _spanState2.colspan) > 1 && (cellSpans.colspan = spanState.colspan);
        if (spanState.skipped) return null;
      }
      var tdStyles = table_hooks_useFixed.getColumnFixedStyles(col, colIndex, props.rowAndColFixedPosition, classnames.tableColFixedClasses);
      var style = _objectSpread({}, tdStyles.style);
      if ((_props$thWidthList = props.thWidthList) !== null && _props$thWidthList !== void 0 && _props$thWidthList[col.colKey]) {
        style.width = "".concat(props.thWidthList[col.colKey] || 0, "px");
      }
      return /* @__PURE__ */React__default["default"].createElement("td", {
        key: col.colKey,
        rowSpan: cellSpans.rowspan,
        colSpan: cellSpans.colspan,
        className: classNames__default["default"](tdStyles.classes),
        style: style
      }, renderTFootCell({
        row: row,
        rowIndex: rowIndex,
        col: col,
        colIndex: colIndex
      }));
    }));
  });
  if (!footerSummary && (!props.footData || !props.footData.length)) return null;
  return /* @__PURE__ */React__default["default"].createElement("tfoot", {
    ref: tfooterRef,
    className: classNames__default["default"](theadClasses),
    style: {
      visibility: virtualScroll ? "hidden" : "visible"
    }
  }, footerSummary && /* @__PURE__ */React__default["default"].createElement("tr", {
    className: classnames.tableFullRowClasses.base
  }, /* @__PURE__ */React__default["default"].createElement("td", {
    colSpan: columns.length
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classnames.tableFullRowClasses.innerFullElement
  }, footerSummary))), footerDomList);
}

exports["default"] = TFoot;
//# sourceMappingURL=TFoot.js.map
