/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-1135362e.js');
var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var React = require('react');
var classNames = require('classnames');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var tabs_TabNav = require('./TabNav.js');
var tabs_useTabClass = require('./useTabClass.js');
var tabs_TabPanel = require('./TabPanel.js');
var tabs_defaultProps = require('./defaultProps.js');
var hooks_useDragSorter = require('../hooks/useDragSorter.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-a483aecf.js');
require('hoist-non-react-statics');
require('tdesign-icons-react');
require('../_util/noop.js');
require('./TabNavItem.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-0030e873.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useGlobalIcon.js');
require('./TabBar.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c6c72aff.js');
require('../_chunks/dep-05e58abe.js');
require('../_chunks/dep-4a4a845f.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-888c17ef.js');
require('../_chunks/dep-825271ec.js');
require('../hooks/useResizeObserver.js');
require('../hooks/useLayoutEffect.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-e13830e4.js');
require('../_chunks/dep-24a443af.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../_chunks/dep-dd40281a.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-e3718be1.js');
require('../_chunks/dep-fc852541.js');
require('../hooks/useEventCallback.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Tabs = _util_forwardRefWithStatics["default"](function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, tabs_defaultProps.tabsDefaultProps);
  var defaultValue = props.defaultValue,
    children = props.children,
    list = props.list,
    placement = props.placement,
    tabValue = props.value,
    dragSort = props.dragSort,
    className = props.className,
    style = props.style,
    onRemove = props.onRemove,
    onChange = props.onChange;
  var _useTabClass = tabs_useTabClass.useTabClass(),
    tdTabsClassPrefix = _useTabClass.tdTabsClassPrefix,
    tdTabsClassGenerator = _useTabClass.tdTabsClassGenerator,
    tdClassGenerator = _useTabClass.tdClassGenerator;
  var targetClassNameRegExpStr = "^".concat(tdTabsClassPrefix, "(__nav-item|__nav-item-wrapper|__nav-item-text-wrapper)");
  var _useDragSorter = hooks_useDragSorter["default"](_objectSpread(_objectSpread({}, props), {}, {
      sortOnDraggable: dragSort,
      onDragOverCheck: {
        x: true,
        targetClassNameRegExp: new RegExp(targetClassNameRegExpStr)
      }
    })),
    getDragProps = _useDragSorter.getDragProps;
  var memoChildren = React__default["default"].useMemo(function () {
    if (!list || list.length === 0) {
      return children;
    }
    return list.map(function (panelProps) {
      return /* @__PURE__ */React__default["default"].createElement(tabs_TabPanel["default"], _objectSpread({
        key: panelProps.value
      }, panelProps));
    });
  }, [children, list]);
  var itemList = React__default["default"].Children.map(memoChildren, function (child) {
    if (child && child.type === tabs_TabPanel["default"]) {
      return child.props;
    }
    return null;
  });
  var _React$useState = React__default["default"].useState(function () {
      return defaultValue === void 0 && Array.isArray(itemList) && itemList.length !== 0 ? itemList[0].value : defaultValue;
    }),
    _React$useState2 = slicedToArray._slicedToArray(_React$useState, 2),
    value = _React$useState2[0],
    setValue = _React$useState2[1];
  React.useEffect(function () {
    if (tabValue !== void 0) {
      setValue(tabValue);
    }
  }, [tabValue]);
  var handleChange = React__default["default"].useCallback(function (v) {
    if (tabValue === void 0) {
      setValue(v);
    }
    onChange === null || onChange === void 0 || onChange(v);
  }, [tabValue, onChange]);
  var handleClickTab = React__default["default"].useCallback(function (v) {
    if (tabValue === void 0) {
      setValue(v);
    }
  }, [tabValue]);
  var headerNode = React__default["default"].useMemo(function () {
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: classNames__default["default"](tdTabsClassGenerator("header"), tdClassGenerator("is-".concat(placement)))
    }, /* @__PURE__ */React__default["default"].createElement(tabs_TabNav["default"], _objectSpread(_objectSpread({}, props), {}, {
      getDragProps: getDragProps,
      activeValue: value,
      onRemove: onRemove,
      itemList: itemList,
      tabClick: handleClickTab,
      onChange: handleChange
    })));
  }, [props, getDragProps, value, onRemove, itemList, handleClickTab, handleChange, placement, tdTabsClassGenerator, tdClassGenerator]);
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: classNames__default["default"](tdTabsClassPrefix, className),
    style: style
  }, placement !== "bottom" ? headerNode : null, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"](tdTabsClassGenerator("content"), tdClassGenerator("is-".concat(placement)))
  }, React__default["default"].Children.map(memoChildren, function (child) {
    if (child && child.type === tabs_TabPanel["default"]) {
      return /* @__PURE__ */React__default["default"].createElement(tabs_TabPanel["default"], _objectSpread(_objectSpread({}, child.props), {}, {
        isActive: child.props.value === value
      }));
    }
    return null;
  })), placement === "bottom" ? headerNode : null);
}, {
  TabPanel: tabs_TabPanel["default"]
});
Tabs.displayName = "Tabs";

exports["default"] = Tabs;
//# sourceMappingURL=Tabs.js.map
