/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var toConsumableArray = require('../_chunks/dep-4d46699b.js');
var slicedToArray = require('../_chunks/dep-1135362e.js');
var React = require('react');
var tag_index = require('../tag/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var isFunction = require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-2ebc1a75.js');
require('../tag/Tag.js');
require('../_chunks/dep-d4a1910a.js');
require('classnames');
require('tdesign-icons-react');
require('tinycolor2');
require('../_util/noop.js');
require('../hooks/useGlobalIcon.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../tag/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../tag/CheckTag.js');
require('../_chunks/dep-a844b8f2.js');
require('../_chunks/dep-7603c5b0.js');
require('../_chunks/dep-8ad5b41f.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-825271ec.js');
require('../tag/CheckTagGroup.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useTagList(props) {
  var _useConfig = hooks_useConfig["default"](),
    prefix = _useConfig.classPrefix;
  var onRemove = props.onRemove,
    max = props.max,
    minCollapsedNum = props.minCollapsedNum,
    size = props.size,
    disabled = props.disabled,
    readonly = props.readonly,
    tagProps = props.tagProps,
    tag = props.tag,
    collapsedItems = props.collapsedItems,
    getDragProps = props.getDragProps;
  var _useControlled = hooks_useControlled["default"](props, "value", props.onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    tagValue = _useControlled2[0],
    setTagValue = _useControlled2[1];
  var _useState = React.useState(),
    _useState2 = slicedToArray._slicedToArray(_useState, 2);
    _useState2[0];
    var setOldInputValue = _useState2[1];
  var _onClose = function onClose(p) {
    var arr = toConsumableArray._toConsumableArray(tagValue);
    var _arr$splice = arr.splice(p.index, 1),
      _arr$splice2 = slicedToArray._slicedToArray(_arr$splice, 1),
      item = _arr$splice2[0];
    setTagValue(arr, _objectSpread(_objectSpread({
      trigger: "tag-remove"
    }, p), {}, {
      item: item
    }));
    onRemove === null || onRemove === void 0 || onRemove(_objectSpread(_objectSpread({}, p), {}, {
      item: item,
      trigger: "tag-remove",
      value: arr
    }));
  };
  var clearAll = function clearAll(context) {
    setTagValue([], {
      trigger: "clear",
      e: context.e
    });
  };
  var onInnerEnter = function onInnerEnter(value, context) {
    var _props$onEnter;
    var valueStr = value ? String(value).trim() : "";
    var newValue = tagValue;
    var isLimitExceeded = max && (tagValue === null || tagValue === void 0 ? void 0 : tagValue.length) >= max;
    if (valueStr && !isLimitExceeded) {
      newValue = tagValue instanceof Array ? tagValue.concat(String(valueStr)) : [valueStr];
      setTagValue(newValue, {
        trigger: "enter",
        index: newValue.length - 1,
        item: valueStr,
        e: context.e
      });
    }
    props === null || props === void 0 || (_props$onEnter = props.onEnter) === null || _props$onEnter === void 0 || _props$onEnter.call(props, newValue, _objectSpread(_objectSpread({}, context), {}, {
      inputValue: value
    }));
  };
  var onInputBackspaceKeyUp = function onInputBackspaceKeyUp(value) {
    if (!tagValue || !tagValue.length) return;
    setOldInputValue(value);
  };
  var onInputBackspaceKeyDown = function onInputBackspaceKeyDown(value, context) {
    var e = context.e;
    if (!tagValue || !tagValue.length || readonly) return;
    if (!value && ["Backspace", "NumpadDelete"].includes(e.key)) {
      var index = tagValue.length - 1;
      var item = tagValue[index];
      var trigger = "backspace";
      var newValue = tagValue.slice(0, -1);
      setTagValue(newValue, {
        e: e,
        index: index,
        item: item,
        trigger: trigger
      });
      onRemove === null || onRemove === void 0 || onRemove({
        e: e,
        index: index,
        item: item,
        trigger: trigger,
        value: newValue
      });
    }
  };
  var renderLabel = function renderLabel(_ref) {
    var displayNode = _ref.displayNode,
      label = _ref.label;
    var newList = minCollapsedNum ? tagValue.slice(0, minCollapsedNum) : tagValue;
    var list = displayNode ? [/* @__PURE__ */React__default["default"].createElement(React.Fragment, {
      key: "display-node"
    }, displayNode)] : newList === null || newList === void 0 ? void 0 : newList.map(function (item, index) {
      var tagContent = isFunction.isFunction(tag) ? tag({
        value: item
      }) : tag;
      return /* @__PURE__ */React__default["default"].createElement(tag_index.Tag, _objectSpread(_objectSpread({
        key: index,
        size: size,
        disabled: disabled,
        onClose: function onClose(context) {
          return _onClose({
            e: context.e,
            index: index
          });
        },
        closable: !readonly && !disabled
      }, getDragProps === null || getDragProps === void 0 ? void 0 : getDragProps(index, item)), tagProps), tagContent !== null && tagContent !== void 0 ? tagContent : item);
    });
    if (label) {
      list === null || list === void 0 || list.unshift(/* @__PURE__ */React__default["default"].createElement("div", {
        className: "".concat(prefix, "-tag-input__prefix"),
        key: "label"
      }, label));
    }
    if (newList.length !== tagValue.length) {
      var len = tagValue.length - newList.length;
      var options = Array.isArray(props === null || props === void 0 ? void 0 : props.options) ? props.options : tagValue;
      var params = {
        value: tagValue,
        count: tagValue.length - minCollapsedNum,
        collapsedTags: tagValue.slice(minCollapsedNum, tagValue.length),
        collapsedSelectedItems: options.slice(minCollapsedNum, tagValue.length),
        onClose: _onClose
      };
      var more = isFunction.isFunction(collapsedItems) ? collapsedItems(params) : collapsedItems;
      list.push(/* @__PURE__ */React__default["default"].createElement(React.Fragment, {
        key: "more"
      }, more !== null && more !== void 0 ? more : /* @__PURE__ */React__default["default"].createElement(tag_index.Tag, _objectSpread({
        size: size
      }, tagProps), "+", len)));
    }
    return list;
  };
  return {
    tagValue: tagValue,
    clearAll: clearAll,
    onClose: _onClose,
    onInnerEnter: onInnerEnter,
    onInputBackspaceKeyDown: onInputBackspaceKeyDown,
    onInputBackspaceKeyUp: onInputBackspaceKeyUp,
    renderLabel: renderLabel
  };
}

exports["default"] = useTagList;
//# sourceMappingURL=useTagList.js.map
