/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var classNames = require('classnames');
var React = require('react');
var hooks_useConfig = require('../hooks/useConfig.js');
var timeline_TimelineItem = require('./TimelineItem.js');
var timeline_TimelineContext = require('./TimelineContext.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var timeline_useAlign = require('./useAlign.js');
require('../_chunks/dep-a483aecf.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-e13830e4.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../_chunks/dep-1135362e.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-0030e873.js');
require('../_chunks/dep-5aec375e.js');
require('../_chunks/dep-4d46699b.js');
require('../_chunks/dep-c02b300c.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-e15a33e9.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-24a443af.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-825271ec.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../_chunks/dep-dd40281a.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-e3718be1.js');
require('../_chunks/dep-fc852541.js');
require('hoist-non-react-statics');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var Timeline = _util_forwardRefWithStatics["default"](function (props, ref) {
  var _props$theme = props.theme,
    theme = _props$theme === void 0 ? "default" : _props$theme,
    labelAlign = props.labelAlign,
    children = props.children,
    className = props.className,
    style = props.style,
    _props$reverse = props.reverse,
    reverse = _props$reverse === void 0 ? false : _props$reverse,
    _props$layout = props.layout,
    layout = _props$layout === void 0 ? "vertical" : _props$layout,
    _props$mode = props.mode,
    mode = _props$mode === void 0 ? "alternate" : _props$mode;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var renderAlign = timeline_useAlign.useAlign(labelAlign, layout);
  var timelineItems = React__default["default"].Children.toArray(children).filter(function (child) {
    var _child$type;
    return ((_child$type = child.type) === null || _child$type === void 0 ? void 0 : _child$type.displayName) === timeline_TimelineItem["default"].displayName;
  });
  var itemsStatus = React__default["default"].Children.map(timelineItems, function (child) {
    var _child$props;
    return ((_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.dotColor) || "primary";
  });
  var hasLabelItem = timelineItems.some(function (item) {
    var _item$props;
    return !!(item !== null && item !== void 0 && (_item$props = item.props) !== null && _item$props !== void 0 && _item$props.label);
  });
  if (reverse) {
    timelineItems.reverse();
  }
  var itemsCounts = React__default["default"].Children.count(timelineItems);
  var timelineClassName = classNames__default["default"]("".concat(classPrefix, "-timeline"), defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-timeline-").concat(renderAlign), true), "".concat(classPrefix, "-timeline-reverse"), reverse), "".concat(classPrefix, "-timeline-").concat(layout), true), "".concat(classPrefix, "-timeline-label"), hasLabelItem), "".concat(classPrefix, "-timeline-label--").concat(mode), true), className);
  return /* @__PURE__ */React__default["default"].createElement(timeline_TimelineContext["default"].Provider, {
    value: {
      theme: theme,
      reverse: reverse,
      itemsStatus: itemsStatus,
      layout: layout,
      globalAlign: labelAlign,
      mode: mode
    }
  }, /* @__PURE__ */React__default["default"].createElement("ul", {
    className: timelineClassName,
    style: style,
    ref: ref
  }, React__default["default"].Children.map(timelineItems, function (ele, index) {
    var _ele$props;
    return /*#__PURE__*/React__default["default"].cloneElement(ele, {
      index: index,
      className: classNames__default["default"]([ele === null || ele === void 0 || (_ele$props = ele.props) === null || _ele$props === void 0 ? void 0 : _ele$props.className], defineProperty._defineProperty({}, "".concat(classPrefix, "-timeline-item--last"), index === itemsCounts - 1))
    });
  })));
}, {
  Item: timeline_TimelineItem["default"]
});
Timeline.displayName = "Timeline";

exports["default"] = Timeline;
//# sourceMappingURL=Timeline.js.map
