/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var timeline_TimelineContext = require('./TimelineContext.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var timeline_useAlign = require('./useAlign.js');
var loading_index = require('../loading/index.js');
var omit = require('../_chunks/dep-24a443af.js');
require('../_chunks/dep-a483aecf.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-cfd04a4b.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_chunks/dep-e13830e4.js');
require('../loading/Loading.js');
require('../_chunks/dep-1135362e.js');
require('../_chunks/dep-2ebc1a75.js');
require('../_chunks/dep-2e323406.js');
require('../_chunks/dep-c340510d.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-0030e873.js');
require('../_chunks/dep-5aec375e.js');
require('../_chunks/dep-4d46699b.js');
require('../_chunks/dep-c02b300c.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-e15a33e9.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-825271ec.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../_chunks/dep-dd40281a.js');
require('../_chunks/dep-bacf1f7c.js');
require('../_chunks/dep-e3718be1.js');
require('../_chunks/dep-fc852541.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var DefaultTheme = ["default", "primary", "success", "warning", "error"];
var TimelineItem = function TimelineItem(props) {
  var className = props.className,
    _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    dot = props.dot,
    _props$dotColor = props.dotColor,
    dotColor = _props$dotColor === void 0 ? "primary" : _props$dotColor,
    labelAlign = props.labelAlign,
    children = props.children,
    index = props.index,
    content = props.content,
    label = props.label,
    _props$loading = props.loading,
    loading = _props$loading === void 0 ? false : _props$loading,
    onClick = props.onClick;
  var _useContext = React.useContext(timeline_TimelineContext["default"]),
    theme = _useContext.theme,
    reverse = _useContext.reverse,
    itemsStatus = _useContext.itemsStatus,
    layout = _useContext.layout,
    globalAlign = _useContext.globalAlign,
    mode = _useContext.mode;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var renderAlign = timeline_useAlign.useAlign(globalAlign, layout);
  var getPositionClassName = function getPositionClassName(index2) {
    var left = layout === "horizontal" ? "top" : "left";
    var right = layout === "horizontal" ? "bottom" : "right";
    if (renderAlign === "alternate") {
      return labelAlign || index2 % 2 === 0 ? "".concat(classPrefix, "-timeline-item-").concat(left) : "".concat(classPrefix, "-timeline-item-").concat(right);
    }
    if (renderAlign === "left" || renderAlign === "top") {
      return "".concat(classPrefix, "-timeline-item-").concat(left);
    }
    if (renderAlign === "right" || renderAlign === "bottom") {
      return "".concat(classPrefix, "-timeline-item-").concat(right);
    }
    return "";
  };
  var dotElement = React.useMemo(function () {
    var ele = _util_parseTNode["default"](dot);
    if (/*#__PURE__*/React__default["default"].isValidElement(ele)) {
      var _ele$props;
      return /*#__PURE__*/React__default["default"].cloneElement(ele, {
        className: classNames__default["default"](ele === null || ele === void 0 || (_ele$props = ele.props) === null || _ele$props === void 0 ? void 0 : _ele$props.className, "".concat(classPrefix, "-timeline-item__dot-content"))
      });
    }
    return ele;
  }, [dot, classPrefix]);
  var handleClick = function handleClick(e) {
    onClick === null || onClick === void 0 || onClick({
      e: e,
      item: omit.omit(props, ["children", "index", "onClick"])
    });
  };
  var itemClassName = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-timeline-item"), true), "".concat(getPositionClassName(index)), true), className);
  var tailClassName = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-timeline-item__tail"), true), "".concat(classPrefix, "-timeline-item__tail--theme-").concat(theme), true), "".concat(classPrefix, "-timeline-item__tail--status-").concat(itemsStatus[index]), reverse));
  var dotClassName = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-timeline-item__dot"), true), "".concat(classPrefix, "-timeline-item__dot--custom"), !!dotElement || !dotElement && loading), "".concat(classPrefix, "-timeline-item__dot--").concat(dotColor), DefaultTheme.includes(dotColor)));
  var labelClassName = classNames__default["default"]("".concat(classPrefix, "-timeline-item__label"), defineProperty._defineProperty({}, "".concat(classPrefix, "-timeline-item__label--").concat(mode), true));
  return /* @__PURE__ */React__default["default"].createElement("li", {
    className: itemClassName,
    style: style,
    onClick: handleClick
  }, mode === "alternate" && label && /* @__PURE__ */React__default["default"].createElement("div", {
    className: labelClassName
  }, label), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-timeline-item__wrapper")
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: dotClassName,
    style: {
      borderColor: !DefaultTheme.includes(dotColor) && dotColor
    }
  }, !dotElement && loading && /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, {
    size: "12px",
    className: "".concat(classPrefix, "-timeline-item__dot-content")
  }), dotElement), /* @__PURE__ */React__default["default"].createElement("div", {
    className: tailClassName
  })), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-timeline-item__content")
  }, content || children, mode === "same" && label && /* @__PURE__ */React__default["default"].createElement("div", {
    className: labelClassName
  }, label)));
};
TimelineItem.displayName = "TimelineItem";

exports["default"] = TimelineItem;
//# sourceMappingURL=TimelineItem.js.map
