/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-36f2c0c2.js');
var slicedToArray = require('../_chunks/dep-1135362e.js');
var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var transfer_utils = require('./utils.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var checkbox_index = require('../checkbox/index.js');
var input_index = require('../input/index.js');
var pagination_index = require('../pagination/index.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var isEmpty = require('../_chunks/dep-9c407767.js');
var isFunction = require('../_chunks/dep-cfd04a4b.js');
var isString = require('../_chunks/dep-c340510d.js');
require('../_chunks/dep-a483aecf.js');
require('../_chunks/dep-2ebc1a75.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-62452fcb.js');
require('../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../_chunks/dep-5a0b2388.js');
require('../_chunks/dep-c03abb8d.js');
require('../_chunks/dep-93691cd7.js');
require('../_chunks/dep-4d53c647.js');
require('../_chunks/dep-0d2e37a8.js');
require('../_chunks/dep-24d4266a.js');
require('../_chunks/dep-4422ab9c.js');
require('../_chunks/dep-d5965f49.js');
require('../_chunks/dep-f9fc748e.js');
require('../_chunks/dep-39cfa1e8.js');
require('../_chunks/dep-5a308fe8.js');
require('../_chunks/dep-ab975a03.js');
require('../_chunks/dep-9aa61227.js');
require('../_chunks/dep-bf3c4644.js');
require('../_chunks/dep-810d56ec.js');
require('../_chunks/dep-2f2e3172.js');
require('../_chunks/dep-e121d70e.js');
require('../_chunks/dep-bd0ab4be.js');
require('../_chunks/dep-0da99b78.js');
require('../_chunks/dep-4edddcbd.js');
require('../_chunks/dep-831ea6d9.js');
require('../_chunks/dep-b1179ab2.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../common/Check.js');
require('../_chunks/dep-d4a1910a.js');
require('../_util/helper.js');
require('../_chunks/dep-7e8bb5cc.js');
require('../_chunks/dep-f9468320.js');
require('../_chunks/dep-825271ec.js');
require('../_chunks/dep-7603c5b0.js');
require('../_chunks/dep-8ad5b41f.js');
require('../_chunks/dep-bacf1f7c.js');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-c4b07574.js');
require('../checkbox/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../_chunks/dep-c02b300c.js');
require('../input/Input.js');
require('../hooks/useLayoutEffect.js');
require('../_chunks/dep-2e323406.js');
require('../input/InputGroup.js');
require('../input/defaultProps.js');
require('../input/useLengthLimit.js');
require('../_chunks/dep-e13830e4.js');
require('../_chunks/dep-5aec375e.js');
require('../_chunks/dep-4d46699b.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-bf0e5957.js');
require('../_chunks/dep-349377fd.js');
require('../_chunks/dep-9ee1931f.js');
require('../_chunks/dep-e57f7de9.js');
require('../_chunks/dep-d371704c.js');
require('../_chunks/dep-aca4abf9.js');
require('../_chunks/dep-a422f8bb.js');
require('../pagination/Pagination.js');
require('../select/index.js');
require('../select/base/Select.js');
require('../select/util/helper.js');
require('../select/base/OptionGroup.js');
require('../select/defaultProps.js');
require('../select/base/Option.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-0030e873.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-f3ba9c81.js');
require('../_chunks/dep-8bc1cdb3.js');
require('../common/FakeArrow.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../common/Portal.js');
require('react-dom');
require('../loading/gradient.js');
require('../loading/defaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-e15a33e9.js');
require('../common/PluginContainer.js');
require('../select-input/index.js');
require('../select-input/SelectInput.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../popup/hooks/useTrigger.js');
require('react-is');
require('../_util/ref.js');
require('../_util/isFragment.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c6c72aff.js');
require('../_chunks/dep-05e58abe.js');
require('../_chunks/dep-4a4a845f.js');
require('../_chunks/dep-b6a887a7.js');
require('../_chunks/dep-888c17ef.js');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../popup/PopupPlugin.js');
require('../select-input/useSingle.js');
require('../_chunks/dep-99057d6c.js');
require('../_chunks/dep-08c2f3c4.js');
require('../_chunks/dep-199b9155.js');
require('../_chunks/dep-e3718be1.js');
require('../_chunks/dep-fc852541.js');
require('../select-input/useMultiple.js');
require('../tag-input/index.js');
require('../tag-input/TagInput.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../tag-input/useTagScroll.js');
require('../tag-input/useTagList.js');
require('../tag/index.js');
require('../tag/Tag.js');
require('tinycolor2');
require('../tag/defaultProps.js');
require('../tag/CheckTag.js');
require('../_chunks/dep-a844b8f2.js');
require('../tag/CheckTagGroup.js');
require('../tag-input/useHover.js');
require('../tag-input/defaultProps.js');
require('../select-input/useOverlayInnerStyle.js');
require('../select-input/defaultProps.js');
require('../select/base/PopupContent.js');
require('../select/hooks/usePanelVirtualScroll.js');
require('../hooks/useVirtualScroll.js');
require('../hooks/useResizeObserver.js');
require('../select/hooks/useOptions.js');
require('../input-number/index.js');
require('../input-number/InputNumber.js');
require('../button/index.js');
require('../button/Button.js');
require('../button/defaultProps.js');
require('../input-number/useInputNumber.js');
require('../_chunks/dep-d2f9d8ad.js');
require('../_chunks/dep-fccfa508.js');
require('../hooks/useCommonClassName.js');
require('../input-number/defaultProps.js');
require('../input-adornment/InputAdornment.js');
require('../pagination/hooks/useBoundaryJumper.js');
require('../pagination/hooks/usePrevNextJumper.js');
require('../pagination/hooks/usePageNumber.js');
require('../pagination/hooks/useTotal.js');
require('../pagination/validators.js');
require('../pagination/defaultProps.js');
require('../_chunks/dep-24a443af.js');
require('../_chunks/dep-dd40281a.js');
require('../pagination/PaginationMini.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var TransferList = function TransferList(props) {
  var className = props.className,
    style = props.style,
    data = props.data,
    _props$search = props.search,
    search = _props$search === void 0 ? false : _props$search,
    _props$checked = props.checked,
    checked = _props$checked === void 0 ? [] : _props$checked,
    empty = props.empty,
    title = props.title,
    footer = props.footer,
    content = props.content,
    onCheckbox = props.onCheckbox,
    onSearch = props.onSearch,
    _props$disabled = props.disabled,
    disabled = _props$disabled === void 0 ? false : _props$disabled,
    pagination = props.pagination,
    transferItem = props.transferItem,
    treeNode = props.tree,
    showCheckAll = props.showCheckAll,
    listType = props.listType;
  var notDisabledData = !treeNode ? data.filter(function (item) {
    return !item.disabled;
  }) : transfer_utils.getLeafNodes(data).filter(function (item) {
    return !item.disabled;
  });
  var _useState = React.useState(1),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    currentPage = _useState2[0],
    setCurrentPage = _useState2[1];
  var _useMemo = React.useMemo(function () {
      var activeLen = checked.length;
      var notLen = notDisabledData.length;
      return [activeLen && activeLen < notLen, activeLen && activeLen === notLen];
    }, [checked, notDisabledData]),
    _useMemo2 = slicedToArray._slicedToArray(_useMemo, 2),
    indeterminate = _useMemo2[0],
    allChecked = _useMemo2[1];
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      SearchIcon: tdesignIconsReact.SearchIcon
    }),
    SearchIcon = _useGlobalIcon.SearchIcon;
  var CLASSPREFIX = "".concat(classPrefix, "-transfer__list");
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("transfer"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var handleCheckbox = function handleCheckbox(vals) {
    if (isFunction.isFunction(onCheckbox)) onCheckbox(vals);
  };
  var handleAllCheckbox = function handleAllCheckbox(checked2) {
    if (isFunction.isFunction(onCheckbox)) onCheckbox(checked2 ? notDisabledData.map(function (item) {
      return item.value;
    }) : []);
  };
  var HeaderCmp = function HeaderCmp() {
    var total = treeNode ? transfer_utils.getLeafNodes(data).length : data.length;
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(CLASSPREFIX, "-header")
    }, /* @__PURE__ */React__default["default"].createElement("div", null, showCheckAll ? /* @__PURE__ */React__default["default"].createElement(checkbox_index.Checkbox, {
      indeterminate: indeterminate,
      checked: allChecked,
      disabled: disabled,
      onChange: handleAllCheckbox
    }) : null, /* @__PURE__ */React__default["default"].createElement("span", null, t(local.title, {
      checked: checked.length,
      total: total
    }))), /* @__PURE__ */React__default["default"].createElement("span", null, title));
  };
  var SearchCmp = function SearchCmp() {
    return search ? /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-transfer__search-wrapper")
    }, /* @__PURE__ */React__default["default"].createElement(input_index.Input, {
      placeholder: local.placeholder,
      suffixIcon: /* @__PURE__ */React__default["default"].createElement(SearchIcon, null),
      onChange: onSearch
    })) : null;
  };
  var viewData = React.useMemo(function () {
    if (!isEmpty.isEmpty(pagination)) {
      var pageSize = pagination.pageSize || 10;
      var start = (currentPage - 1) * pageSize;
      return data.slice(start, start + pageSize);
    }
    return data;
  }, [currentPage, data, pagination]);
  var EmptyCmp = function EmptyCmp() {
    return isString.isString(empty) ? /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-transfer__empty")
    }, /* @__PURE__ */React__default["default"].createElement("span", null, empty || "\u6682\u65E0\u6570\u636E")) : empty;
  };
  var contentCmp = function contentCmp() {
    if (typeof treeNode === "function") {
      return treeNode({
        data: viewData,
        value: checked,
        onChange: handleCheckbox
      });
    }
    if (typeof content === "function") {
      return content({
        data: viewData
      });
    }
    return /* @__PURE__ */React__default["default"].createElement(checkbox_index.Checkbox.Group, {
      value: checked,
      onChange: handleCheckbox,
      disabled: disabled
    }, viewData.map(function (item, index) {
      return /* @__PURE__ */React__default["default"].createElement(checkbox_index.Checkbox, {
        key: item.value,
        value: item.value,
        disabled: item.disabled,
        className: "".concat(CLASSPREFIX, "-item")
      }, /* @__PURE__ */React__default["default"].createElement("span", null, transferItem ? _util_parseTNode.parseContentTNode(transferItem, {
        data: item,
        index: index,
        type: listType
      }) : item.label));
    }));
  };
  var BodyCmp = function BodyCmp() {
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: classNames__default["default"]("".concat(CLASSPREFIX, "-body"), defineProperty._defineProperty({}, "".concat(CLASSPREFIX, "--with-search"), search))
    }, SearchCmp(), /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(CLASSPREFIX, "-content narrow-scrollbar")
    }, viewData.length ? contentCmp() : EmptyCmp()));
  };
  var PaginationCmp = function PaginationCmp() {
    var handleCurrentPagination = function handleCurrentPagination(current) {
      setCurrentPage(current);
      if (isFunction.isFunction(pagination.onPageChange)) {
        pagination.onPageChange(current);
      }
    };
    return pagination ? /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(CLASSPREFIX, "-pagination")
    }, /* @__PURE__ */React__default["default"].createElement(pagination_index.Pagination, {
      size: "small",
      theme: "simple",
      pageSizeOptions: [],
      total: data.length,
      totalContent: false,
      onCurrentChange: handleCurrentPagination,
      pageSize: pagination.pageSize
    })) : null;
  };
  var footerCmp = function footerCmp() {
    return !isEmpty.isEmpty(footer) ? /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-transfer__footer")
    }, footer) : null;
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    style: style,
    className: classNames__default["default"](CLASSPREFIX, className)
  }, HeaderCmp(), BodyCmp(), PaginationCmp(), footerCmp());
};

exports["default"] = TransferList;
//# sourceMappingURL=TransferList.js.map
