/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-36f2c0c2.js');
var React = require('react');
var treeStore = require('../../_chunks/dep-2964015e.js');
var hooks_usePersistFn = require('../../hooks/usePersistFn.js');
var treeSelect_defaultProps = require('../defaultProps.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-ce434e16.js');
require('mitt');
require('../../_chunks/dep-0de56bba.js');
require('../../_chunks/dep-e15a33e9.js');
require('../../_chunks/dep-4d46699b.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-e13830e4.js');
require('../../_chunks/dep-99057d6c.js');
require('../../_chunks/dep-8bc1cdb3.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-08c2f3c4.js');
require('../../_chunks/dep-810d56ec.js');
require('../../_chunks/dep-2f2e3172.js');
require('../../_chunks/dep-39cfa1e8.js');
require('../../_chunks/dep-199b9155.js');
require('../../_chunks/dep-93691cd7.js');
require('../../_chunks/dep-d5965f49.js');
require('../../_chunks/dep-e3718be1.js');
require('../../_chunks/dep-fc852541.js');
require('../../_chunks/dep-e57f7de9.js');
require('../../_chunks/dep-0da99b78.js');
require('../../_chunks/dep-c4b07574.js');
require('../../_chunks/dep-24a443af.js');
require('../../_chunks/dep-349377fd.js');
require('../../_chunks/dep-c03abb8d.js');
require('../../_chunks/dep-4422ab9c.js');
require('../../_chunks/dep-f9fc748e.js');
require('../../_chunks/dep-e121d70e.js');
require('../../_chunks/dep-9ee1931f.js');
require('../../_chunks/dep-d371704c.js');
require('../../_chunks/dep-aca4abf9.js');
require('../../_chunks/dep-a422f8bb.js');
require('../../_chunks/dep-dd40281a.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../_chunks/dep-4edddcbd.js');
require('../../_chunks/dep-fccfa508.js');
require('../../_chunks/dep-c02b300c.js');
require('../../_chunks/dep-f3ba9c81.js');
require('../../_chunks/dep-1b417134.js');
require('../../_chunks/dep-a3296643.js');
require('../../_chunks/dep-c340510d.js');
require('../../_chunks/dep-4a0537fa.js');
require('../../_chunks/dep-d12ca794.js');
require('../../_chunks/dep-05e58abe.js');
require('../../_chunks/dep-98484f3b.js');
require('../../_chunks/dep-bd0ab4be.js');
require('../../_chunks/dep-7e8bb5cc.js');
require('../../_chunks/dep-7603c5b0.js');
require('../../_chunks/dep-8ad5b41f.js');

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var useTreeSelectUtils = function useTreeSelectUtils(_ref, treeRef) {
  var data = _ref.data,
    treeProps = _ref.treeProps,
    valueType = _ref.valueType;
  var defaultStore = React.useMemo(function () {
    var store = new treeStore.TreeStore(_objectSpread(_objectSpread({}, treeSelect_defaultProps.treeSelectDefaultProps.treeProps), treeProps));
    store.append(data);
    return store;
  }, [data, treeProps]);
  var getNodeItem = hooks_usePersistFn.usePersistFn(function (value) {
    var _defaultStore$getNode;
    if (treeRef.current) {
      return treeRef.current.getItem(value);
    }
    return (_defaultStore$getNode = defaultStore.getNode(value)) === null || _defaultStore$getNode === void 0 ? void 0 : _defaultStore$getNode.getModel();
  });
  var formatValue = hooks_usePersistFn.usePersistFn(function (value) {
    var _treeProps$keys$value, _treeProps$keys, _treeProps$keys$label, _treeProps$keys2;
    var label = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : String(value);
    var valueKey = (_treeProps$keys$value = treeProps === null || treeProps === void 0 || (_treeProps$keys = treeProps.keys) === null || _treeProps$keys === void 0 ? void 0 : _treeProps$keys.value) !== null && _treeProps$keys$value !== void 0 ? _treeProps$keys$value : "value";
    var labelKey = (_treeProps$keys$label = treeProps === null || treeProps === void 0 || (_treeProps$keys2 = treeProps.keys) === null || _treeProps$keys2 === void 0 ? void 0 : _treeProps$keys2.label) !== null && _treeProps$keys$label !== void 0 ? _treeProps$keys$label : "label";
    return value && valueType === "object" ? defineProperty._defineProperty(defineProperty._defineProperty({}, valueKey, value), labelKey, label) : value;
  });
  var normalizeValue = hooks_usePersistFn.usePersistFn(function (value) {
    var _treeProps$keys$value2, _treeProps$keys3, _treeProps$keys$label2, _treeProps$keys4, _ref3, _node$label;
    var valueKey = (_treeProps$keys$value2 = treeProps === null || treeProps === void 0 || (_treeProps$keys3 = treeProps.keys) === null || _treeProps$keys3 === void 0 ? void 0 : _treeProps$keys3.value) !== null && _treeProps$keys$value2 !== void 0 ? _treeProps$keys$value2 : "value";
    var labelKey = (_treeProps$keys$label2 = treeProps === null || treeProps === void 0 || (_treeProps$keys4 = treeProps.keys) === null || _treeProps$keys4 === void 0 ? void 0 : _treeProps$keys4.label) !== null && _treeProps$keys$label2 !== void 0 ? _treeProps$keys$label2 : "label";
    var realValue = valueType === "value" ? value : value === null || value === void 0 ? void 0 : value[valueKey];
    var node = getNodeItem(realValue);
    var realLabel = valueType === "object" ? value === null || value === void 0 ? void 0 : value[labelKey] : void 0;
    return {
      value: realValue,
      label: (_ref3 = (_node$label = node === null || node === void 0 ? void 0 : node.label) !== null && _node$label !== void 0 ? _node$label : realLabel) !== null && _ref3 !== void 0 ? _ref3 : String(realValue)
    };
  });
  return {
    getNodeItem: getNodeItem,
    formatValue: formatValue,
    normalizeValue: normalizeValue
  };
};

exports.useTreeSelectUtils = useTreeSelectUtils;
//# sourceMappingURL=useTreeSelectUtils.js.map
