/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-1135362e.js');
var React = require('react');
var treeStore = require('../../_chunks/dep-2964015e.js');
var hooks_useUpdateLayoutEffect = require('../../hooks/useUpdateLayoutEffect.js');
var hooks_usePrevious = require('../../hooks/usePrevious.js');
var hooks_usePersistFn = require('../../hooks/usePersistFn.js');
var cloneDeep = require('../../_chunks/dep-bf0e5957.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-36f2c0c2.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-ce434e16.js');
require('mitt');
require('../../_chunks/dep-0de56bba.js');
require('../../_chunks/dep-e15a33e9.js');
require('../../_chunks/dep-4d46699b.js');
require('../../_chunks/dep-e13830e4.js');
require('../../_chunks/dep-99057d6c.js');
require('../../_chunks/dep-8bc1cdb3.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-08c2f3c4.js');
require('../../_chunks/dep-810d56ec.js');
require('../../_chunks/dep-2f2e3172.js');
require('../../_chunks/dep-39cfa1e8.js');
require('../../_chunks/dep-199b9155.js');
require('../../_chunks/dep-93691cd7.js');
require('../../_chunks/dep-d5965f49.js');
require('../../_chunks/dep-e3718be1.js');
require('../../_chunks/dep-fc852541.js');
require('../../_chunks/dep-e57f7de9.js');
require('../../_chunks/dep-0da99b78.js');
require('../../_chunks/dep-c4b07574.js');
require('../../_chunks/dep-24a443af.js');
require('../../_chunks/dep-349377fd.js');
require('../../_chunks/dep-c03abb8d.js');
require('../../_chunks/dep-4422ab9c.js');
require('../../_chunks/dep-f9fc748e.js');
require('../../_chunks/dep-e121d70e.js');
require('../../_chunks/dep-9ee1931f.js');
require('../../_chunks/dep-d371704c.js');
require('../../_chunks/dep-aca4abf9.js');
require('../../_chunks/dep-a422f8bb.js');
require('../../_chunks/dep-dd40281a.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../_chunks/dep-4edddcbd.js');
require('../../_chunks/dep-fccfa508.js');
require('../../_chunks/dep-c02b300c.js');
require('../../_chunks/dep-f3ba9c81.js');
require('../../_chunks/dep-1b417134.js');
require('../../_chunks/dep-a3296643.js');
require('../../_chunks/dep-c340510d.js');
require('../../_chunks/dep-4a0537fa.js');
require('../../_chunks/dep-d12ca794.js');
require('../../_chunks/dep-05e58abe.js');
require('../../_chunks/dep-98484f3b.js');
require('../../_chunks/dep-bd0ab4be.js');
require('../../_chunks/dep-7e8bb5cc.js');
require('../../_chunks/dep-7603c5b0.js');
require('../../_chunks/dep-8ad5b41f.js');
require('../../hooks/useIsFirstRender.js');
require('../../hooks/useLayoutEffect.js');
require('../../_chunks/dep-2e323406.js');

function useStore(props, refresh) {
  var storeRef = React.useRef(null);
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    filterChanged = _useState2[0],
    toggleFilterChanged = _useState2[1];
  var _useState3 = React.useState(null),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    prevExpanded = _useState4[0],
    changePrevExpanded = _useState4[1];
  var data = props.data,
    keys = props.keys,
    expandAll = props.expandAll,
    expandParent = props.expandParent,
    expanded = props.expanded,
    expandLevel = props.expandLevel,
    expandMutex = props.expandMutex,
    activable = props.activable,
    activeMultiple = props.activeMultiple,
    actived = props.actived,
    disabled = props.disabled,
    draggable = props.draggable,
    checkable = props.checkable,
    value = props.value,
    checkStrictly = props.checkStrictly,
    load = props.load,
    lazy = props.lazy,
    valueMode = props.valueMode,
    filter = props.filter,
    _onLoad = props.onLoad,
    indeterminate = props.indeterminate,
    setTreeIndeterminate = props.setTreeIndeterminate,
    _props$allowFoldNodeO = props.allowFoldNodeOnFilter,
    allowFoldNodeOnFilter = _props$allowFoldNodeO === void 0 ? false : _props$allowFoldNodeO;
  var preFilter = hooks_usePrevious["default"](filter);
  React.useEffect(function () {
    if (!allowFoldNodeOnFilter) return;
    toggleFilterChanged(JSON.stringify(preFilter) !== JSON.stringify(filter));
  }, [filter, allowFoldNodeOnFilter]);
  var expandFilterPath = function expandFilterPath() {
    if (!allowFoldNodeOnFilter || !filterChanged) return;
    toggleFilterChanged(false);
    var store2 = storeRef.current;
    if (props.filter) {
      if (!prevExpanded) changePrevExpanded(store2.getExpanded());
      var pathValues = [];
      var allNodes = store2.getNodes();
      allNodes.forEach(function (node) {
        if (node.vmIsLocked) {
          pathValues.push(node.value);
        }
      });
      store2.setExpanded(pathValues);
    } else if (prevExpanded) {
      store2.replaceExpanded(prevExpanded);
      changePrevExpanded(null);
    }
  };
  var handleUpdate = hooks_usePersistFn.usePersistFn(function () {
    expandFilterPath();
    refresh();
  });
  var getExpandedArr = function getExpandedArr(arr, store2) {
    var expandedMap = /* @__PURE__ */new Map();
    arr.forEach(function (val) {
      expandedMap.set(val, true);
      if (expandParent) {
        var node = store2.getNode(val);
        node === null || node === void 0 || node.getParents().forEach(function (tn) {
          expandedMap.set(tn.value, true);
        });
      }
    });
    return Array.from(expandedMap.keys());
  };
  var createStore = function createStore() {
    var store2 = new treeStore.TreeStore({
      keys: keys,
      activable: activable,
      activeMultiple: activeMultiple,
      checkable: checkable,
      checkStrictly: checkStrictly,
      expandAll: expandAll,
      expandLevel: expandLevel,
      expandMutex: expandMutex,
      expandParent: expandParent,
      disabled: disabled,
      draggable: draggable,
      load: load,
      lazy: lazy,
      valueMode: valueMode,
      filter: filter,
      onLoad: function onLoad(info) {
        var node = info.node;
        _onLoad === null || _onLoad === void 0 || _onLoad({
          node: node.getModel()
        });
      },
      onUpdate: handleUpdate,
      allowFoldNodeOnFilter: allowFoldNodeOnFilter
    });
    var list = cloneDeep.cloneDeep(data);
    if (!Array.isArray(list)) {
      list = [];
    }
    store2.append(list);
    store2.refreshNodes();
    if (Array.isArray(value)) {
      store2.setChecked(value);
    }
    if (Array.isArray(expanded)) {
      var expandedArr = getExpandedArr(expanded, store2);
      store2.setExpanded(expandedArr);
    }
    if (Array.isArray(actived)) {
      store2.setActived(actived);
    }
    store2.refreshNodes();
    return store2;
  };
  if (!storeRef.current) {
    storeRef.current = createStore();
  }
  var store = storeRef.current;
  hooks_useUpdateLayoutEffect["default"](function () {
    if (data && Array.isArray(data)) {
      var expanded2 = store.getExpanded();
      var checked = store.getChecked();
      var actived2 = store.getActived();
      store.removeAll();
      store.append(data);
      store.setChecked(checked);
      store.setActived(actived2);
      store.setExpanded(expanded2);
    }
  }, [data, store]);
  hooks_useUpdateLayoutEffect["default"](function () {
    store.setConfig({
      keys: keys,
      expandAll: expandAll,
      expandLevel: expandLevel,
      expandMutex: expandMutex,
      expandParent: expandParent,
      activable: activable,
      activeMultiple: activeMultiple,
      disabled: disabled,
      checkable: checkable,
      draggable: draggable,
      checkStrictly: checkStrictly,
      load: load,
      lazy: lazy,
      valueMode: valueMode
    });
    store.refreshState();
  }, [activable, activeMultiple, checkStrictly, draggable, checkable, disabled, expandAll, expandLevel, expandMutex, expandParent, keys, lazy, load, store, valueMode]);
  hooks_useUpdateLayoutEffect["default"](function () {
    if (expandAll) {
      var valueList = store.getNodes().filter(function (node) {
        return Array.isArray(node.children) && node.children.length;
      }).map(function (node) {
        return node.value;
      });
      store.setExpanded(valueList);
    } else {
      store.replaceExpanded(prevExpanded);
      changePrevExpanded(null);
    }
  }, [store, expandAll]);
  hooks_useUpdateLayoutEffect["default"](function () {
    if (Array.isArray(value)) {
      store.replaceChecked(value);
      var checkedValue = store.getCheckedNodes().map(function (v) {
        return v.data[(keys === null || keys === void 0 ? void 0 : keys.value) || "value"];
      });
      var indeterminateConflict = checkedValue.filter(function (v) {
        return indeterminate.includes(v);
      });
      if (indeterminateConflict.length) {
        setTreeIndeterminate(indeterminate.filter(function (v) {
          return !indeterminateConflict.includes(v);
        }));
      }
    }
  }, [store, value, data]);
  hooks_useUpdateLayoutEffect["default"](function () {
    if (Array.isArray(expanded)) {
      var expandedArr = getExpandedArr(expanded, store);
      store.replaceExpanded(expandedArr);
    }
  }, [expanded, store]);
  hooks_useUpdateLayoutEffect["default"](function () {
    if (Array.isArray(actived)) {
      store.replaceActived(actived);
    }
  }, [actived, store]);
  hooks_useUpdateLayoutEffect["default"](function () {
    if (Array.isArray(indeterminate)) {
      store.replaceIndeterminate(indeterminate);
    }
  }, [indeterminate, store, data]);
  hooks_useUpdateLayoutEffect["default"](function () {
    store.setConfig({
      filter: filter
    });
    store.updateAll();
  }, [filter, store]);
  return storeRef.current;
}

exports.useStore = useStore;
//# sourceMappingURL=useStore.js.map
