/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-36f2c0c2.js');
var slicedToArray = require('../../_chunks/dep-1135362e.js');
var objectWithoutProperties = require('../../_chunks/dep-d4a1910a.js');
var React = require('react');
var classNames = require('classnames');
var typography_ellipsis_Truncate = require('./Truncate.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
require('../../_chunks/dep-a483aecf.js');
require('../../_chunks/dep-2ebc1a75.js');
require('../../_chunks/dep-ce434e16.js');
require('react-is');
require('../../_chunks/dep-24a443af.js');
require('../../_chunks/dep-f9468320.js');
require('../../_chunks/dep-4d53c647.js');
require('../../_chunks/dep-24d4266a.js');
require('../../_chunks/dep-825271ec.js');
require('../../_chunks/dep-0d2e37a8.js');
require('../../_chunks/dep-349377fd.js');
require('../../_chunks/dep-c03abb8d.js');
require('../../_chunks/dep-93691cd7.js');
require('../../_chunks/dep-4422ab9c.js');
require('../../_chunks/dep-d5965f49.js');
require('../../_chunks/dep-cfd04a4b.js');
require('../../_chunks/dep-9aa61227.js');
require('../../_chunks/dep-f9fc748e.js');
require('../../_chunks/dep-39cfa1e8.js');
require('../../_chunks/dep-5a308fe8.js');
require('../../_chunks/dep-ab975a03.js');
require('../../_chunks/dep-bf3c4644.js');
require('../../_chunks/dep-810d56ec.js');
require('../../_chunks/dep-2f2e3172.js');
require('../../_chunks/dep-e121d70e.js');
require('../../_chunks/dep-9ee1931f.js');
require('../../_chunks/dep-e57f7de9.js');
require('../../_chunks/dep-d371704c.js');
require('../../_chunks/dep-aca4abf9.js');
require('../../_chunks/dep-a422f8bb.js');
require('../../_chunks/dep-8bc1cdb3.js');
require('../../_chunks/dep-dd40281a.js');
require('../../_chunks/dep-bacf1f7c.js');
require('../../_chunks/dep-4edddcbd.js');
require('../../_chunks/dep-e3718be1.js');
require('../../_chunks/dep-fc852541.js');
require('../../_chunks/dep-0da99b78.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-62452fcb.js');
require('../../_chunks/dep-6a2c14e7.js');
require('dayjs');
require('../../_chunks/dep-5a0b2388.js');
require('../../_chunks/dep-bd0ab4be.js');
require('../../_chunks/dep-831ea6d9.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["className", "children", "lines", "ellipsisClassName", "ellipsisPrefix", "onToggleExpand", "width", "onTruncate", "component", "collapsible", "expandable", "more", "less"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Ellipsis = function Ellipsis(_ref) {
  var className = _ref.className,
    children = _ref.children,
    _ref$lines = _ref.lines,
    lines = _ref$lines === void 0 ? 1 : _ref$lines,
    ellipsisClassName = _ref.ellipsisClassName,
    _ref$ellipsisPrefix = _ref.ellipsisPrefix,
    ellipsisPrefix = _ref$ellipsisPrefix === void 0 ? "..." : _ref$ellipsisPrefix,
    onToggleExpand = _ref.onToggleExpand,
    _ref$width = _ref.width,
    width = _ref$width === void 0 ? 0 : _ref$width,
    onTruncate = _ref.onTruncate,
    _ref$component = _ref.component,
    Component = _ref$component === void 0 ? "div" : _ref$component,
    _ref$collapsible = _ref.collapsible,
    collapsible = _ref$collapsible === void 0 ? false : _ref$collapsible,
    _ref$expandable = _ref.expandable,
    expandable = _ref$expandable === void 0 ? false : _ref$expandable,
    more = _ref.more,
    less = _ref.less,
    rest = objectWithoutProperties._objectWithoutProperties(_ref, _excluded);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var symbolClassName = ellipsisClassName || "".concat(classPrefix, "-typography-ellipsis-symbol");
  var isMountRef = React.useRef(false);
  React.useEffect(function () {
    isMountRef.current = true;
  }, []);
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    isExpanded = _useState2[0],
    setIsExpanded = _useState2[1];
  var handleToggleExpand = function handleToggleExpand(e) {
    if (!expandable) return;
    if (isMountRef.current) {
      setIsExpanded(!isExpanded);
      onToggleExpand === null || onToggleExpand === void 0 || onToggleExpand(!isExpanded, e);
    }
  };
  var truncateRef = React.useRef(null);
  var _useState3 = React.useState(false),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    isTruncated = _useState4[0],
    setTruncated = _useState4[1];
  var handleTruncate = function handleTruncate(truncated) {
    if (isMountRef.current && truncated !== isTruncated) {
      setTruncated(truncated);
      if (truncated && truncateRef.current) {
        var _truncateRef$current$, _truncateRef$current;
        (_truncateRef$current$ = (_truncateRef$current = truncateRef.current).onResize) === null || _truncateRef$current$ === void 0 || _truncateRef$current$.call(_truncateRef$current);
      }
      onTruncate === null || onTruncate === void 0 || onTruncate(truncated);
    }
  };
  var componentProps = _objectSpread({
    className: className
  }, rest);
  return /* @__PURE__ */React__default["default"].createElement(Component, _objectSpread({}, componentProps), /* @__PURE__ */React__default["default"].createElement(typography_ellipsis_Truncate["default"], {
    width: width,
    lines: !isExpanded && lines,
    className: "".concat(classPrefix, "-typography-ellipsis"),
    ellipsis: /* @__PURE__ */React__default["default"].createElement("span", {
      className: "".concat(classPrefix, "-typography-ellipsis-symbol-wrapper")
    }, ellipsisPrefix, /* @__PURE__ */React__default["default"].createElement("span", {
      className: symbolClassName,
      onClick: handleToggleExpand
    }, more)),
    onTruncate: handleTruncate,
    ref: truncateRef,
    lineClassName: "".concat(classPrefix, "-typography-ellipsis-line")
  }, children), !isTruncated && collapsible && isExpanded && /* @__PURE__ */React__default["default"].createElement("span", {
    className: classNames__default["default"](symbolClassName, "".concat(symbolClassName, "--expanded")),
    onClick: handleToggleExpand
  }, less));
};

exports["default"] = Ellipsis;
//# sourceMappingURL=Ellipsis.js.map
