import { MouseEventHandler } from 'react';
export type PositionType = [number, number];
interface UsePositionArg {
    initPosition?: PositionType;
    move?: boolean;
    computed?: (XY: PositionType, screenXY: PositionType, oldXY: PositionType) => PositionType;
    onMouseUp?: (event?: MouseEvent) => void;
    onMouseMove?: (event?: MouseEvent) => void;
    onMouseDown?: (event?: MouseEventHandler<HTMLDivElement>) => void;
}
declare const usePosition: ({ initPosition, move, onMouseUp: onEnd, onMouseMove: onUpdate, onMouseDown: onStart }: UsePositionArg, $dom?: HTMLElement | Document) => [PositionType, MouseEventHandler<HTMLDivElement>];
export default usePosition;
