/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import classNames from 'classnames';
import useConfig from '../hooks/useConfig.js';
import { cacularPaddingLeft } from './_util/cacularPaddingLeft.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-f105ca38.js';
import '../_chunks/dep-bff1a51f.js';
import 'lodash-es';
import '../locale/zh_CN.js';
import '../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../_chunks/dep-3c66615e.js';

var MenuGroup = function MenuGroup(_ref) {
  var title = _ref.title,
    children = _ref.children,
    _ref$level = _ref.level,
    level = _ref$level === void 0 ? 1 : _ref$level;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var itemAndGroupPaddingBias = 28;
  var menuPaddingLeft = cacularPaddingLeft(level - 1) - itemAndGroupPaddingBias;
  return /* @__PURE__ */React.createElement("div", {
    className: classNames("".concat(classPrefix, "-menu-group"))
  }, /* @__PURE__ */React.createElement("div", {
    className: classNames("".concat(classPrefix, "-menu-group__title")),
    style: {
      paddingLeft: "".concat(menuPaddingLeft, "px")
    }
  }, title), children);
};
MenuGroup.displayName = "MenuGroup";

export { MenuGroup as default };
//# sourceMappingURL=MenuGroup.js.map
