import { ReactNode } from 'react';
import { SetMenuState, MenuMode } from '../MenuContext';
import { TdMenuProps, TdHeadMenuProps, MenuValue } from '../type';
interface UseMenuContextProps extends Extract<TdMenuProps, TdHeadMenuProps> {
    children: ReactNode;
    mode: MenuMode;
}
declare function useMenuContext({ defaultValue, defaultExpanded, expandMutex, children, onExpand, onChange, value, expanded, collapsed, expandType, theme, mode, }: UseMenuContextProps): {
    value: {
        onExpand: (value: MenuValue, expanded: MenuValue[]) => void;
        onChange: (value: MenuValue) => void;
        active: MenuValue;
        expanded: MenuValue[];
        collapsed: boolean;
        setState: SetMenuState;
        expandMutex: boolean;
        expandType: "normal" | "popup";
        mode: MenuMode;
        theme: "dark" | "light";
    };
};
export default useMenuContext;
