/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import classNames from 'classnames';
import { CloseIcon } from 'tdesign-icons-react';
import useGlobalIcon from '../hooks/useGlobalIcon.js';
import { useMessageClass } from './useMessageClass.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-f105ca38.js';
import '../_chunks/dep-bff1a51f.js';
import 'lodash-es';
import '../locale/zh_CN.js';
import '../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../_chunks/dep-3c66615e.js';

function MessageClose(_ref) {
  var closeBtn = _ref.closeBtn,
    onCloseBtnClick = _ref.onCloseBtnClick;
  var _useMessageClass = useMessageClass(),
    tdMessageClassGenerator = _useMessageClass.tdMessageClassGenerator;
  var _useGlobalIcon = useGlobalIcon({
      CloseIcon: CloseIcon
    }),
    CloseIcon$1 = _useGlobalIcon.CloseIcon;
  var relCloseBtn = closeBtn;
  if (typeof closeBtn === "function") {
    relCloseBtn = closeBtn();
  }
  if (!relCloseBtn) {
    return null;
  }
  if (typeof relCloseBtn === "string" || typeof relCloseBtn === "number") {
    return /* @__PURE__ */React.createElement("span", {
      className: tdMessageClassGenerator("close"),
      onClick: function onClick(e) {
        return onCloseBtnClick === null || onCloseBtnClick === void 0 ? void 0 : onCloseBtnClick({
          e: e
        });
      }
    }, closeBtn);
  }
  if (/*#__PURE__*/React.isValidElement(relCloseBtn)) {
    var _onClick = relCloseBtn.props.onClick;
    return /*#__PURE__*/React.cloneElement(relCloseBtn, {
      className: classNames(relCloseBtn.props.className, tdMessageClassGenerator("close")),
      onClick: function onClick(e) {
        _onClick === null || _onClick === void 0 || _onClick(e);
        onCloseBtnClick === null || onCloseBtnClick === void 0 || onCloseBtnClick({
          e: e
        });
      }
    });
  }
  return /* @__PURE__ */React.createElement(CloseIcon$1, {
    className: tdMessageClassGenerator("close"),
    onClick: function onClick(e) {
      return onCloseBtnClick === null || onCloseBtnClick === void 0 ? void 0 : onCloseBtnClick({
        e: e
      });
    }
  });
}

export { MessageClose as default };
//# sourceMappingURL=MessageClose.js.map
