/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import { CheckCircleFilledIcon, ErrorCircleFilledIcon, HelpCircleFilledIcon, InfoCircleFilledIcon } from 'tdesign-icons-react';
import useGlobalIcon from '../hooks/useGlobalIcon.js';
import { Loading } from '../loading/index.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-f105ca38.js';
import '../_chunks/dep-bff1a51f.js';
import 'lodash-es';
import '../locale/zh_CN.js';
import '../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../_chunks/dep-3c66615e.js';
import '../loading/Loading.js';
import '../_chunks/dep-4501cb83.js';
import '../_chunks/dep-34d8fc80.js';
import 'classnames';
import '../_chunks/dep-4fb528b6.js';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-8e2b9778.js';
import '../_chunks/dep-c1de0c2f.js';
import '../_chunks/dep-a5c7489a.js';
import '../_chunks/dep-5462fae6.js';
import '../hooks/useDomRefCallback.js';
import '../loading/defaultProps.js';
import '../hooks/useDefaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-036ea6a5.js';
import '../common/PluginContainer.js';
import '../config-provider/index.js';
import '../config-provider/ConfigProvider.js';
import '../config-provider/type.js';
import '../loading/style/css.js';
import '../loading/type.js';

function MessageIcon(_ref) {
  var theme = _ref.theme,
    onCloseBtnClick = _ref.onCloseBtnClick;
  var _useGlobalIcon = useGlobalIcon({
      CheckCircleFilledIcon: CheckCircleFilledIcon,
      ErrorCircleFilledIcon: ErrorCircleFilledIcon,
      HelpCircleFilledIcon: HelpCircleFilledIcon,
      InfoCircleFilledIcon: InfoCircleFilledIcon
    }),
    CheckCircleFilledIcon$1 = _useGlobalIcon.CheckCircleFilledIcon,
    ErrorCircleFilledIcon$1 = _useGlobalIcon.ErrorCircleFilledIcon,
    HelpCircleFilledIcon$1 = _useGlobalIcon.HelpCircleFilledIcon,
    InfoCircleFilledIcon$1 = _useGlobalIcon.InfoCircleFilledIcon;
  var iconMap = {
    info: InfoCircleFilledIcon$1,
    success: CheckCircleFilledIcon$1,
    warning: ErrorCircleFilledIcon$1,
    error: ErrorCircleFilledIcon$1,
    question: HelpCircleFilledIcon$1,
    loading: Loading
  };
  var Icon = iconMap[theme];
  if (theme === "loading") {
    return /* @__PURE__ */React.createElement(Icon, {
      loading: true
    });
  }
  return Icon ? /* @__PURE__ */React.createElement(Icon, {
    onClick: function onClick(e) {
      return onCloseBtnClick === null || onCloseBtnClick === void 0 ? void 0 : onCloseBtnClick({
        e: e
      });
    }
  }) : null;
}

export { MessageIcon as default };
//# sourceMappingURL=MessageIcon.js.map
