import { MessageOptions } from './type';
/**
 * @name: globalConfig
 * @description: message 组件全局的默认配置
 * */
export declare const globalConfig: {
    top: number;
};
/**
 * @name: getMessageConfig
 * @description: 组合 currentOptions 和 defaultConfig 拼装成最终生效的 options
 * 保证所有的配置出口都通过该函数，当后续封装 globalConfig 时从此处添加即可全局生效
 * @param: options MessageOptions
 * @return: MessageOptions
 * @todo: options 合法性检测
 * */
export declare const getMessageConfig: (options: MessageOptions) => MessageOptions;
/**
 * @name: setGlobalConfig
 * @description: 设置全局配置
 * */
export declare const setGlobalConfig: (options: MessageOptions) => void;
/**
 * @name: getMessageDefaultConfig
 * @description: 获取默认的消息配置，不允许更改
 * @return: MessageOptions
 * */
export declare const getMessageDefaultConfig: () => MessageOptions;
