import React from 'react';
import { TdSpaceProps } from './type';
import { StyledProps } from '../common';
export declare const SizeMap: {
    small: string;
    medium: string;
    large: string;
};
export interface SpaceProps extends TdSpaceProps, StyledProps {
    children?: React.ReactNode;
    /** 强制使用 margin 间距代替 gap 属性间距（某些浏览器不支持 gap 属性） */
    forceFlexGapPolyfill?: boolean;
}
declare const Space: React.ForwardRefExoticComponent<SpaceProps & React.RefAttributes<HTMLDivElement>>;
export default Space;
