/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../../_chunks/dep-4501cb83.js';
import { useCallback } from 'react';
import useConfig from '../../hooks/useConfig.js';
import '../../_chunks/dep-34d8fc80.js';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-f105ca38.js';
import '../../_chunks/dep-bff1a51f.js';
import 'lodash-es';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../../_chunks/dep-3c66615e.js';

function usePrefixClass() {
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  return useCallback(function () {
    var className = "";
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    args.forEach(function (item, index) {
      if (item && index > 0) className = className.concat(" ");
      if (item instanceof Array) {
        var _item = _slicedToArray(item, 3),
          block = _item[0],
          element = _item[1],
          modifier = _item[2];
        className = className.concat(classPrefix, "-", block);
        if (element) className = className.concat("__", element);
        if (modifier) className = className.concat("--", modifier);
      } else if (typeof item === "string") {
        className = className.concat(classPrefix, "-", item);
      }
    });
    return className;
  }, [classPrefix]);
}

export { usePrefixClass as default };
//# sourceMappingURL=usePrefixClass.js.map
