/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../../../_chunks/dep-f105ca38.js';
import { _ as _slicedToArray } from '../../../../_chunks/dep-4501cb83.js';
import React, { useState } from 'react';
import { g as getColorFormatOptions, F as FormatInputs } from '../../../../_chunks/dep-6edbe417.js';
import { Select } from '../../../../select/index.js';
import '../../../../_chunks/dep-bff1a51f.js';
import '../../../../_chunks/dep-34d8fc80.js';
import 'lodash-es';
import '../../../../_chunks/dep-c4d83876.js';
import '../../../../_chunks/dep-c2712c76.js';
import 'tinycolor2';
import '../../../../_chunks/dep-11560925.js';
import '../../../../_chunks/dep-a5c7489a.js';
import '../../../../input/index.js';
import '../../../../input/Input.js';
import '../../../../_chunks/dep-5462fae6.js';
import 'classnames';
import 'tdesign-icons-react';
import '../../../../hooks/useLayoutEffect.js';
import '../../../../_chunks/dep-4fb528b6.js';
import '../../../../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../../../../hooks/useConfig.js';
import '../../../../config-provider/ConfigContext.js';
import '../../../../locale/zh_CN.js';
import '../../../../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../../../../_chunks/dep-3c66615e.js';
import '../../../../hooks/useGlobalIcon.js';
import '../../../../input/InputGroup.js';
import '../../../../hooks/useControlled.js';
import '../../../../_util/noop.js';
import '../../../../locale/LocalReceiver.js';
import '../../../../config-provider/index.js';
import '../../../../config-provider/ConfigProvider.js';
import '../../../../config-provider/type.js';
import '../../../../input/defaultProps.js';
import '../../../../_util/parseTNode.js';
import '../../../../_chunks/dep-b146be0a.js';
import '../../../../_chunks/dep-ec9a9b6b.js';
import '../../../../input/useLengthLimit.js';
import '../../../../_chunks/dep-c1de0c2f.js';
import '../../../../hooks/useDefaultProps.js';
import '../../../../input/style/index.js';
import '../../../../input/type.js';
import '../../../../input-number/index.js';
import '../../../../input-number/InputNumber.js';
import '../../../../button/index.js';
import '../../../../button/Button.js';
import '../../../../hooks/useDomRefCallback.js';
import '../../../../hooks/useRipple.js';
import '../../../../_chunks/dep-8e2b9778.js';
import '../../../../hooks/useAnimation.js';
import '../../../../loading/index.js';
import '../../../../loading/Loading.js';
import '../../../../common/Portal.js';
import 'react-dom';
import '../../../../loading/gradient.js';
import '../../../../loading/defaultProps.js';
import '../../../../loading/plugin.js';
import '../../../../_util/react-render.js';
import '../../../../_chunks/dep-036ea6a5.js';
import '../../../../common/PluginContainer.js';
import '../../../../loading/style/index.js';
import '../../../../loading/type.js';
import '../../../../button/defaultProps.js';
import '../../../../button/style/index.js';
import '../../../../button/type.js';
import '../../../../input-number/useInputNumber.js';
import '../../../../_chunks/dep-632bb50f.js';
import '../../../../hooks/useCommonClassName.js';
import '../../../../input-number/defaultProps.js';
import '../../../../input-number/style/index.js';
import '../../../../input-number/type.js';
import '../../../../select/base/Select.js';
import '../../../../_util/helper.js';
import '../../../../select/util/helper.js';
import '../../../../select/base/OptionGroup.js';
import '../../../../select/defaultProps.js';
import '../../../../select/base/Option.js';
import '../../../../common/FakeArrow.js';
import '../../../../select-input/index.js';
import '../../../../select-input/SelectInput.js';
import '../../../../popup/index.js';
import '../../../../popup/Popup.js';
import 'react-transition-group';
import '../../../../popup/hooks/useTrigger.js';
import 'react-is';
import '../../../../_util/ref.js';
import '../../../../_util/isFragment.js';
import '../../../../_util/composeRefs.js';
import '../../../../_util/listener.js';
import '../../../../popup/utils/transition.js';
import '../../../../hooks/useMutationObserver.js';
import '../../../../hooks/useLatest.js';
import '../../../../hooks/useWindowSize.js';
import '../../../../popup/defaultProps.js';
import '../../../../hooks/useAttach.js';
import '../../../../hooks/usePopper.js';
import '@popperjs/core';
import 'react-fast-compare';
import '../../../../popup/PopupPlugin.js';
import '../../../../popup/style/index.js';
import '../../../../popup/type.js';
import '../../../../select-input/useSingle.js';
import '../../../../select-input/useMultiple.js';
import '../../../../tag-input/index.js';
import '../../../../tag-input/TagInput.js';
import '../../../../hooks/useDragSorter.js';
import '../../../../hooks/useEventCallback.js';
import '../../../../tag-input/useTagScroll.js';
import '../../../../tag-input/useTagList.js';
import '../../../../tag/index.js';
import '../../../../tag/Tag.js';
import '../../../../tag/defaultProps.js';
import '../../../../tag/CheckTag.js';
import '../../../../_chunks/dep-f1d23980.js';
import '../../../../tag/CheckTagGroup.js';
import '../../../../tag/style/index.js';
import '../../../../tag/type.js';
import '../../../../tag-input/useHover.js';
import '../../../../tag-input/defaultProps.js';
import '../../../../tag-input/style/index.js';
import '../../../../tag-input/type.js';
import '../../../../select-input/useOverlayInnerStyle.js';
import '../../../../select-input/defaultProps.js';
import '../../../../select-input/style/index.js';
import '../../../../select-input/type.js';
import '../../../../select/base/PopupContent.js';
import '../../../../select/hooks/usePanelVirtualScroll.js';
import '../../../../hooks/useVirtualScroll.js';
import '../../../../hooks/useResizeObserver.js';
import '../../../../select/hooks/useOptions.js';
import '../../../../select/style/index.js';
import '../../../../select/type.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var FormatPanel = function FormatPanel(props) {
  var enableAlpha = props.enableAlpha,
    baseClassName = props.baseClassName,
    format = props.format,
    selectInputProps = props.selectInputProps;
  var _useState = useState(format),
    _useState2 = _slicedToArray(_useState, 2),
    formatMode = _useState2[0],
    setFormatMode = _useState2[1];
  var handleModeChange = function handleModeChange(v) {
    setFormatMode(v);
  };
  return /* @__PURE__ */React.createElement("div", {
    className: "".concat(baseClassName, "__format")
  }, /* @__PURE__ */React.createElement("div", {
    className: "".concat(baseClassName, "__format--item")
  }, /* @__PURE__ */React.createElement(Select, {
    size: "small",
    className: "".concat(baseClassName, "__format-mode-select"),
    popupProps: _objectSpread({
      overlayClassName: "".concat(baseClassName, "__select-options")
    }, selectInputProps === null || selectInputProps === void 0 ? void 0 : selectInputProps.popupProps),
    autoWidth: true,
    value: formatMode,
    onChange: handleModeChange
  }, getColorFormatOptions(enableAlpha).map(function (item) {
    return /* @__PURE__ */React.createElement(Select.Option, {
      key: item,
      value: item,
      label: item,
      style: {
        fontSize: "12px"
      }
    });
  }))), /* @__PURE__ */React.createElement("div", {
    className: "".concat(baseClassName, "__format--item")
  }, /* @__PURE__ */React.createElement(FormatInputs, _objectSpread(_objectSpread({}, props), {}, {
    format: formatMode
  }))));
};
var FormatPanel$1 = /*#__PURE__*/React.memo(FormatPanel);

export { FormatPanel$1 as default };
//# sourceMappingURL=index.js.map
