/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../../../_chunks/dep-4501cb83.js';
import React from 'react';
import { d as COLOR_MODES } from '../../../_chunks/dep-11560925.js';
import { Radio } from '../../../radio/index.js';
import { useLocaleReceiver } from '../../../locale/LocalReceiver.js';
import '../../../_chunks/dep-34d8fc80.js';
import '../../../_chunks/dep-d3440587.js';
import '../../../_chunks/dep-f105ca38.js';
import '../../../_chunks/dep-bff1a51f.js';
import '../../../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../../../common/Check.js';
import '../../../_chunks/dep-5462fae6.js';
import 'classnames';
import 'lodash-es';
import '../../../_util/helper.js';
import '../../../hooks/useConfig.js';
import '../../../config-provider/ConfigContext.js';
import '../../../locale/zh_CN.js';
import '../../../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../../../_chunks/dep-3c66615e.js';
import '../../../hooks/useControlled.js';
import '../../../_util/noop.js';
import '../../../_chunks/dep-beace92f.js';
import '../../../hooks/useCommonClassName.js';
import '../../../radio/defaultProps.js';
import '../../../hooks/useDefaultProps.js';
import '../../../radio/useKeyboard.js';
import '../../../_chunks/dep-f1d23980.js';
import '../../../_util/listener.js';
import '../../../_chunks/dep-4fb528b6.js';
import '../../../radio/style/index.js';
import '../../../radio/type.js';
import '../../../config-provider/index.js';
import '../../../config-provider/ConfigProvider.js';
import '../../../config-provider/type.js';

var Header = function Header(props) {
  var _useLocaleReceiver = useLocaleReceiver("colorPicker"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var baseClassName = props.baseClassName,
    _props$mode = props.mode,
    mode = _props$mode === void 0 ? "monochrome" : _props$mode,
    colorModes = props.colorModes,
    onModeChange = props.onModeChange;
  var isSingleMode = (colorModes === null || colorModes === void 0 ? void 0 : colorModes.length) === 1;
  if (isSingleMode) {
    return null;
  }
  return /* @__PURE__ */React.createElement("div", {
    className: "".concat(baseClassName, "__head")
  }, /* @__PURE__ */React.createElement("div", {
    className: "".concat(baseClassName, "__mode")
  }, /* @__PURE__ */React.createElement(Radio.Group, {
    variant: "default-filled",
    size: "small",
    value: mode,
    onChange: onModeChange
  }, Object.keys(COLOR_MODES).map(function (key) {
    return /* @__PURE__ */React.createElement(Radio.Button, {
      key: key,
      value: key
    }, t(local[COLOR_MODES[key]]));
  }))));
};
var PanelHeader = /*#__PURE__*/React.memo(Header);

export { PanelHeader as default };
//# sourceMappingURL=header.js.map
