/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-f105ca38.js';
import { _ as _slicedToArray } from '../_chunks/dep-4501cb83.js';
import React, { useState, useRef, useEffect } from 'react';
import classNames from 'classnames';
import { throttle } from 'lodash-es';
import { ChevronRightIcon } from 'tdesign-icons-react';
import useConfig from '../hooks/useConfig.js';
import { Divider } from '../divider/index.js';
import DropdownItem from './DropdownItem.js';
import useGlobalIcon from '../hooks/useGlobalIcon.js';
import '../_chunks/dep-bff1a51f.js';
import '../_chunks/dep-34d8fc80.js';
import '../config-provider/ConfigContext.js';
import '../locale/zh_CN.js';
import '../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../_chunks/dep-3c66615e.js';
import '../divider/Divider.js';
import '../_chunks/dep-5462fae6.js';
import '../divider/defaultProps.js';
import '../hooks/useDefaultProps.js';
import '../divider/style/index.js';
import '../divider/type.js';
import '../hooks/useDomRefCallback.js';
import '../hooks/useRipple.js';
import '../_chunks/dep-8e2b9778.js';
import '../hooks/useAnimation.js';
import '../_chunks/dep-4fb528b6.js';
import './defaultProps.js';
import '../_util/helper.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DropdownMenu = function DropdownMenu(props) {
  var _props$options = props.options,
    options = _props$options === void 0 ? [] : _props$options,
    _props$maxHeight = props.maxHeight,
    maxHeight = _props$maxHeight === void 0 ? 300 : _props$maxHeight,
    _props$minColumnWidth = props.minColumnWidth,
    minColumnWidth = _props$minColumnWidth === void 0 ? 10 : _props$minColumnWidth,
    _props$maxColumnWidth = props.maxColumnWidth,
    maxColumnWidth = _props$maxColumnWidth === void 0 ? 160 : _props$maxColumnWidth,
    direction = props.direction,
    panelTopContent = props.panelTopContent,
    panelBottomContent = props.panelBottomContent;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var dropdownClass = "".concat(classPrefix, "-dropdown");
  var dropdownMenuClass = "".concat(dropdownClass, "__menu");
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    panelTopContentHeight = _useState2[0],
    setPanelTopContentHeight = _useState2[1];
  var _useGlobalIcon = useGlobalIcon({
      ChevronRightIcon: ChevronRightIcon
    }),
    ChevronRightIcon$1 = _useGlobalIcon.ChevronRightIcon;
  var menuRef = useRef(null);
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    isOverMaxHeight = _useState4[0],
    setIsOverMaxHeight = _useState4[1];
  var _useState5 = useState({}),
    _useState6 = _slicedToArray(_useState5, 2),
    calcScrollTopMap = _useState6[0],
    setScrollTopMap = _useState6[1];
  useEffect(function () {
    if (menuRef.current) {
      var _menuRef$current$chil;
      var menuHeight = ((_menuRef$current$chil = menuRef.current.childNodes) === null || _menuRef$current$chil === void 0 ? void 0 : _menuRef$current$chil.length) * 30;
      setTimeout(function () {
        if (panelTopContent) {
          var _getComputedStyle, _menuRef$current$chil2;
          var panelTopHeight = parseInt((_getComputedStyle = getComputedStyle((_menuRef$current$chil2 = menuRef.current.childNodes) === null || _menuRef$current$chil2 === void 0 ? void 0 : _menuRef$current$chil2[0])) === null || _getComputedStyle === void 0 ? void 0 : _getComputedStyle.height, 10) || 0;
          setPanelTopContentHeight(panelTopHeight);
        }
      });
      if (menuHeight >= maxHeight) setIsOverMaxHeight(true);
    }
  }, [maxHeight, panelTopContent]);
  var handleItemClick = function handleItemClick(options2) {
    var _data$onClick, _props$onClick;
    var data = options2.data,
      context = options2.context;
    data === null || data === void 0 || (_data$onClick = data.onClick) === null || _data$onClick === void 0 || _data$onClick.call(data, data, context);
    (_props$onClick = props.onClick) === null || _props$onClick === void 0 || _props$onClick.call(props, data, context);
  };
  var handleScroll = function handleScroll(e) {
    var deep = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var scrollTop = e.target.scrollTop;
    setScrollTopMap(_objectSpread(_objectSpread({}, calcScrollTopMap), {}, _defineProperty({}, deep, scrollTop)));
  };
  var throttleUpdate = throttle(handleScroll, 100);
  var _renderOptions = function renderOptions(data, deep) {
    var _data$forEach;
    var arr = [];
    var renderContent;
    (_data$forEach = data.forEach) === null || _data$forEach === void 0 || _data$forEach.call(data, function (menu, idx) {
      var optionItem = _objectSpread({}, menu);
      var onViewIdx = Math.ceil(calcScrollTopMap[deep] / 30);
      var isOverflow = idx >= onViewIdx;
      var shouldCalcPanelTopContent = panelTopContent && deep > 0;
      var itemIdx = isOverflow ? idx - onViewIdx : idx;
      if (optionItem.children) {
        optionItem.children = _renderOptions(optionItem.children, deep + 1);
        renderContent = /* @__PURE__ */React.createElement("div", {
          key: idx
        }, /* @__PURE__ */React.createElement(DropdownItem, {
          className: classNames(optionItem.className, "".concat(dropdownClass, "__item"), "".concat(dropdownClass, "__item--suffix")),
          style: optionItem.style,
          value: optionItem.value,
          theme: optionItem.theme,
          active: optionItem.active,
          prefixIcon: optionItem.prefixIcon,
          disabled: optionItem.disabled,
          minColumnWidth: minColumnWidth,
          maxColumnWidth: maxColumnWidth,
          isSubmenu: true
        }, /* @__PURE__ */React.createElement("div", {
          className: "".concat(dropdownClass, "__item-content")
        }, /* @__PURE__ */React.createElement("span", {
          className: "".concat(dropdownClass, "__item-text")
        }, optionItem.content), /* @__PURE__ */React.createElement(ChevronRightIcon$1, {
          className: "".concat(dropdownClass, "__item-direction"),
          size: "16"
        })), /* @__PURE__ */React.createElement("div", {
          className: classNames("".concat(dropdownClass, "__submenu-wrapper"), _defineProperty({}, "".concat(dropdownClass, "__submenu-wrapper--").concat(props.direction), props.direction)),
          style: {
            position: "absolute",
            top: "".concat(itemIdx * 30 + (shouldCalcPanelTopContent ? 0 : panelTopContentHeight), "px")
          }
        }, /* @__PURE__ */React.createElement("div", {
          className: classNames("".concat(dropdownClass, "__submenu"), _defineProperty({}, "".concat(dropdownClass, "__submenu--disabled"), optionItem.disabled)),
          style: {
            position: "static",
            maxHeight: "".concat(props.maxHeight, "px")
          },
          onScroll: function onScroll(e) {
            return handleScroll(e, deep + 1);
          }
        }, /* @__PURE__ */React.createElement("ul", null, optionItem.children)))), optionItem.divider ? /* @__PURE__ */React.createElement(Divider, null) : null);
      } else {
        renderContent = /* @__PURE__ */React.createElement("div", {
          key: idx
        }, /* @__PURE__ */React.createElement(DropdownItem, {
          className: classNames(optionItem.className, "".concat(dropdownClass, "__item")),
          style: optionItem.style,
          value: optionItem.value,
          theme: optionItem.theme,
          active: optionItem.active,
          prefixIcon: optionItem.prefixIcon,
          disabled: optionItem.disabled,
          minColumnWidth: minColumnWidth,
          maxColumnWidth: maxColumnWidth,
          onClick: optionItem.disabled || optionItem.children ? function () {
            return null;
          } : function (value, context) {
            return handleItemClick({
              data: optionItem,
              context: context
            });
          }
        }, /* @__PURE__ */React.createElement("span", {
          className: "".concat(dropdownClass, "__item-text")
        }, optionItem.content)), optionItem.divider ? /* @__PURE__ */React.createElement(Divider, null) : null);
      }
      arr.push(renderContent);
    });
    return arr;
  };
  return /* @__PURE__ */React.createElement("div", {
    className: classNames(dropdownMenuClass, "".concat(dropdownMenuClass, "--").concat(direction), _defineProperty({}, "".concat(dropdownMenuClass, "--overflow"), isOverMaxHeight)),
    style: {
      maxHeight: "".concat(maxHeight, "px")
    },
    ref: menuRef,
    onScroll: throttleUpdate
  }, panelTopContent ? /* @__PURE__ */React.createElement("div", {
    className: "".concat(dropdownClass, "__top-content")
  }, panelTopContent) : null, _renderOptions(options, 0), panelBottomContent ? /* @__PURE__ */React.createElement("div", {
    className: "".concat(dropdownClass, "__bottom-content")
  }, panelBottomContent) : null);
};
DropdownMenu.displayName = "DropdownMenu";

export { DropdownMenu as default };
//# sourceMappingURL=DropdownMenu.js.map
