/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { debounce } from 'lodash-es';
import { useCallback, useEffect } from 'react';
import { usePersistFn } from './usePersistFn.js';

var useDebounce = function useDebounce(func, delay, options) {
  var callback = usePersistFn(func);
  var debounced = useCallback(debounce(callback, delay, options), [callback, delay, options]);
  useEffect(function () {
    return debounced.cancel;
  }, [debounced]);
  return debounced;
};

export { useDebounce as default };
//# sourceMappingURL=useDebounce.js.map
