/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { ChevronDownIcon, ChevronLeftIcon, ChevronRightIcon, CloseIcon, DownloadIcon, MirrorIcon, RotationIcon, ZoomInIcon, ZoomOutIcon } from 'tdesign-icons-react';
import useGlobalIcon from '../../hooks/useGlobalIcon.js';
import '../../hooks/useConfig.js';
import 'react';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-f105ca38.js';
import '../../_chunks/dep-bff1a51f.js';
import 'lodash-es';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../../_chunks/dep-3c66615e.js';

var useIconMap = function useIconMap() {
  var Icons = useGlobalIcon({
    ChevronDownIcon: ChevronDownIcon,
    ChevronLeftIcon: ChevronLeftIcon,
    ChevronRightIcon: ChevronRightIcon,
    CloseIcon: CloseIcon,
    DownloadIcon: DownloadIcon,
    MirrorIcon: MirrorIcon,
    RotationIcon: RotationIcon,
    ZoomInIcon: ZoomInIcon,
    ZoomOutIcon: ZoomOutIcon
  });
  return {
    rotation: Icons.RotationIcon,
    "zoom-in": Icons.ZoomInIcon,
    mirror: Icons.MirrorIcon,
    "zoom-out": Icons.ZoomOutIcon,
    download: Icons.DownloadIcon,
    "chevron-left": Icons.ChevronLeftIcon,
    "chevron-right": Icons.ChevronRightIcon,
    "chevron-down": Icons.ChevronDownIcon,
    close: Icons.CloseIcon
  };
};

export { useIconMap as default };
//# sourceMappingURL=useIconMap.js.map
