import { MessageCloseAllMethod, MessageErrorMethod, MessageInfoMethod, MessageInstance, MessageLoadingMethod, MessageOptions, MessageQuestionMethod, MessageSuccessMethod, MessageWarningMethod, MessageThemeList, MessageConfigMethod } from './type';
import MessageComponent from './MessageComponent';
export interface MessagePlugin {
    (theme: MessageThemeList, message: string | MessageOptions, duration?: number): Promise<MessageInstance>;
    info: MessageInfoMethod;
    success: MessageSuccessMethod;
    warning: MessageWarningMethod;
    error: MessageErrorMethod;
    question: MessageQuestionMethod;
    loading: MessageLoadingMethod;
    closeAll: MessageCloseAllMethod;
    close: (message: Promise<MessageInstance>) => void;
    config: MessageConfigMethod;
}
export declare const MessagePlugin: MessagePlugin;
export default MessageComponent;
