/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../_chunks/dep-f105ca38.js';
import React from 'react';
import classNames from 'classnames';
import useConfig from '../../hooks/useConfig.js';
import { optionGroupDefaultProps } from '../defaultProps.js';
import useDefaultProps from '../../hooks/useDefaultProps.js';
import '../../_chunks/dep-bff1a51f.js';
import '../../config-provider/ConfigContext.js';
import 'lodash-es';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../../_chunks/dep-3c66615e.js';

var OptionGroup = function OptionGroup(props) {
  var _useDefaultProps = useDefaultProps(props, optionGroupDefaultProps),
    children = _useDefaultProps.children,
    label = _useDefaultProps.label,
    divider = _useDefaultProps.divider;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  return /* @__PURE__ */React.createElement("li", {
    className: classNames("".concat(classPrefix, "-select-option-group"), _defineProperty({}, "".concat(classPrefix, "-select-option-group__divider"), divider))
  }, (label !== null && label !== void 0 ? label : false) && /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-select-option-group__header")
  }, label), children);
  return;
};

export { OptionGroup as default };
//# sourceMappingURL=OptionGroup.js.map
