/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _typeof } from '../_chunks/dep-bff1a51f.js';
import { _ as _defineProperty } from '../_chunks/dep-f105ca38.js';
import { _ as _slicedToArray } from '../_chunks/dep-4501cb83.js';
import React, { useRef, useState } from 'react';
import { FilterIcon } from 'tdesign-icons-react';
import { isEmpty } from 'lodash-es';
import classNames from 'classnames';
import '../_chunks/dep-b146be0a.js';
import { Popup } from '../popup/index.js';
import { Checkbox } from '../checkbox/index.js';
import { Radio } from '../radio/index.js';
import { Input } from '../input/index.js';
import { Button } from '../button/index.js';
import { useLocaleReceiver } from '../locale/LocalReceiver.js';
import useGlobalIcon from '../hooks/useGlobalIcon.js';
import { parseContentTNode } from '../_util/parseTNode.js';
import { l as log } from '../_chunks/dep-ec9a9b6b.js';
import '../_chunks/dep-34d8fc80.js';
import '../popup/Popup.js';
import 'react-transition-group';
import '../hooks/useControlled.js';
import '../_util/noop.js';
import '../hooks/useAnimation.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../locale/zh_CN.js';
import '../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../_chunks/dep-3c66615e.js';
import '../common/Portal.js';
import 'react-dom';
import '../_chunks/dep-4fb528b6.js';
import '../hooks/useLayoutEffect.js';
import '../popup/hooks/useTrigger.js';
import 'react-is';
import '../_util/ref.js';
import '../_util/isFragment.js';
import '../_util/composeRefs.js';
import '../_util/listener.js';
import '../popup/utils/transition.js';
import '../hooks/useMutationObserver.js';
import '../hooks/useLatest.js';
import '../hooks/useWindowSize.js';
import '../popup/defaultProps.js';
import '../hooks/useDefaultProps.js';
import '../hooks/useAttach.js';
import '../hooks/usePopper.js';
import '../_chunks/dep-a5c7489a.js';
import '@popperjs/core';
import 'react-fast-compare';
import '../popup/PopupPlugin.js';
import '../_chunks/dep-036ea6a5.js';
import '../_util/react-render.js';
import '../common/PluginContainer.js';
import '../config-provider/index.js';
import '../config-provider/ConfigProvider.js';
import '../config-provider/type.js';
import '../popup/style/index.js';
import '../popup/type.js';
import '../_chunks/dep-ce5fd8e5.js';
import '../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../common/Check.js';
import '../_chunks/dep-5462fae6.js';
import '../_util/helper.js';
import '../checkbox/defaultProps.js';
import '../checkbox/style/index.js';
import '../checkbox/type.js';
import '../_chunks/dep-d3440587.js';
import '../_chunks/dep-beace92f.js';
import '../hooks/useCommonClassName.js';
import '../radio/defaultProps.js';
import '../radio/useKeyboard.js';
import '../_chunks/dep-f1d23980.js';
import '../radio/style/index.js';
import '../radio/type.js';
import '../input/Input.js';
import '../input/InputGroup.js';
import '../input/defaultProps.js';
import '../input/useLengthLimit.js';
import '../_chunks/dep-c1de0c2f.js';
import '../input/style/index.js';
import '../input/type.js';
import '../button/Button.js';
import '../hooks/useDomRefCallback.js';
import '../hooks/useRipple.js';
import '../_chunks/dep-8e2b9778.js';
import '../loading/index.js';
import '../loading/Loading.js';
import '../loading/gradient.js';
import '../loading/defaultProps.js';
import '../loading/plugin.js';
import '../loading/style/index.js';
import '../loading/type.js';
import '../button/defaultProps.js';
import '../button/style/index.js';
import '../button/type.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CheckboxGroup = Checkbox.Group;
var RadioGroup = Radio.Group;
function TableFilterController(props) {
  var tFilterValue = props.tFilterValue,
    innerFilterValue = props.innerFilterValue,
    tableFilterClasses = props.tableFilterClasses,
    isFocusClass = props.isFocusClass,
    column = props.column;
  var _useGlobalIcon = useGlobalIcon({
      FilterIcon: FilterIcon
    }),
    FilterIcon$1 = _useGlobalIcon.FilterIcon;
  var triggerElementRef = useRef(null);
  var _useLocaleReceiver = useLocaleReceiver("table"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    filterPopupVisible = _useState2[0],
    setFilterPopupVisible = _useState2[1];
  var onFilterPopupVisibleChange = function onFilterPopupVisibleChange(visible) {
    var _props$onVisibleChang;
    setFilterPopupVisible(visible);
    (_props$onVisibleChang = props.onVisibleChange) === null || _props$onVisibleChang === void 0 || _props$onVisibleChang.call(props, visible);
  };
  var getFilterContent = function getFilterContent(column2) {
    var _column2$filter, _column2$filter2, _column2$filter3, _column2$filter4, _column2$filter5;
    var types = ["single", "multiple", "input"];
    if (column2.type && !types.includes(column2.filter.type)) {
      log.error("Table", "TDesign Table Error: column.filter.type must be the following: ".concat(JSON.stringify(types)));
      return;
    }
    var Component = {
      single: RadioGroup,
      multiple: CheckboxGroup,
      input: Input
    }[column2.filter.type];
    if (!Component && !(column2 !== null && column2 !== void 0 && (_column2$filter = column2.filter) !== null && _column2$filter !== void 0 && _column2$filter.component)) return;
    var filterComponentProps = _objectSpread(_objectSpread({
      options: ["single", "multiple"].includes(column2.filter.type) ? (_column2$filter2 = column2.filter) === null || _column2$filter2 === void 0 ? void 0 : _column2$filter2.list : void 0
    }, ((_column2$filter3 = column2.filter) === null || _column2$filter3 === void 0 ? void 0 : _column2$filter3.props) || {}), {}, {
      onChange: function onChange(val) {
        var _props$onInnerFilterC;
        (_props$onInnerFilterC = props.onInnerFilterChange) === null || _props$onInnerFilterC === void 0 || _props$onInnerFilterC.call(props, val, column2);
      }
    });
    if (column2.colKey && innerFilterValue && column2.colKey in innerFilterValue) {
      filterComponentProps.value = innerFilterValue[column2.colKey];
    }
    if ((_column2$filter4 = column2.filter) !== null && _column2$filter4 !== void 0 && _column2$filter4.confirmEvents) {
      column2.filter.confirmEvents.forEach(function (event) {
        filterComponentProps[event] = function () {
          var _props$onConfirm;
          setFilterPopupVisible(false);
          (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 || _props$onConfirm.call(props, column2);
        };
      });
    }
    var FilterComponent = (column2 === null || column2 === void 0 || (_column2$filter5 = column2.filter) === null || _column2$filter5 === void 0 ? void 0 : _column2$filter5.component) || Component;
    var filter = column2.filter || {};
    return /* @__PURE__ */React.createElement("div", {
      className: tableFilterClasses.contentInner
    }, /* @__PURE__ */React.createElement(FilterComponent, _objectSpread(_objectSpread({
      className: filter.classNames,
      style: filter.style
    }, filter.attrs), filterComponentProps)));
  };
  var getBottomButtons = function getBottomButtons(column2) {
    if (!column2.filter.showConfirmAndReset) return;
    return /* @__PURE__ */React.createElement("div", {
      className: tableFilterClasses.bottomButtons
    }, /* @__PURE__ */React.createElement(Button, {
      theme: "default",
      size: "small",
      onClick: function onClick() {
        var _props$onReset;
        setFilterPopupVisible(false);
        (_props$onReset = props.onReset) === null || _props$onReset === void 0 || _props$onReset.call(props, column2);
      }
    }, locale.resetText), /* @__PURE__ */React.createElement(Button, {
      theme: "primary",
      size: "small",
      onClick: function onClick() {
        var _props$onConfirm2;
        setFilterPopupVisible(false);
        (_props$onConfirm2 = props.onConfirm) === null || _props$onConfirm2 === void 0 || _props$onConfirm2.call(props, column2);
      }
    }, locale.confirmText));
  };
  if (!column.filter || column.filter && !Object.keys(column.filter).length) return null;
  var defaultFilterIcon = t(locale.filterIcon) || /* @__PURE__ */React.createElement(FilterIcon$1, null);
  var filterValue = tFilterValue === null || tFilterValue === void 0 ? void 0 : tFilterValue[column.colKey];
  var isObjectTrue = _typeof(filterValue) === "object" && !isEmpty(filterValue);
  var isValueExist = ![null, void 0, ""].includes(filterValue) && _typeof(filterValue) !== "object";
  return /* @__PURE__ */React.createElement("div", {
    className: classNames([tableFilterClasses.icon, _defineProperty({}, isFocusClass, isObjectTrue || isValueExist)])
  }, /* @__PURE__ */React.createElement(Popup, _objectSpread({
    visible: filterPopupVisible,
    destroyOnClose: true,
    trigger: "click",
    placement: "bottom-right",
    showArrow: true,
    overlayClassName: tableFilterClasses.popup,
    onVisibleChange: function onVisibleChange(val) {
      return onFilterPopupVisibleChange(val);
    },
    content: /* @__PURE__ */React.createElement("div", {
      className: tableFilterClasses.popupContent
    }, getFilterContent(column), getBottomButtons(column))
  }, props.popupProps), /* @__PURE__ */React.createElement("div", {
    ref: triggerElementRef
  }, parseContentTNode(props.filterIcon, {
    col: column,
    colIndex: props.colIndex
  }) || defaultFilterIcon)));
}

export { TableFilterController as default };
//# sourceMappingURL=FilterController.js.map
