/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-f105ca38.js';
import React, { useRef } from 'react';
import classNames from 'classnames';
import { useTabClass } from './useTabClass.js';
import { tabPanelDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../_chunks/dep-bff1a51f.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import 'lodash-es';
import '../locale/zh_CN.js';
import '../_chunks/dep-e61f9018.js';
import 'dayjs';
import '../_chunks/dep-3c66615e.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TabPanel = function TabPanel(props) {
  var _useDefaultProps = useDefaultProps(props, tabPanelDefaultProps),
    className = _useDefaultProps.className,
    lazy = _useDefaultProps.lazy,
    isActive = _useDefaultProps.isActive,
    destroyOnHide = _useDefaultProps.destroyOnHide,
    style = _useDefaultProps.style;
  var _useTabClass = useTabClass(),
    tdTabPanelClassPrefix = _useTabClass.tdTabPanelClassPrefix;
  var lazyRenderRef = useRef(lazy);
  if (lazy && isActive && lazyRenderRef.current) {
    lazyRenderRef.current = false;
  }
  if (!isActive && destroyOnHide || lazyRenderRef.current) {
    return null;
  }
  return /* @__PURE__ */React.createElement("div", {
    className: classNames(tdTabPanelClassPrefix, className),
    style: _objectSpread(_objectSpread({}, style), {}, {
      display: !isActive ? "none" : void 0
    })
  }, props.children || props.panel);
};
TabPanel.displayName = "TabPanel";

export { TabPanel as default };
//# sourceMappingURL=TabPanel.js.map
