/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-f105ca38.js';
import React from 'react';
import { pick } from 'lodash-es';
import classNames from 'classnames';
import Panel from './components/Panel.js';
import { useCascaderContext } from './hooks.js';
import { cascaderDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../_chunks/dep-bff1a51f.js';
import '../_chunks/dep-4501cb83.js';
import '../_chunks/dep-34d8fc80.js';
import './components/Item.js';
import 'tdesign-icons-react';
import '../loading/index.js';
import '../loading/Loading.js';
import '../_chunks/dep-4fb528b6.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-ed3ed0e1.js';
import '../_chunks/dep-761c2704.js';
import 'dayjs';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-8e2b9778.js';
import '../_chunks/dep-7f6f136d.js';
import '../_chunks/dep-a5c7489a.js';
import '../hooks/useDomRefCallback.js';
import '../loading/defaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-395fc56d.js';
import '../common/PluginContainer.js';
import '../config-provider/ConfigProvider.js';
import '../checkbox/index.js';
import '../_chunks/dep-840feedc.js';
import '../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../common/Check.js';
import '../_chunks/dep-5462fae6.js';
import '../_util/helper.js';
import '../hooks/useControlled.js';
import '../_util/noop.js';
import '../checkbox/defaultProps.js';
import '../hooks/useGlobalIcon.js';
import '../hooks/useCommonClassName.js';
import './core/helper.js';
import './core/className.js';
import '../locale/LocalReceiver.js';
import './core/effect.js';
import '../_chunks/dep-4e36434d.js';
import '../_chunks/dep-b1a658e6.js';
import 'mitt';
import '../_chunks/dep-d1c15188.js';
import '../_chunks/dep-ec9a9b6b.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CascaderPanel = function CascaderPanel(originalProps) {
  var props = useDefaultProps(originalProps, cascaderDefaultProps);
  var _useCascaderContext = useCascaderContext(props),
    cascaderContext = _useCascaderContext.cascaderContext;
  return /* @__PURE__ */React.createElement(Panel, _objectSpread({
    className: classNames(props.className),
    style: props.style,
    cascaderContext: cascaderContext
  }, pick(props, ["trigger", "onChange", "empty"])));
};
CascaderPanel.displayName = "CascaderPanel";

export { CascaderPanel as default };
//# sourceMappingURL=CascaderPanel.js.map
