/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React, { forwardRef } from 'react';
import classNames from 'classnames';
import { Button } from '../button/index.js';
import useConfig from '../hooks/useConfig.js';
import { commentDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../button/Button.js';
import '../_chunks/dep-f105ca38.js';
import '../_chunks/dep-bff1a51f.js';
import '../_chunks/dep-4501cb83.js';
import '../_chunks/dep-34d8fc80.js';
import '../_chunks/dep-5462fae6.js';
import '../hooks/useDomRefCallback.js';
import '../hooks/useRipple.js';
import '../_chunks/dep-8e2b9778.js';
import '../hooks/useAnimation.js';
import '../config-provider/ConfigContext.js';
import 'lodash-es';
import '../_chunks/dep-ed3ed0e1.js';
import '../_chunks/dep-761c2704.js';
import 'dayjs';
import '../_chunks/dep-4fb528b6.js';
import '../loading/index.js';
import '../loading/Loading.js';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-7f6f136d.js';
import '../_chunks/dep-a5c7489a.js';
import '../loading/defaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-395fc56d.js';
import '../common/PluginContainer.js';
import '../config-provider/ConfigProvider.js';
import '../button/defaultProps.js';
import '../_util/parseTNode.js';
import '../_chunks/dep-ec9a9b6b.js';

var Comment = /*#__PURE__*/forwardRef(function (props, ref) {
  var _useDefaultProps = useDefaultProps(props, commentDefaultProps),
    actions = _useDefaultProps.actions,
    author = _useDefaultProps.author,
    avatar = _useDefaultProps.avatar,
    content = _useDefaultProps.content,
    datetime = _useDefaultProps.datetime,
    reply = _useDefaultProps.reply,
    quote = _useDefaultProps.quote,
    className = _useDefaultProps.className,
    style = _useDefaultProps.style;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var avatarElement = avatar ? /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__avatar")
  }, typeof avatar === "string" ? /* @__PURE__ */React.createElement("img", {
    src: avatar,
    alt: "",
    className: "".concat(classPrefix, "-comment__avatar-image")
  }) : avatar) : null;
  var authorDatetimeContent = (author || datetime) && /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__author")
  }, author && /* @__PURE__ */React.createElement("span", {
    className: "".concat(classPrefix, "-comment__name")
  }, author), datetime && /* @__PURE__ */React.createElement("span", {
    className: "".concat(classPrefix, "-comment__time")
  }, datetime));
  var quoteElement = quote ? /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__quote")
  }, quote) : null;
  var actionsElement = actions && actions.length ? /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__actions")
  }, actions.map(function (action, index) {
    return /* @__PURE__ */React.createElement(Button, {
      key: "action-".concat(index),
      size: "small",
      variant: "text"
    }, action);
  })) : null;
  var contentElement = /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__content")
  }, authorDatetimeContent, /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__detail")
  }, content), quoteElement, actionsElement);
  var replyElement = reply ? /* @__PURE__ */React.createElement("div", {
    className: classNames("".concat(classPrefix, "-comment__reply"))
  }, reply) : null;
  return /* @__PURE__ */React.createElement("div", {
    ref: ref,
    style: style,
    className: classNames("".concat(classPrefix, "-comment"), className)
  }, /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-comment__inner")
  }, avatarElement, contentElement), replyElement);
});
Comment.displayName = "Comment";

export { Comment as default };
//# sourceMappingURL=Comment.js.map
