/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../_chunks/dep-f105ca38.js';
import { _ as _slicedToArray } from '../../_chunks/dep-4501cb83.js';
import React from 'react';
import classNames from 'classnames';
import { useLocaleReceiver } from '../../locale/LocalReceiver.js';
import { Button } from '../../button/index.js';
import useConfig from '../../hooks/useConfig.js';
import '../../_chunks/dep-bff1a51f.js';
import '../../_chunks/dep-34d8fc80.js';
import '../../config-provider/ConfigProvider.js';
import 'lodash-es';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-ed3ed0e1.js';
import '../../_chunks/dep-761c2704.js';
import 'dayjs';
import '../../button/Button.js';
import '../../_chunks/dep-5462fae6.js';
import '../../hooks/useDomRefCallback.js';
import '../../hooks/useRipple.js';
import '../../_chunks/dep-8e2b9778.js';
import '../../hooks/useAnimation.js';
import '../../_chunks/dep-4fb528b6.js';
import '../../loading/index.js';
import '../../loading/Loading.js';
import '../../common/Portal.js';
import 'react-dom';
import '../../hooks/useLayoutEffect.js';
import '../../loading/gradient.js';
import '../../_chunks/dep-7f6f136d.js';
import '../../_chunks/dep-a5c7489a.js';
import '../../loading/defaultProps.js';
import '../../hooks/useDefaultProps.js';
import '../../loading/plugin.js';
import '../../_util/react-render.js';
import '../../_chunks/dep-395fc56d.js';
import '../../common/PluginContainer.js';
import '../../button/defaultProps.js';
import '../../_util/parseTNode.js';
import '../../_chunks/dep-ec9a9b6b.js';

var DatePickerFooter = function DatePickerFooter(props) {
  var _useLocaleReceiver = useLocaleReceiver("datePicker"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var confirmText = t(local.confirm);
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var enableTimePicker = props.enableTimePicker,
    onConfirmClick = props.onConfirmClick,
    _props$presetsPlaceme = props.presetsPlacement,
    presetsPlacement = _props$presetsPlaceme === void 0 ? "bottom" : _props$presetsPlaceme,
    presets = props.presets,
    onPresetClick = props.onPresetClick,
    selectedValue = props.selectedValue,
    needConfirm = props.needConfirm;
  var footerClass = classNames("".concat(classPrefix, "-date-picker__footer"), "".concat(classPrefix, "-date-picker__footer--").concat(presetsPlacement));
  return /* @__PURE__ */React.createElement("div", {
    className: footerClass
  }, /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-date-picker__presets")
  }, presets && Object.keys(presets).map(function (key) {
    return /* @__PURE__ */React.createElement(Button, {
      key: key,
      size: "small",
      variant: "text",
      onClick: function onClick(e) {
        return onPresetClick(presets[key], {
          e: e,
          preset: _defineProperty({}, key, presets[key])
        });
      }
    }, key);
  })), enableTimePicker && needConfirm && /* @__PURE__ */React.createElement(Button, {
    disabled: !selectedValue,
    size: "small",
    theme: "primary",
    onClick: function onClick(e) {
      return onConfirmClick({
        e: e
      });
    }
  }, confirmText));
};
DatePickerFooter.displayName = "DatePickerFooter";

export { DatePickerFooter as default };
//# sourceMappingURL=Footer.js.map
