/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../_chunks/dep-f105ca38.js';
import { _ as _slicedToArray } from '../../_chunks/dep-4501cb83.js';
import React, { useMemo } from 'react';
import classNames from 'classnames';
import dayjs from 'dayjs';
import { c as commonjsGlobal } from '../../_chunks/dep-761c2704.js';
import { p as parseToDayjs } from '../../_chunks/dep-42733ea7.js';
import { useLocaleReceiver } from '../../locale/LocalReceiver.js';
import useConfig from '../../hooks/useConfig.js';
import DatePickerCell from './Cell.js';
import '../../_chunks/dep-bff1a51f.js';
import '../../_chunks/dep-34d8fc80.js';
import 'lodash-es';
import '../../_chunks/dep-ec9a9b6b.js';
import '../../config-provider/ConfigProvider.js';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-ed3ed0e1.js';
import '../../_chunks/dep-c19fe9cd.js';
import '../../_chunks/dep-56ab53dd.js';

var isoWeek$1 = {exports: {}};

(function (module, exports) {
  !function (e, t) {
    module.exports = t() ;
  }(commonjsGlobal, function () {

    var e = "day";
    return function (t, i, s) {
      var a = function a(t) {
          return t.add(4 - t.isoWeekday(), e);
        },
        d = i.prototype;
      d.isoWeekYear = function () {
        return a(this).year();
      }, d.isoWeek = function (t) {
        if (!this.$utils().u(t)) return this.add(7 * (t - this.isoWeek()), e);
        var i,
          d,
          n,
          o,
          r = a(this),
          u = (i = this.isoWeekYear(), d = this.$u, n = (d ? s.utc : s)().year(i).startOf("year"), o = 4 - n.isoWeekday(), n.isoWeekday() > 4 && (o += 7), n.add(o, e));
        return r.diff(u, "week") + 1;
      }, d.isoWeekday = function (e) {
        return this.$utils().u(e) ? this.day() || 7 : this.day(this.day() % 7 ? e : e - 7);
      };
      var n = d.startOf;
      d.startOf = function (e, t) {
        var i = this.$utils(),
          s = !!i.u(t) || t;
        return "isoweek" === i.p(e) ? s ? this.date(this.date() - (this.isoWeekday() - 1)).startOf("day") : this.date(this.date() - 1 - (this.isoWeekday() - 1) + 7).endOf("day") : n.bind(this)(e, t);
      };
    };
  });
})(isoWeek$1);
var isoWeek = isoWeek$1.exports;

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
dayjs.extend(isoWeek);
var DatePickerTable = function DatePickerTable(props) {
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var value = props.value,
    format = props.format,
    mode = props.mode,
    data = props.data,
    time = props.time,
    onCellClick = props.onCellClick,
    onCellMouseEnter = props.onCellMouseEnter,
    onCellMouseLeave = props.onCellMouseLeave,
    firstDayOfWeek = props.firstDayOfWeek;
  var _useLocaleReceiver = useLocaleReceiver("datePicker"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var weekdays = t(local.weekdays);
  var weekAbbreviation = t(local.weekAbbreviation);
  var weekArr = [];
  var wi = firstDayOfWeek - 1;
  var len = weekdays.length;
  while (weekArr.length < len) {
    weekArr.push(weekdays[wi]);
    wi = (wi + len + 1) % len;
  }
  if (mode === "week") weekArr.unshift(weekAbbreviation);
  var showThead = mode === "date" || mode === "week";
  var valueYearWeek = useMemo(function () {
    if (mode !== "week" || !value) return {};
    if (Array.isArray(value)) {
      var _startObj$year, _startObj$locale, _startObj$locale$week, _endObj$year, _endObj$locale, _endObj$locale$week;
      if (!value.length) return {};
      var _value$map = value.map(function (v) {
          return v && parseToDayjs(v, format);
        }),
        _value$map2 = _slicedToArray(_value$map, 2),
        startObj = _value$map2[0],
        endObj = _value$map2[1];
      var startYear = startObj === null || startObj === void 0 || (_startObj$year = startObj.year) === null || _startObj$year === void 0 ? void 0 : _startObj$year.call(startObj);
      var startWeek = startObj === null || startObj === void 0 || (_startObj$locale = startObj.locale) === null || _startObj$locale === void 0 || (_startObj$locale = _startObj$locale.call(startObj, local.dayjsLocale)) === null || _startObj$locale === void 0 || (_startObj$locale$week = _startObj$locale.week) === null || _startObj$locale$week === void 0 ? void 0 : _startObj$locale$week.call(_startObj$locale);
      var endYear = endObj === null || endObj === void 0 || (_endObj$year = endObj.year) === null || _endObj$year === void 0 ? void 0 : _endObj$year.call(endObj);
      var endWeek = endObj === null || endObj === void 0 || (_endObj$locale = endObj.locale) === null || _endObj$locale === void 0 || (_endObj$locale = _endObj$locale.call(endObj, local.dayjsLocale)) === null || _endObj$locale === void 0 || (_endObj$locale$week = _endObj$locale.week) === null || _endObj$locale$week === void 0 ? void 0 : _endObj$locale$week.call(_endObj$locale);
      return {
        startYear: startYear,
        startWeek: startWeek,
        endYear: endYear,
        endWeek: endWeek
      };
    }
    var valueObj = parseToDayjs(value, format).locale(local.dayjsLocale);
    return {
      year: valueObj.year(),
      week: valueObj.week()
    };
  }, [mode, value, format]);
  var weekRowClass = function weekRowClass(value2, targetDayjs) {
    if (mode !== "week" || !value2) return {};
    if (Array.isArray(value2)) {
      if (!value2.length) return {};
      var targetYear = targetDayjs.isoWeekYear();
      var targetWeek = targetDayjs.isoWeek();
      var isActive = targetYear === valueYearWeek.startYear && targetWeek === valueYearWeek.startWeek || targetYear === valueYearWeek.endYear && targetWeek === valueYearWeek.endWeek;
      var isRange = (targetYear > valueYearWeek.startYear || targetYear === valueYearWeek.startYear && targetWeek > valueYearWeek.startWeek) && (targetYear < valueYearWeek.endYear || targetYear === valueYearWeek.endYear && targetWeek < valueYearWeek.endWeek);
      return _defineProperty(_defineProperty({}, "".concat(classPrefix, "-date-picker__table-").concat(mode, "-row--active"), isActive), "".concat(classPrefix, "-date-picker__table-").concat(mode, "-row--range"), isRange);
    }
    return _defineProperty({}, "".concat(classPrefix, "-date-picker__table-").concat(mode, "-row--active"), valueYearWeek.year === targetDayjs.year() && valueYearWeek.week === targetDayjs.week());
  };
  var multipleWeekRowClass = function multipleWeekRowClass(value2, targetDayjs) {
    if (mode !== "week" || Array.isArray(value2) && !value2.length) return {};
    var isSomeYearWeek = value2.map(function (v) {
      return parseToDayjs(v, format);
    }).some(function (item) {
      return item.isoWeek() === targetDayjs.isoWeek() && item.isoWeekYear() === targetDayjs.isoWeekYear();
    });
    return _defineProperty({}, "".concat(classPrefix, "-date-picker__table-").concat(mode, "-row--active"), isSomeYearWeek);
  };
  var activeRowCss = props.multiple ? multipleWeekRowClass : weekRowClass;
  return /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-date-picker__table"),
    onMouseLeave: function onMouseLeave(e) {
      return onCellMouseLeave === null || onCellMouseLeave === void 0 ? void 0 : onCellMouseLeave({
        e: e
      });
    }
  }, /* @__PURE__ */React.createElement("table", null, showThead && /* @__PURE__ */React.createElement("thead", null, /* @__PURE__ */React.createElement("tr", null, weekArr.map(function (value2, i) {
    return /* @__PURE__ */React.createElement("th", {
      key: i
    }, value2);
  }))), /* @__PURE__ */React.createElement("tbody", null, data.map(function (row, i) {
    return /* @__PURE__ */React.createElement("tr", {
      key: i,
      className: classNames("".concat(classPrefix, "-date-picker__table-").concat(mode, "-row"), _objectSpread({}, activeRowCss(value, row[0].dayjsObj)))
    }, row.map(function (col, j) {
      return /* @__PURE__ */React.createElement(DatePickerCell, _objectSpread(_objectSpread({}, col), {}, {
        key: j,
        time: time,
        onClick: onCellClick,
        onMouseEnter: onCellMouseEnter
      }));
    }));
  }))));
};
DatePickerTable.displayName = "DatePickerTable";

export { DatePickerTable as default };
//# sourceMappingURL=Table.js.map
