/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { isObject } from 'lodash-es';
import dayjs from 'dayjs';
import { j as isEnabledDate } from '../../_chunks/dep-c19fe9cd.js';
import '../../_chunks/dep-4501cb83.js';
import '../../_chunks/dep-34d8fc80.js';
import '../../_chunks/dep-f105ca38.js';
import '../../_chunks/dep-bff1a51f.js';
import '../../_chunks/dep-761c2704.js';
import '../../_chunks/dep-56ab53dd.js';
import '../../_chunks/dep-42733ea7.js';
import '../../_chunks/dep-ec9a9b6b.js';

function useDisableDate(props) {
  var _disableDate = props.disableDate,
    format = props.format,
    mode = props.mode,
    start = props.start,
    end = props.end;
  return {
    disableDate: function disableDate(value) {
      return !isEnabledDate({
        disableDate: _disableDate,
        format: format,
        mode: mode,
        value: value
      });
    },
    minDate: isObject(_disableDate) && "before" in _disableDate ? new Date(dayjs(_disableDate.before).startOf("day").format()) : start,
    maxDate: isObject(_disableDate) && "after" in _disableDate ? new Date(dayjs(_disableDate.after).endOf("day").format()) : end
  };
}

export { useDisableDate as default };
//# sourceMappingURL=useDisableDate.js.map
