import React from 'react';
import { StyledProps } from '../../common';
import type { TdDatePickerProps } from '../type';
import type { TdTimePickerProps } from '../../time-picker';
export interface SinglePanelProps extends TdDatePickerProps, StyledProps {
    year?: number;
    month?: number;
    time?: string;
    popupVisible?: boolean;
    onPanelClick?: (context: {
        e: React.MouseEvent<HTMLDivElement>;
    }) => void;
    onCellClick?: (date: Date, context: {
        e: React.MouseEvent<HTMLDivElement>;
    }) => void;
    onCellMouseEnter?: (date: Date) => void;
    onCellMouseLeave?: (context: {
        e: React.MouseEvent<HTMLDivElement>;
    }) => void;
    onJumperClick?: (context: {
        e?: MouseEvent;
        trigger: string;
    }) => void;
    onConfirmClick?: (context: {
        e: React.MouseEvent<HTMLButtonElement>;
    }) => void;
    onPresetClick?: any;
    onYearChange?: (year: number) => void;
    onMonthChange?: (month: number) => void;
    onTimePickerChange?: TdTimePickerProps['onChange'];
}
declare const SinglePanel: React.ForwardRefExoticComponent<SinglePanelProps & React.RefAttributes<HTMLDivElement>>;
export default SinglePanel;
