import React from 'react';
import { TdDescriptionsProps } from './type';
import { StyledProps } from '../common';
import type { DescriptionsItemProps } from './DescriptionsItem';
/**
 * 实现思路
 * 1. 基于 table tbody tr td 来实现布局
 * 2. 通过 span 计算总共有几行以及每一行的 item 个数，特别注意最后一行，要填充满
 * 3. 整体布局：左右布局（column 和 span 生效）/上下布局（column 和 span 失效，一行一个 item）
 * 4. item 布局：左右布局/上下布局
 */
/**
 * TDescriptions：承载 header（title） 和 body（table, tbody）
 * TDescriptionsRow：承载每一行（tr）
 * TDescriptionsItem：获取 item 数据（span, label, content）
 */
export type DescriptionsProps = TdDescriptionsProps & StyledProps & {
    children?: React.ReactNode;
};
declare const Descriptions: {
    (DescriptionsProps: DescriptionsProps): React.JSX.Element;
    displayName: string;
    DescriptionsItem: React.FC<DescriptionsItemProps>;
};
export default Descriptions;
