/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-f105ca38.js';
import { _ as _objectWithoutProperties } from '../_chunks/dep-5462fae6.js';
import classNames from 'classnames';
import React from 'react';
import useConfig from '../hooks/useConfig.js';
import parseTNode from '../_util/parseTNode.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import { linkDefaultProps } from './defaultProps.js';
import '../_chunks/dep-bff1a51f.js';
import '../config-provider/ConfigContext.js';
import 'lodash-es';
import '../_chunks/dep-ed3ed0e1.js';
import '../_chunks/dep-761c2704.js';
import 'dayjs';
import '../_chunks/dep-ec9a9b6b.js';

var _excluded = ["children", "content", "className", "underline", "prefixIcon", "suffixIcon", "theme", "disabled", "hover", "onClick", "href", "size"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Link = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useDefaultProps = useDefaultProps(props, linkDefaultProps),
    children = _useDefaultProps.children,
    content = _useDefaultProps.content,
    className = _useDefaultProps.className,
    underline = _useDefaultProps.underline,
    prefixIcon = _useDefaultProps.prefixIcon,
    suffixIcon = _useDefaultProps.suffixIcon,
    theme = _useDefaultProps.theme,
    disabled = _useDefaultProps.disabled,
    hover = _useDefaultProps.hover,
    onClick = _useDefaultProps.onClick,
    href = _useDefaultProps.href,
    size = _useDefaultProps.size,
    otherProps = _objectWithoutProperties(_useDefaultProps, _excluded);
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var childNode = content || children;
  var handleClick = function handleClick(e) {
    if (disabled) {
      return;
    }
    onClick === null || onClick === void 0 || onClick(e);
  };
  return /* @__PURE__ */React.createElement("a", _objectSpread(_objectSpread({}, otherProps), {}, {
    href: disabled || !href ? void 0 : href,
    ref: ref,
    className: classNames(className, ["".concat(classPrefix, "-link"), "".concat(classPrefix, "-link--theme-").concat(theme)], _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(classPrefix, "-size-s"), size === "small"), "".concat(classPrefix, "-size-l"), size === "large"), "".concat(classPrefix, "-is-disabled"), !!disabled), "".concat(classPrefix, "-is-underline"), !!underline), "".concat(classPrefix, "-link--hover-").concat(hover), !disabled)),
    onClick: handleClick
  }), prefixIcon && /* @__PURE__ */React.createElement("span", {
    className: classNames(["".concat(classPrefix, "-link__prefix-icon")])
  }, parseTNode(prefixIcon)), childNode, suffixIcon && /* @__PURE__ */React.createElement("span", {
    className: classNames(["".concat(classPrefix, "-link__suffix-icon")])
  }, parseTNode(suffixIcon)));
});
Link.displayName = "Link";

export { Link as default };
//# sourceMappingURL=Link.js.map
