import React from 'react';
import { TdListProps } from './type';
import { ComponentScrollToElementParams, StyledProps } from '../common';
export interface ListProps extends TdListProps, StyledProps {
    /**
     * 文本内容
     */
    children?: React.ReactNode;
}
export type ListRef = {
    scrollTo: (params: ComponentScrollToElementParams) => void;
};
/**
 * 列表组件
 */
declare const List: React.FunctionComponent<ListProps & React.RefAttributes<ListRef>> & {
    ListItem: React.ForwardRefExoticComponent<import("./ListItem").ListItemProps & React.RefAttributes<HTMLLIElement>>;
    ListItemMeta: React.ForwardRefExoticComponent<import("./ListItemMeta").ListItemMetaProps & React.RefAttributes<HTMLDivElement>>;
};
export default List;
