/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../../_chunks/dep-4501cb83.js';
import React from 'react';
import useConfig from '../../hooks/useConfig.js';
import { useLocaleReceiver } from '../../locale/LocalReceiver.js';
import '../../_chunks/dep-34d8fc80.js';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-f105ca38.js';
import '../../_chunks/dep-bff1a51f.js';
import 'lodash-es';
import '../../_chunks/dep-ed3ed0e1.js';
import '../../_chunks/dep-761c2704.js';
import 'dayjs';
import '../../config-provider/ConfigProvider.js';

function useTotal(props) {
  var _useLocaleReceiver = useLocaleReceiver("pagination"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var name = "".concat(classPrefix, "-pagination");
  var totalContent = props.totalContent,
    pageSize = props.pageSize,
    current = props.current,
    total = props.total;
  var totalControl = null;
  if (totalContent === false) return {
    totalControl: totalControl
  };
  var renderTotalContent = function renderTotalContent() {
    if (typeof totalContent === "boolean") {
      return totalContent ? t(locale.total, {
        total: total
      }) : null;
    }
    if (typeof totalContent === "function") {
      var start = (current - 1) * pageSize;
      var end = Math.min(total, start + pageSize);
      return totalContent(total, [start + 1, end]);
    }
    return totalContent;
  };
  totalControl = /* @__PURE__ */React.createElement("div", {
    className: "".concat(name, "__total")
  }, renderTotalContent());
  return {
    totalControl: totalControl
  };
}

export { useTotal as default };
//# sourceMappingURL=useTotal.js.map
