import { MutableRefObject, CSSProperties } from 'react';
import { TdSelectProps } from '../type';
import { SizeEnum } from '../../common';
interface PanelVirtualScroll {
    scroll?: TdSelectProps['scroll'];
    popupContentRef: MutableRefObject<HTMLDivElement>;
    options: TdSelectProps['options'];
    size: SizeEnum;
}
declare const usePanelVirtualScroll: ({ popupContentRef, scroll, options, size }: PanelVirtualScroll) => {
    scrollHeight: number;
    translateY: number;
    visibleData: any[];
    handleRowMounted: (rowData: any) => void;
    isVirtual: boolean;
    cursorStyle: CSSProperties;
    panelStyle: CSSProperties;
};
export default usePanelVirtualScroll;
