/**
 * tdesign v1.12.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../_chunks/dep-4501cb83.js';
import { _ as _defineProperty } from '../_chunks/dep-f105ca38.js';
import React, { useMemo } from 'react';
import classNames from 'classnames';
import { isFragment } from 'react-is';
import { d as getFlexGapPolyFill } from '../_chunks/dep-7f6f136d.js';
import useConfig from '../hooks/useConfig.js';
import { spaceDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../_chunks/dep-34d8fc80.js';
import '../_chunks/dep-bff1a51f.js';
import '../_chunks/dep-a5c7489a.js';
import 'lodash-es';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-ed3ed0e1.js';
import '../_chunks/dep-761c2704.js';
import 'dayjs';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var SizeMap = {
  small: "8px",
  medium: "16px",
  large: "24px"
};
var defaultNeedPolyfill = getFlexGapPolyFill();
var _toArray = function toArray(children) {
  var ret = [];
  React.Children.forEach(children, function (child) {
    if (child === void 0 || child === null) {
      return;
    }
    if (Array.isArray(child)) {
      ret = ret.concat(_toArray(child));
    } else if (isFragment(child) && child.props) {
      ret = ret.concat(_toArray(child.props.children));
    } else {
      ret.push(child);
    }
  });
  return ret;
};
var EMPTY_NODE = ["", false, null, void 0];
var Space = /*#__PURE__*/React.forwardRef(function (originalProps, ref) {
  var props = useDefaultProps(originalProps, spaceDefaultProps);
  var className = props.className,
    style = props.style,
    align = props.align,
    direction = props.direction,
    size = props.size,
    breakLine = props.breakLine,
    separator = props.separator,
    forceFlexGapPolyfill = props.forceFlexGapPolyfill;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var needPolyfill = Boolean(forceFlexGapPolyfill || defaultNeedPolyfill);
  var renderStyle = useMemo(function () {
    var renderGap = "";
    if (Array.isArray(size)) {
      renderGap = size.map(function (s) {
        if (typeof s === "number") {
          return "".concat(s, "px");
        }
        if (typeof s === "string") {
          return SizeMap[s] || s;
        }
        return s;
      }).join(" ");
    } else if (typeof size === "string") {
      renderGap = SizeMap[size] || size;
    } else if (typeof size === "number") {
      renderGap = "".concat(size, "px");
    }
    var tStyle = _objectSpread({}, style);
    if (needPolyfill) {
      var _renderGap$split = renderGap.split(" "),
        _renderGap$split2 = _slicedToArray(_renderGap$split, 2),
        columnGap = _renderGap$split2[0],
        rowGap = _renderGap$split2[1];
      tStyle["--td-space-column-gap"] = columnGap;
      tStyle["--td-space-row-gap"] = rowGap || columnGap;
    } else {
      tStyle.gap = renderGap;
    }
    return tStyle;
  }, [style, size, needPolyfill]);
  var childrenNode = React.useMemo(function () {
    var children = _toArray(props.children);
    var childCount = React.Children.count(children);
    return React.Children.map(children, function (child, index) {
      var showSeparator = index + 1 !== childCount && separator;
      return /* @__PURE__ */React.createElement(React.Fragment, null, EMPTY_NODE.includes(child) ? null : /* @__PURE__ */React.createElement("div", {
        className: "".concat(classPrefix, "-space-item")
      }, child), showSeparator && /* @__PURE__ */React.createElement("div", {
        className: "".concat(classPrefix, "-space-item-separator")
      }, separator));
    });
  }, [props.children, classPrefix, separator]);
  return /* @__PURE__ */React.createElement("div", {
    ref: ref,
    style: renderStyle,
    className: classNames("".concat(classPrefix, "-space"), className, _defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(classPrefix, "-space-align-").concat(align), align), "".concat(classPrefix, "-space-").concat(direction), direction), "".concat(classPrefix, "-space--break-line"), breakLine), "".concat(classPrefix, "-space--polyfill"), needPolyfill))
  }, childrenNode);
});
Space.displayName = "Space";

export { SizeMap, Space as default };
//# sourceMappingURL=Space.js.map
