import React from 'react';
import { TdTransferProps, TransferListType, TransferValue } from './type';
import { TNode, StyledProps } from '../common';
import { PaginationProps } from '../pagination';
interface TransferListProps extends Pick<TdTransferProps, 'data' | 'search' | 'checked' | 'transferItem' | 'tree'>, StyledProps {
    disabled?: boolean;
    empty?: TNode | string;
    title?: TNode;
    footer?: TNode;
    content?: TNode | TNode<{
        data: Object;
    }>;
    pagination?: Pick<PaginationProps, 'pageSize'> & {
        onPageChange?: (current: number) => void;
    };
    onCheckbox?: (checked: Array<TransferValue>) => void;
    onSearch?: (value: string) => void;
    showCheckAll?: boolean;
    listType: TransferListType;
}
declare const TransferList: React.FunctionComponent<TransferListProps>;
export default TransferList;
